Package: Rwave
Version: 2.6-5
Date: 2022-10-18
Title: Time-Frequency Analysis of 1-D Signals
Authors@R: c(person(given="Rene", family='Carmona', email='rcarmona@princeton.edu', role='aut'),
	   person(given="Bruno", family='Torresani', email='bruno.torresani@cmi.univ-mrs.fr', role='aut'),
	   person(given="Brandon", family='Whitcher', email='bjw34032@users.sourceforge.net', role='ctb'),
	   person(given="Andrea", family='Wang', role='ctb'),
	   person(given="Wen-Liang", family='Hwang', role='ctb'),
	   person(given="Robert", family="Alberts", role='ctb'),
	   person(given="Jonathan M.", family="Lees", role = c("ctb", "cre"), email = "jonathan.lees@unc.edu"))
Author: Rene Carmona [aut],
  Bruno Torresani [aut],
  Brandon Whitcher [ctb],
  Andrea Wang [ctb],
  Wen-Liang Hwang [ctb],
  Robert Alberts [ctb],
  Jonathan M. Lees [ctb, cre]
Maintainer: Jonathan M. Lees <jonathan.lees@unc.edu>
Depends: R (>= 2.14)
Description: A set of R functions which provide an
        environment for the Time-Frequency analysis of 1-D signals (and
        especially for the wavelet and Gabor transforms of noisy
        signals). It was originally written for Splus by Rene Carmona,
        Bruno Torresani, and Wen L. Hwang, first at the University of
        California at Irvine and then at Princeton University.  Credit
        should also be given to Andrea Wang whose functions on the
        dyadic wavelet transform are included. Rwave is based on the
        book: "Practical Time-Frequency Analysis: Gabor and Wavelet
        Transforms with an Implementation in S", by Rene Carmona, Wen
        L. Hwang and Bruno Torresani (1998, eBook ISBN:978008053942), Academic Press.
License: GPL (>= 2)
Copyright: University of California
URL: https://carmona.princeton.edu/TFbook/tfbook.html,
        https://r-forge.r-project.org/projects/rwave/
Packaged: 2022-10-20 16:53:19 UTC; lees
Repository: CRAN
Date/Publication: 2022-10-21 23:17:49 UTC
NeedsCompilation: yes
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 21:06:59 UTC; unix
Archs: Rwave.so.dSYM

# Export all names
exportPattern(".")
useDynLib(Rwave)
importFrom("grDevices", "dev.set")
importFrom("graphics", "abline", "image", "lines", "par", "title")
importFrom("stats", "as.ts", "fft", "lag", "lsfit", "plot.ts",
             "quantile", "rnorm", "spec.pgram", "var")

## Example 1.3 Dolphin click
## Read and plot the dolphin click data
data("click")
fclick <- fft(click)
par(mfrow=c(2,1))
plot.ts(click)
plot.ts(Mod(fclick))
## Subsampling the data:
k <- 1:1249
sclick <- click[2*k]
plot.ts(click)
plot.ts(sclick)
## Fourier transforms of the original and click data:
fsclick <- fft(sclick)
nfclick <- c(fclick[1250:2499], fclick[1:1249])
nfsclick <- c(fsclick[625:1249], fsclick[1:624])
plot.ts(Mod(nfclick), xaxt="n")
axis(1, at=c(0,500,1000,1500,2000,2500),
     labels=c("-1250","-750","-250","250","750","1250"))
plot.ts(Mod(nfsclick), xaxt="n")
axis(1, at=c(0,200,400,600,800,1000,1200),
     labels=c("-600","-400","-200","0","200","400","600"))
par(mfrow=c(1,1))

## Example 8.1 "Pure" Transient Analysis/Synthesis
## Compute the dyadic wavelet transform and the corresponding local
## extrema:
data("C0")
dwC0 <- mw(C0,5)
extC0 <- ext(dwC0)
## Reconstruction from the extrema:
recC0 <- mrecons(extC0)
## Example 8.2 "Noisy" Transient Analysis
data("C4")
dwC4 <- mw(C4,5)
extC4 <- ext(dwC4)
## Example 8.3 : "Noisy" Transient Detection/Synthesis
## Trim the extrema:
trC4 <- mntrim(extC4)
## Reconstruction from the trimmed extrema:
recC4 <- mrecons(trC4)
## Example 8.5 Simple Reconstruction of a Speech Signal
data("HOWAREYOU")
plot.ts(HOWAREYOU)
cgtHOW <- cgt(HOWAREYOU,70,0.01,60)
clHOW <- crc(Mod(cgtHOW),nbclimb=2000)
## Simple reconstruction:
srecHOW <- scrcrec(HOWAREYOU,cgtHOW,clHOW,ptile=0.0001,plot=2)

## Example 3.1 Gabor Functions
## Generate a Gabor function at given frequency (here 0.1 Hz), for a
## sampling frequency (here 1 Hz), location (here 256) and scale
## (here 25):
gab <- gabor(512, 256, .1, 25)
par(mfrow=c(1,2))
plot(Re(gab), type="l", ylab="")
title("Real part")
plot(Im(gab), type="l", ylab="")
title("Imaginary part")

## Example 3.2 Transients
## Compute Gabor transform of transient signal, here with n_f = 50,
## delta_f = 0.02 and two different values for the scale parameter,
## namely scale = 10, 18:
par(mfrow=c(4,1))
data(A0)
plot(A0, type="l", xaxs="i")
title("Transients")
cgtA0 <- cgt(A0, 50, .02, 10)
cgtA0 <- cgt(A0, 50, .02, 18)
## To display the phase of the Gabor transform
tmp <- cleanph(cgtA0, .1)
title("Phase of the Gabor transform")

## Example 3.3 Sine wave
## Generate the sequence, here a sine wave of frequency 1/32 Hz sampled
## with unit sampling frequency
x <- 1:512
sinewave <- sin(2*pi*x/32)
par(mfrow=c(3,1))
plot(sinewave, type="l")
title("Sine wave")
## Compute the Gabor transform with n_f = 50, delta_f = .005 and scale
## sigma = 25.  This corresponds to frequencies ranging from 0 to 0.125
## Hz.  Display the phase:
cgtsinewave <- cgt(sinewave, 50, .005, 25)
tmp <- cleanph(cgtsinewave, .01)
title("Gabor Transform Phase")

## Example 3.4 Chirp
## Generate the chirp and compute the Gabor transform between frequencies
## 0 and 0.125 Hz:
x <- 1:512
chirp <- sin(2*pi*(x + 0.002*(x-256)*(x-256))/16) 
par(mfrow=c(3,1))
plot(ts(chirp), xaxs="i", xlab="", ylab="")
title('Chirp signal')
## The result is displayed in Figure 3.5

mycgt <- function (input, nvoice, freqstep = (1/nvoice),
                   scale = 1, plot = TRUE) {
  oldinput <- input
  isize <- length(oldinput)
  tmp <- adjust.length(oldinput)
  input <- tmp$signal
  newsize <- length(input)
  pp <- nvoice
  Routput <- matrix(0, newsize, pp)
  Ioutput <- matrix(0, newsize, pp)
  output <- matrix(0, newsize, pp)
  dim(Routput) <- c(pp * newsize, 1)
  dim(Ioutput) <- c(pp * newsize, 1)
  dim(input) <- c(newsize, 1)
  z <- .C("Sgabor", as.double(input), Rtmp = as.double(Routput), 
          Itmp = as.double(Ioutput), as.integer(nvoice), as.double(freqstep), 
          as.integer(newsize), as.double(scale), PACKAGE="Rwave")
  Routput <- z$Rtmp
  Ioutput <- z$Itmp
  dim(Routput) <- c(newsize, pp)
  dim(Ioutput) <- c(newsize, pp)
  i <- sqrt(as.complex(-1))
  output <- Routput[1:isize, ] + Ioutput[1:isize, ] * i
  if (plot) {
    image(1:newsize, seq(0, nvoice*freqstep/2, length=nvoice),
          Mod(output), xlab = "Time", ylab = "Frequency")
    title("Gabor Transform Modulus")
  }
  output
}

cgtchirp <- mycgt(chirp, 50, .005, 25)
tmp <- cleanph(cgtchirp, .01)

#########################################################################
#      $Log: Cwt_Morlet.S,v $
#########################################################################
#
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################

cwt <- function(input, noctave, nvoice = 1, w0 = 2*pi, twoD = TRUE,
                plot = TRUE)
#########################################################################
#      cwt:
#      ---
#       continuous wavelet transform function
# 	compute the continuous wavelet transform with (complex-valued)
#			Morlet wavelet
#
#       Input:
#       ------
# 	 input: input signal (possibly complex-valued)
#	 noctave: number of powers of 2 for the scale variable
#	 nvoice: number of scales between 2 consecutive powers of 2
#        w0: central frequency of Morlet wavelet
#	 twoD: if set to TRUE, organizes the output as a 2D array 
#			(signal_size X nb_scales)
#		      if not: 3D array (signal_size X noctave X nvoice)
#	 plot: if set to TRUE, displays the modulus of cwt on the graphic
#		device.
#
#       Output:
#       -------
#        tmp: continuous (complex) wavelet transform
#
#########################################################################
{
  oldinput <- input
  isize <- length(oldinput)
  
  tmp <- adjust.length(oldinput)
  input <- tmp$signal
  newsize <- length(input)
  
  pp <- noctave * nvoice
  Routput <- matrix(0,newsize,pp)
  Ioutput <- matrix(0,newsize,pp)
  output <- matrix(0,newsize,pp)
  dim(Routput) <- c(pp * newsize,1)
  dim(Ioutput) <- c(pp * newsize,1)
  dim(input) <- c(newsize,1)
  
  z <- .C("Scwt_morlet",
          as.double(Re(input)),
          as.double(Im(input)),
          Rtmp = as.double(Routput),
          Itmp = as.double(Ioutput),
          as.integer(noctave),
          as.integer(nvoice),
          as.integer(newsize),
          as.double(w0),
          PACKAGE="Rwave")
  
  Routput <- z$Rtmp
  Ioutput <- z$Itmp
  dim(Routput) <- c(newsize,pp)
  dim(Ioutput) <- c(newsize,pp)
  if(twoD) {
    output <- Routput[1:isize,] + 1i*Ioutput[1:isize,]
    if(plot) {
      image(Mod(output), xlab="Time", ylab="log(scale)",
            main="Wavelet Transform Modulus")
    }
    output
  } 
  else {
    Rtmp <- array(0,c(isize,noctave,nvoice))
    Itmp <- array(0,c(isize,noctave,nvoice))
    for(i in 1:noctave)
      for(j in 1:nvoice) {
        Rtmp[,i,j] <- Routput[1:isize,(i-1)*nvoice+j]
        Itmp[,i,j] <- Ioutput[1:isize,(i-1)*nvoice+j]
      }
    Rtmp + 1i*Itmp
  }
}

cwtpolar <- function(cwt, threshold=0.0)
#########################################################################
#       cwtpolar:   
#       --------
# 	continuous wavelet transform conversion:
#        converts one of the possible outputs of cwt to modulus and phase
#
#       input:
#       ------
# 	 cwt: 3D array containing a continuous wavelet transform (output
#		of cwt, with twoD=FALSE)
#	 threshold: the phase is forced to -pi if the modulus is 
#		less than threshold.
#
#       output:
#       -------
#        output1: modulus
#        output2: phase      
#
#########################################################################
{
  tmp1 <- cwt
  sigsize <- dim(tmp1)[1] # sig size
  noctave <- dim(tmp1)[2]
  nvoice <- dim(tmp1)[3]
  
  output1 <- array(0,c(sigsize,noctave,nvoice))
  output2 <- array(0,c(sigsize,noctave,nvoice))
  for(i in 1:noctave)
    for(j in 1:nvoice) {
      output1[,i,j] <- sqrt(Re(tmp1[,i,j])^2 + Im(tmp1[,i,j])^2)
      output2[,i,j] <- atan2(Im(tmp1[,i,j]), Re(tmp1[,i,j]))
    }
  
  ma <- max(output1)
  rel <- threshold * ma
  dim(output1) <- c(sigsize * noctave * nvoice,1)
  dim(output2) <- c(sigsize * noctave * nvoice,1)
  output2[abs(output1) < rel] <- -3.14159
  dim(output1) <- c(sigsize,noctave,nvoice)
  dim(output2) <- c(sigsize,noctave,nvoice)
  
  list(modulus=output1,argument=output2)
}
 
cwtimage <- function(input)
#########################################################################
#       cwtimage:   
#       ---------
#        continuous wavelet transform display
# 	 converts the output (modulus or argument) of cwtpolar to a 
#		2D array and displays on the graphic device
#
#       input:
#       ------
# 	 input: 3D array containing a continuous wavelet transform (output
#		of cwtpolar
#       output:
#       -------
#        output: 2D array 
#
#########################################################################
{
  sigsize <- dim(input)[1]
  noctave <- dim(input)[2]
  nvoice <- dim(input)[3]
  
  output <- matrix(0,sigsize, noctave * nvoice)
  for(i in 1:noctave) {
    k <- (i-1) * nvoice
    for(j in 1:nvoice) {
      output[,k+j] <- input[,i,j]
    }
  }
  image(output)
  output
}
 
vwt <- function(input, scale, w0 = 2*pi)
#########################################################################
#      vwt:   voice Morlet wavelet transform   
#      ----
#       continuous wavelet transform on one scale
# 	compute the continuous wavelet transform with (complex-valued)
#			Morlet wavelet
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#        scale: value of the scale at which the transform is computed
#        w0: central frequency of Morlet wavelet
#
#       output:
#       -------
#        Routput + i Ioutput: voice wavelet transform (complex 1D array)
#
#########################################################################
{
  oldinput <- input
  isize <- length(oldinput)
  
  tmp <- adjust.length(oldinput)
  input <- tmp$signal
  newsize <- length(input)
  
  Routput <- numeric(newsize)
  Ioutput <- numeric(newsize)
  dim(input) <- c(newsize,1)
  
  z <- .C("Svwt_morlet",
          as.double(Re(input)),
          as.double(Im(input)),
          Rtmp = as.double(Routput),
          Itmp = as.double(Ioutput),
          as.double(scale),
          as.integer(newsize),
          as.double(w0),
          PACKAGE="Rwave")
  
  Routput <- z$Rtmp
  Ioutput <- z$Itmp
  Routput[1:isize] + 1i*Ioutput[1:isize]
}

morlet <- function(sigsize, location, scale, w0 = 2*pi)
#########################################################################
#       morlet: Morlet's wavelet  
#       -------
#        Generates a Morlet wavelet for given location and scale
#
#       input:
#       ------
#        sigsize: signal size (dimension of the array)
#        location: location of the wavelet
#        scale: value of the scale at which the transform is computed
#        w0: central frequency of Morlet wavelet
#
#       output:
#       -------
#        z$wavelet.r + z$wavelet.i * i: wavelet (complex 1D array
#          of size sigsize)
#
#########################################################################
{
  wavelet.r <- numeric(sigsize)
  wavelet.i <- numeric(sigsize)
  
  z <- .C("morlet_time",
          as.double(w0),
          as.double(scale),
          as.integer(location),
          wavelet.r = as.double(wavelet.r),
          wavelet.i = as.double(wavelet.i),
          as.integer(sigsize),
          PACKAGE="Rwave")
  
  z$wavelet.r + 1i*z$wavelet.i
}

vecmorlet <- function(sigsize, nbnodes, bridge, aridge, w0 = 2*pi)
#########################################################################
#       vecmorlet:   vector of Morlet's wavelets
#       ---------
#        Generates morlet wavelets located on the ridge
#
#       input:
#       ------
#        sigsize: signal size (dimension of the array)
#        nbnodes: number of ridge samples
#        bridge: b coordinates of the ridge samples
#        aridge: acoordinates of the ridge samples
#        w0: central frequency of Morlet wavelet
#
#       output:
#       -------
#        z$morlet.r + z$morlet.i * i: 2D array containing the morlet
#           wavelets located on the ridge
#
#########################################################################
{
  morlet.r <- numeric(nbnodes * sigsize)
  morlet.i <- numeric(nbnodes * sigsize)

  z <- .C("vmorlet_time",
          as.double(w0),
          as.double(aridge),
          as.integer(bridge),
          morlet.r = as.double(morlet.r),
          morlet.i = as.double(morlet.i),
          as.integer(sigsize),
          as.integer(nbnodes),
          PACKAGE="Rwave")
  
  z$morlet.r + 1i*z$morlet.i
}

#########################################################################
#      $Log: Pca_Climbers.S,v $
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################





hescrc <- function(tfrep, tfspec = numeric(dim(tfrep)[2]), grida = 10,
                   gridb = 20, bstep = 3, iteration = 10000, rate = .001,
                   seed = -7, nbclimb = 10, flag.int = TRUE, chain= TRUE,
                   flag.temp = FALSE, lineflag = FALSE)
#########################################################################
#  hescrc:   Time-frequency multiple ridge estimation (hessian climbers)
#  ------
# 	use the hessian climber algorithm to evaluate ridges of
#    	   continuous Time-Frequency transform
#
#      input:
#      ------
# 	tfrep: wavelet or Gabor transform
#	tfspec: additional potential (coming from learning the noise)
#       grida : window of a
#       gridb : window of b
#       pct : the percent number of points in window 2*grida and
#             2*gridb to select histogram
#       count : the maximal number of repetitive selection, if location
#               was chosen before
#       iteration: number of iterations
#       rate: initial value of the temperature
#       seed: initialization for random numbers generator
#       nbclimb: number of crazy climbers
#       bstep: step size for the climber walk in the time direction
#	flag.int: if set to TRUE, computes the integral on the ridge.
#	chain: if set to TRUE, chains the ridges.
#	flag.temp: if set to TRUE, keeps a constant temperature.
#       linfflag: if set to TRUE, the line segments oriented to the
#                 where the climber will move freely at the block is
#                 shown in image   	
#       
#      output:
#      -------
#       beemap: 2D array containing the (weighted or unweighted)
#               occupation measure (integrated with respect to time)
#       hesmap: 2D array containing number from 1 to 4, denoting the
#               direction a climber will go at some position; where
#               1 moving freely along b, 3 freely along a, 2 along 
#               line a = -b, and 4 along the line a = b. The restricted
#               move is perdendicular to the free move.
#
#########################################################################
{

   tfspectrum <- tfspec 

   d <- dim(tfrep)
   sigsize <- d[1]
   nscale <- d[2]

   sqmodulus <- Re(tfrep*Conj(tfrep))
   for (k in 1:nscale)
     sqmodulus[,k] <- sqmodulus[,k] - tfspectrum[k]
   image(sqmodulus)

   ## number of grid size
   nbx <- as.integer(sigsize/gridb)
   nby <- as.integer(nscale/grida)
   if((sigsize/gridb - nbx) > 0) nbx <- nbx + 1
   if((nscale/grida - nby) > 0) nby <- nby + 1

   nbblock <- nbx * nby

   ## first two locations at each block stores the lower-left corner
   ## of the block followed by the locations of up-right corner and by
   ## the negative values of hessian matrix from xx, xy, yx, and yy at
   ## the last.

   tst <- matrix(0, 8, nbblock)
   dim(tst) <- c(nbblock * 8,1)

   dim(sqmodulus) <- c(sigsize * nscale, 1)

   z <- .C("Shessianmap",
           as.double(sqmodulus),
           as.integer(sigsize),
           as.integer(nscale),
           ublock = as.integer(nbblock),
           as.integer(gridb),
           as.integer(grida),
           tst =as.double(tst),
           PACKAGE="Rwave")
  
   tst <- z$tst
   dim(tst) <- c(8, nbblock)

   ## actual number of block 	
   ublock <- z$ublock

   ## principle component analysis and calculate the direction of each block
   pcamap <- matrix(1,sigsize,nscale)

   ## first eigenvector of a block
   eigv1 <- matrix(0,ublock,2)

   ## to draw eigenvector in a block 
   if(lineflag) {	
     lng <- min(grida, gridb)
     oldLng <- lng
     linex <- numeric(oldLng)
     liney <- numeric(oldLng)
   }


   for(j in 1:ublock) {
        
	left <- max(1,as.integer(tst[1,j]))
	down <- max(1,as.integer(tst[2,j]))
	right <- min(as.integer(tst[3,j]),sigsize)
	up <- min(as.integer(tst[4,j]),nscale)

	ctst <- tst[5:8,j]
	dim(ctst) <- c(2,2)
        ctst <- t(ctst)
        eig<- eigen(ctst)

	
        ## cat("first eig = ",eig$values[1]," ratio in eigenvalues =
        ## ",abs(eig$values[1]/eig$values[2])," \n")

        ## eigen vector 1
        eigv1[j,] <- eig$vector[,1]


        ## shifted center position of a block
	if(lineflag) {
          centerx <- as.integer((left + right)/2)
          centery <- as.integer((down + up)/2)
	}

        ## theta of the eigen vector 1; -pi < theta <= pi

        theta <- atan2((eigv1[j,])[2],(eigv1[j,])[1])

        ## along x : denote 1 in the hesmap

        if(((theta <= pi/8) && (theta > -pi/8)) ||
	   (theta > 7*pi/8 || theta <= -7*pi/8)) {

	  pcamap[left:(right-1),down:(up-1)] <- 1

	  if(lineflag) {
             Lng <- min(lng,(sigsize-centerx))
             if(Lng != oldLng) {
               linex <- numeric(Lng)
               liney <- numeric(Lng)
             }
             llng <- as.integer(Lng/2)
	     x1 <- max(centerx-llng,1)
             x2 <- min(sigsize,x1 + Lng-1)
             linex[] <- x1:x2
             liney[] <- centery
            lines(linex,liney)
	}
	}

        ## along x=y : denoted as 4 in hesmap

        if(((theta > pi/8) && (theta <= 3*pi/8)) ||
	   ((theta > -7*pi/8) && (theta <= -5*pi/8))) {

	  pcamap[left:(right-1),down:(up-1)] <- 4

	  if(lineflag) {
            Lng <- min(lng,sigsize-centerx)
            Lng <- min(Lng,nscale-centery)
            if(Lng != oldLng) {
              linex <- numeric(Lng)
              liney <- numeric(Lng)
            }
            llng <- as.integer(Lng/2)
            x1 <- max(centerx-llng,1)
            x2 <- min(sigsize,x1 + Lng-1)
	    y1 <- max(centery-llng,1)
            y2 <- min(sigsize,y1 + Lng-1)

            linex[] <- x1:x2
            liney[] <- y1:y2
            lines(linex,liney)
           }
	}


        ## along y : as 3 in hesmap

        if(((theta > 3*pi/8) && (theta <= 5*pi/8)) ||
	   ((theta > -5*pi/8) && (theta <= -3*pi/8))) {

	  pcamap[left:(right-1),down:(up-1)] <- 3

	  if(lineflag) {
             Lng <- min(lng, nscale-centery)
             if(Lng != oldLng) {
               linex <- numeric(Lng)
               liney <- numeric(Lng)
             }
            llng <- as.integer(Lng/2)
	    y1 <- max(centery-llng,1)
            y2 <- min(sigsize,y1 + Lng-1)

            linex[] <- centerx
            liney[] <- y1:y2
            lines(linex,liney)
          }
	}


        ## along x=-y : as 2 in hesmap

        if(((theta > 5*pi/8) && (theta <= 7*pi/8)) ||
	   ((theta > -3*pi/8) && (theta <= -pi/8))) {

	  pcamap[left:(right-1),down:(up-1)] <- 2

	  if(lineflag) {
            Lng <- min(lng,nscale-centery)
            Lng <- min(Lng,sigsize-centerx)
            if(Lng != oldLng) {
               linex <- numeric(Lng)
               liney <- numeric(Lng)
            }
            llng <- as.integer(Lng/2)

	    x1 <- max(centerx-llng,1)
            x2 <- min(sigsize,x1 + Lng-1)
	    y1 <- max(centery-llng,1)
            y2 <- min(sigsize,y1 + Lng-1)

            linex[] <- x1:x2
            liney[] <- y2:y1
            lines(linex,liney)
          }
	}

	  if(lineflag) oldLng <- Lng
   }

   ##   if(lineflag==F) image(pcamap)	

   ## From the following on, it is similar to the process of crazy climbers...

   beemap <- matrix(0,sigsize,nscale) 
   dim(beemap) <- c(nscale * sigsize, 1)
   dim(pcamap) <- c(nscale * sigsize, 1)
     
   z <- .C("Spca_annealing",
           as.double(sqmodulus),
           beemap= as.double(beemap),
           as.integer(pcamap),
           as.double(rate),
           as.integer(sigsize),
           as.integer(nscale),
           as.integer(iteration),
           as.integer(seed),
           as.integer(bstep),
           as.integer(nbclimb),
           as.integer(flag.int),
           as.integer(chain),
           as.integer(flag.temp),
           PACKAGE="Rwave")

   beemap <- z$beemap
   dim(beemap) <- c(sigsize, nscale)
   dim(pcamap) <- c(sigsize, nscale)
   image(beemap)
   list(beemap = beemap, pcamap = pcamap)
}

#########################################################################
#      $Log: Snake_Annealing.S,v $
# Revision 1.2  1995/04/05  18:56:55  bruno
# *** empty log message ***
#
# Revision 1.1  1995/04/02  01:04:16  bruno
# Initial revision
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################



snake <- function(tfrep, guessA, guessB, snakesize = length(guessB),
                  tfspec = numeric(dim(modulus)[2]), subrate = 1,
                  temprate = 3, muA = 1, muB = muA, lambdaB = 2*muB,
                  lambdaA = 2*muA, iteration = 1000000, seed = -7,
                  costsub = 1, stagnant = 20000, plot = TRUE)
#########################################################################
#     snake:   
#     ------
#      ridge extraction using snakes and simulated annealing
#
#       input:
#       ------
# 	 tfrep: the wavelet or Gabor transform.
#	 guessA: initial guess for ridge function (frequency coordinate).
#	 guessB: initial guess for ridge function (time coordinate).
#        tfspec: estimate for the contribution of the noise to the
#               transform modulus (1D array)
#        subrate: subsampling rate for the transform modulus.
#	 temprate: constant (numerator) in the temperature schedule.
#	 muA, muB: coeff of phi' and rho' in cost function
#	 lambdaA,lambdaB: same thing for 2nd derivatives
#        iteration: maximal number of iterations
#        seed: initialization for random numbers generator
#        costsub: subsampling of the cost function in cost
#               costsub=1 means that the whole cost function
#               is returned
#        stagnant: maximum number of steps without move (for the
#                  stopping criterion)
#        plot :	 when set (by default), certain results will be
#	         displayed	
#
#       output:
#       ------
#        A: 1D array containing the frequency coordinate of the ridge
#        B: 1D array containing the time coordinate of the ridge
#        cost: 1D array containing the cost function
#
#########################################################################
{

  sigsize <- dim(tfrep)[1]
  nscale <- dim(tfrep)[2]
  costsize <- as.integer(iteration/costsub) + 1	
  cost <- 1:costsize
  modulus <- Mod(tfrep)	
  tfspectrum <- tfspec

  cost[] <- 0
  phi <- as.integer(guessA)
  rho <- as.integer(guessB)
  count <- 0	
  dim(phi) <- c(length(phi),1)	
  dim(rho) <- c(length(rho),1)	
  if(plot== TRUE)  image(modulus)
  dim(modulus) <- c(sigsize * nscale, 1)


  smodsize <- as.integer(sigsize/subrate)
  if((sigsize/subrate - as.integer(sigsize/subrate)) > 0)
    smodsize <- as.integer(sigsize/subrate) + 1

  smodulus <- matrix(0,smodsize,nscale)       
  dim(smodulus) <- c(smodsize * nscale, 1)

  z <- .C("Smodulus_smoothing",
        as.double(modulus),
        smodulus = as.double(smodulus),
	as.integer(sigsize),
        smodsize = as.integer(smodsize),            
        as.integer(nscale),
        as.integer(subrate),
           PACKAGE="Rwave")

  smodulus <- z$smodulus
  smodsize <- z$smodsize
  smodulus <- smodulus * smodulus
  dim(smodulus) <- c(smodsize, nscale)
  for (k in 1:nscale)
    smodulus[,k] <- smodulus[,k] - tfspectrum[k]
  dim(smodulus) <- c(smodsize * nscale, 1)


   z <- .C("Ssnake_annealing",
        cost = as.double(cost),
        as.double(smodulus),
        phi = as.double(phi),
        rho = as.double(rho),
        as.double(lambdaA),
	as.double(muA),
        as.double(lambdaB),
	as.double(muB),
        as.double(temprate),
	as.integer(sigsize),
	as.integer(snakesize),
        as.integer(nscale),
        as.integer(iteration),
	as.integer(stagnant),
	as.integer(seed),
	nb = as.integer(count),
        as.integer(subrate),
	as.integer(costsub),
        as.integer(smodsize),
           PACKAGE="Rwave")

  count <- z$nb
  cat("Number of moves:",count,"(",stagnant," still steps)\n")
  if(plot==TRUE) lines(z$rho+1, z$phi+1)
  list(A = z$phi+1, B = z$rho+1, cost = z$cost[1:count])

}
  


   
snakoid <- function(modulus, guessA, guessB, snakesize = length(guessB),
                    tfspec = numeric(dim(modulus)[2]), subrate = 1,
                    temprate = 3, muA = 1, muB = muA, lambdaB = 2*muB,
                    lambdaA = 2*muA, iteration = 1000000, seed = -7,
                    costsub = 1, stagnant = 20000, plot = TRUE)
#########################################################################
#     snakoid:   
#     ----------
#      ridge extraction using snakes and simulated annealing
#
#       input:
#       ------
# 	 modulus: modulus of the wavelet or Gabor transform.
#	 guessA: initial guess for ridge function (frequency coordinate).
#	 guessB: initial guess for ridge function (time coordinate).
#        tfspec: estimate for the contribution of the noise to the
#               transform modulus (1D array)
#        subrate: subsampling rate for the transform modulus.
#	 temprate: constant (numerator) in the temperature schedule.
#	 muA, muB: coeff of phi' and rho' in cost function
#	 lambdaA,lambdaB: same thing for 2nd derivatives
#        iteration: maximal number of iterations
#        seed: initialization for random numbers generator
#        costsub: subsampling of the cost function in cost
#               costsub=1 means that the whole cost function
#               is returned
#        stagnant: maximum number of steps without move (for the
#                  stopping criterion)
#        plot:	 when set(default), some results will be displayed	
#
#       output:
#       ------
#        A: 1D array containing the frequency coordinate of the ridge
#        B: 1D array containing the time coordinate of the ridge
#        cost: 1D array containing the cost function
#
#########################################################################
{

  sigsize <- dim(modulus)[1]
  nscale <- dim(modulus)[2]
  costsize <- as.integer(iteration/costsub) + 1	
  cost <- 1:costsize
  tfspectrum <- tfspec 

  cost[] <- 0
  phi <- guessA
  rho <- guessB
  count <- 0	
  dim(phi) <- c(length(phi),1)	
  dim(rho) <- c(length(rho),1)
  if(plot== TRUE)  image(modulus)	
  dim(modulus) <- c(sigsize * nscale, 1)


  smodsize <- as.integer(sigsize/subrate)
  if((sigsize/subrate - as.integer(sigsize/subrate)) > 0)
    smodsize <- as.integer(sigsize/subrate) + 1

  smodulus <- matrix(0,smodsize,nscale)       
  dim(smodulus) <- c(smodsize * nscale, 1)

  z <- .C("Smodulus_smoothing",
        as.double(modulus),
        smodulus = as.double(smodulus),
	as.integer(sigsize),
        smodsize = as.integer(smodsize),            
        as.integer(nscale),
        as.double(subrate),
           PACKAGE="Rwave")

  smodulus <- z$smodulus
  smodsize <- z$smodsize
  smodulus <- smodulus * smodulus
  dim(smodulus) <- c(smodsize, nscale)
  for (k in 1:nscale)
    smodulus[,k] <- smodulus[,k] - tfspectrum[k]
  dim(smodulus) <- c(smodsize * nscale, 1)


   z <- .C("Ssnakenoid_annealing",
        cost = as.double(cost),
        as.double(smodulus),
        phi = as.double(phi),
        rho = as.double(rho),
        as.double(lambdaA),
	as.double(muA),
        as.double(lambdaB),
	as.double(muB),
        as.double(temprate),
	as.integer(sigsize),
	as.integer(snakesize),
        as.integer(nscale),
        as.integer(iteration),
	as.integer(stagnant),
	as.integer(seed),
	nb = as.integer(count),
        as.integer(subrate),
	as.integer(costsub),
        as.integer(smodsize),
           PACKAGE="Rwave")

  count <- z$nb
  cat("Number of moves:",count,"(",stagnant," still steps)\n")
  if(plot== TRUE)  lines(z$rho+1, z$phi+1) 
  list(A = z$phi+1, B = z$rho+1, cost = z$cost[1:count])

}
  


snakeview <- function(modulus,snake)
#########################################################################
#      snakeview:
#      ----------
#       Restrict time-frequency transform to a snake
#
#       input:
#       ------
#	 modulus: modulus of the wavelet (or Gabor) transform
#        snake: B and A components of a snake
#
#       output:
#       -------
#        img: 2D array containing the restriction of the transform
#             modulus to the snake
#
#########################################################################
{
   A <- snake$A
   B <- snake$B
   snakesize <- length(A)
   sigsize <- dim(modulus)[1]
   nscale <- dim(modulus)[2]

   img <- matrix(0,sigsize,nscale)
   for(i in 1:snakesize)
     img[B[i],A[i]] <- modulus[B[i],A[i]]

   img
}

     

#########################################################################
#       $Log: Cwt_Thierry.S,v $
#########################################################################
#
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################





cwtTh <- function(input, noctave, nvoice = 1, moments,
	twoD = TRUE, plot = TRUE)
#########################################################################
#       cwtTh:   Cauchy's wavelet transform
#       -----
# 	 continuous wavelet transform function:
#         compute the continuous wavelet transform with (complex-valued)
#	  Cauchy's wavelet
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#	 noctave: number of powers of 2 for the scale variable
#	 nvoice: number of scales between 2 consecutive powers of 2
#        moments: number of vanishing moments for the wavelet
#	 twoD: if set to TRUE, organizes the output as a 2D array 
#			(signal_size X nb_scales)
#		      if not: 3D array (signal_size X noctave X nvoice)
#	 plot: if set to TRUE, displays the modulus of cwt on the graphic
#		device.
#
#       output:
#       -------
#        tmp: continuous (complex) wavelet transform
#
#########################################################################
{
   oldinput <- input
   isize <- length(oldinput)

   tmp <- adjust.length(oldinput)
   input <- tmp$signal
   newsize <- length(input)

   pp <- noctave * nvoice
   Routput <- matrix(0,newsize,pp)
   Ioutput <- matrix(0,newsize,pp)
   output <- matrix(0,newsize,pp)
   dim(Routput) <- c(pp * newsize,1)
   dim(Ioutput) <- c(pp * newsize,1)
   dim(input) <- c(newsize,1)

   z <- .C("Scwt_thierry",
           as.double(Re(input)),
           as.double(Im(input)),
           Rtmp = as.double(Routput),
           Itmp = as.double(Ioutput),
           as.integer(noctave),
           as.integer(nvoice),
           as.integer(newsize),
           as.integer(moments),
           PACKAGE="Rwave")

   Routput <- z$Rtmp
   Ioutput <- z$Itmp
   dim(Routput) <- c(newsize,pp)
   dim(Ioutput) <- c(newsize,pp)
   if(twoD) {
     output <- Routput[1:isize,] + 1i*Ioutput[1:isize,]
     if(plot) { 
       image(Mod(output),xlab="Time",ylab="log(scale)")
       title("Wavelet Transform Modulus")
     }
     output
   } 
   else {
     Rtmp <- array(0,c(isize,noctave,nvoice))
     Itmp <- array(0,c(isize,noctave,nvoice))
     for(i in 1:noctave)
       for(j in 1:nvoice) {
         Rtmp[,i,j] <- Routput[1:isize,(i-1)*nvoice+j]
         Itmp[,i,j] <- Ioutput[1:isize,(i-1)*nvoice+j]
      }
     Rtmp + 1i*Itmp
   }
}



vwtTh <- function(input, scale, moments)
#########################################################################
#       vwtTh:   
#       -----
#        continuous wavelet transform on one scale:
# 	 compute the continuous wavelet transform with (complex-valued)
#	  Cauchy's wavelet
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#        scale: value of the scale at which the transform is computed
#        moments: number of vanishing moments
#
#       output:
#       -------
#        Routput + i Ioutput: voice wavelet transform (complex 1D array)
#
#########################################################################
{
   oldinput <- input
   isize <- length(oldinput)

   tmp <- adjust.length(oldinput)
   input <- tmp$signal
   newsize <- length(input)

   Routput <- numeric(newsize)
   Ioutput <- numeric(newsize)
   dim(input) <- c(newsize,1)

   z <- .C("Svwt_Thierry",
           as.double(Re(input)),
           as.double(Im(input)),
           Rtmp = as.double(Routput),
           Itmp = as.double(Ioutput),
           as.double(scale),
           as.integer(newsize),
           as.integer(moments),
           PACKAGE="Rwave")

   Routput <- z$Rtmp
   Ioutput <- z$Itmp
   Routput[1:isize] + 1i*Ioutput[1:isize]
}

#########################################################################
#      $Log: Cwt_phase.S,v $
#########################################################################
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################





cwtp <- function(input, noctave, nvoice = 1, w0 = 2*pi,
	twoD = TRUE, plot = TRUE)
#########################################################################
#       cwtp:   
#       ----
#        continuous wavelet transform function:
# 	  compute the continuous wavelet transform with Morlet wavelet,
#    	  and its phase derivative (minus the wavelet frequency)
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#	 noctave: number of powers of 2 for the scale variable
#	 nvoice: number of scales between 2 consecutive powers of 2
#        w0: central frequency of Morlet wavelet
#	 twoD: if set to TRUE, organizes the output as a 2D array 
#			(signal_size X nb_scales)
#		      if not: 3D array (signal_size X noctave X nvoice)
#	 plot: if set to TRUE, displays the modulus of cwt on the graphic
#		device.
#
#       output:
#       -------
#        wt: continuous (complex) wavelet transform
#        f: derivative of wavelet transform phase
#
#########################################################################
{
   oldinput <- input
   isize <- length(oldinput)

   tmp <- adjust.length(oldinput)
   input <- tmp$signal
   newsize <- length(input)

   pp <- noctave * nvoice
   Routput <- matrix(0,newsize,pp)
   Ioutput <- matrix(0,newsize,pp)
   Foutput <- matrix(0,newsize,pp)
   output <- matrix(0,newsize,pp)
   dim(Routput) <- c(pp * newsize,1)
   dim(Ioutput) <- c(pp * newsize,1)
   dim(Foutput) <- c(pp * newsize,1)
   dim(input) <- c(newsize,1)

   ## dyn.load("/usr/people/bruno/Swave/wave.a")
   ## dyn.load("/usr/people/whwang/Swave/wave.a")

   z <- .C("Scwt_phase",
           as.double(input),
           Rtmp = as.double(Routput),
           Itmp = as.double(Ioutput),
           Ftmp = as.double(Foutput),
           as.integer(noctave),
           as.integer(nvoice),
           as.integer(newsize),
           as.double(w0),
           PACKAGE="Rwave")

   Routput <- z$Rtmp
   Ioutput <- z$Itmp
   Foutput <- z$Ftmp
   dim(Routput) <- c(newsize,pp)
   dim(Foutput) <- c(newsize,pp)
   dim(Ioutput) <- c(newsize,pp)

   if(twoD) {
     Ftmp <- Foutput[1:isize,]
     output <- Routput[1:isize,] + 1i*Ioutput[1:isize,]
     if(plot) image(Mod(output))
     list(wt=output,f=Ftmp)
   } 
   else {
     Rtmp <- array(0,c(isize,noctave,nvoice))
     Itmp <- array(0,c(isize,noctave,nvoice))
     Ftmp <- array(0,c(isize,noctave,nvoice))
     for(i in 1:noctave)
       for(j in 1:nvoice) {
         Rtmp[,i,j] <- Routput[1:isize,(i-1)*nvoice+j]
         Itmp[,i,j] <- Ioutput[1:isize,(i-1)*nvoice+j]
         Ftmp[,i,j] <- Foutput[1:isize,(i-1)*nvoice+j]
         }       
     list(wt=Rtmp+1i*Itmp, f=Ftmp)
   }
}

#########################################################################
#
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################

#*********************************************************************#
# mnpval
#*********************************************************************#

mnpval <- function(inputdata, maxresoln, wl=128, scale=FALSE)
{
  x <- adjust.length(inputdata)
  s <- x$signal
  np <- x$length
  num.of.windows <- (np/wl - 1) * 4 + 1

  pval <- matrix(0, nrow=maxresoln, ncol=np)
  pval <- t(pval)
  dim(pval) <- c(length(pval), 1)

  z <- .C("normal_pval_compute",
          a=as.double(pval),
          as.double(s),
          as.integer(maxresoln),
          as.integer(np),
          as.integer(num.of.windows),
          as.integer(wl),
           PACKAGE="Rwave")

  pval <- t(z$a)
  dim(pval) <- c(np, maxresoln)

  plotResult(pval, s, maxresoln, scale)
  list( original=s, pval=pval, maxresoln=maxresoln, np=np )
}

#*********************************************************************#
# mbpval
#*********************************************************************#

mbpval <- function(inputdata, maxresoln, wl=128, scale=FALSE)
{
  x <- adjust.length(inputdata)
  s <- x$signal
  np <- x$length
  num.of.windows <- (np/wl - 1) * 4 + 1

  pval <- matrix(0, nrow=maxresoln, ncol=np)
  pval <- t(pval)
  dim(pval) <- c(length(pval), 1)

  z <- .C("compute_mallat_bootstrap_pval",
	a=as.double(pval),
	as.double(s),
	as.integer(maxresoln),
	as.integer(np),
	as.integer(num.of.windows),
	as.integer(wl),
           PACKAGE="Rwave")

  pval <- t(z$a)
  dim(pval) <- c(np, maxresoln)

  plotResult(pval, s, maxresoln, scale)
  list( original=s, pval=pval, maxresoln=maxresoln, np=np )
}

#*********************************************************************#
# mntrim
#*********************************************************************#

mntrim <- function(extrema, scale=FALSE, prct=.95)
{
  s <- extrema$original
  maxresoln <- extrema$maxresoln
  np <- extrema$np
  sample.size <- 128
  nthresh <- 1:maxresoln

  # Find the threshold for each resoln

  z <- .C("nthresh_compute",
	a=as.double(nthresh),
	as.double(s),
	as.integer(maxresoln),
	as.integer(sample.size),
	as.double(prct),
           PACKAGE="Rwave")

  nthresh <- z$a

  trim <- matrix(0, nrow=np, ncol=maxresoln)

  for (j in 1:maxresoln)
  {
    # Keep the extrema if the absolute value of the extrema >= threshold
    temp <- (abs(extrema$extrema[,j]) >= nthresh[j])
    trim[,j] <- temp * extrema$extrema[,j]
  }

  cat("number of extrema left =", sum(trim!=0), "\n")

  plotResult(trim, s, maxresoln, scale)
  list( original=s, extrema=trim, Sf=extrema$Sf, maxresoln=maxresoln, np=np )
}

#*********************************************************************#
# mbtrim
#*********************************************************************#

mbtrim <- function(extrema, scale=FALSE, prct=.95)
{
  s <- extrema$original
  maxresoln <- extrema$maxresoln
  np <- extrema$np
  sample.size <- 128
  bthresh <- 1:maxresoln

  # Find the threshold for each resoln

  z <- .C("bthresh_compute",
	a=as.double(bthresh),
	as.double(s),
	as.integer(maxresoln),
	as.integer(sample.size),
	as.double(prct),
           PACKAGE="Rwave")

  bthresh <- z$a

  trim <- matrix(0, nrow=np, ncol=maxresoln)
  for (j in 1:maxresoln)
  {
    # Keep the extrema if the absolute value of the extrema >= threshold
    temp <- (abs(extrema$extrema[,j]) >= bthresh[j])
    trim[,j] <- temp * extrema$extrema[,j]
  }

  cat("number of extrema left =", sum(trim!=0), "\n")

  plotResult(trim, s, maxresoln, scale)
  list( original=s, extrema=trim, Sf=extrema$Sf, maxresoln=maxresoln, np=np )
}

#########################################################################
#      $Log: Ridge_Annealing.S,v $
#########################################################################
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  University of California, Irvine             
#                  All right reserved                           
#########################################################################





corona <- function(tfrep, guess, tfspec = numeric(dim(tfrep)[2]),
                   subrate = 1, temprate = 3, mu = 1, lambda = 2*mu,
                   iteration = 1000000, seed = -7, stagnant = 20000,
                   costsub = 1, plot = TRUE)
#########################################################################
#       corona:
#       -------
#        ridge extraction using simulated annealing
# 	  compute the continuous wavelet transform ridge from the cwt
#	   modulus, using simulated annealing
#
#       Input:
#       ------
# 	 tfrep: wavelet or Gabor transform.
#	 guess: initial guess for ridge function (1D array).
#        tfspec: estimate for the contribution of the noise to the
#               transform modulus (1D array)
#        subrate: subsampling rate for the transform modulus.
#	 temprate: constant (numerator) in the temperature schedule.
#        lambda: coefficient in front of phi' in the cost function
#        mu: coefficient in front of phi'' in the cost function
#        iteration: maximal number of iterations
#        seed: initialization for random numbers generator
#        stagnant: maximum number of steps without move (for the
#                  stopping criterion)
#        costsub: subsampling of the cost function in cost
#               costsub = 1 means that the whole cost function
#               is returned
#        plot:	 when set(default), some results will be shown on 
#	        the display	
#
#       Output:
#       -------
#        ridge: 1D array (of length sigsize) containing the ridge
#        cost: 1D array containing the cost function
#
#########################################################################
{

  sigsize <- dim(tfrep)[1]
  nscale <- dim(tfrep)[2]
  blocksize <- 1	
  costsize <- as.integer(iteration/blocksize) + 1	
  cost <- 1:costsize

  modulus <- Mod(tfrep)
  tfspectrum <- tfspec

  cost[] <- 0
  phi <- as.integer(guess)
  count <- 0	
  dim(phi) <- c(sigsize,1)	
  dim(modulus) <- c(sigsize * nscale, 1)
   
  smodsize <- as.integer(sigsize/subrate)

  if((sigsize/subrate - as.integer(sigsize/subrate)) > 0)
    smodsize <- as.integer(sigsize/subrate) + 1

  smodulus <- matrix(0,smodsize,nscale)
  dim(smodulus) <- c(smodsize * nscale, 1)


  z <- .C("Smodulus_smoothing",
          as.double(modulus),
          smodulus = as.double(smodulus),
          as.integer(sigsize),
          smodsize = as.integer(smodsize),            
          as.integer(nscale),
          as.integer(subrate),
           PACKAGE="Rwave")

  smodulus <- z$smodulus
  smodsize <- z$smodsize
  smodulus <- smodulus * smodulus
  dim(smodulus) <- c(smodsize, nscale)
  for (k in 1:nscale)
    smodulus[,k] <- smodulus[,k] - tfspectrum[k]

  dim(smodulus) <- c(smodsize * nscale, 1)
  cat("dimension of smodulus",dim(smodulus),"\n")

   z <- .C("Sridge_annealing",
           cost = as.double(cost),
           as.double(smodulus),
           phi = as.double(phi),
           as.double(lambda),
           as.double(mu),
           as.double(temprate),
           as.integer(sigsize),
           as.integer(nscale),
           as.integer(iteration),
           as.integer(stagnant),
           as.integer(seed),
           nb = as.integer(count),
           as.integer(subrate),
           as.integer(costsub),
           as.integer(smodsize),
           PACKAGE="Rwave")

  count <- z$nb
  cat("Number of iterations:",(count-1)*costsub,"(stagnant=",stagnant,")\n")
  if(plot == TRUE) {
   image(Mod(tfrep))
   lines(z$phi+1)
  }	
  list(ridge = z$phi+1, cost = z$cost[1:count])
}



  
coronoid <- function(tfrep, guess, tfspec = numeric(dim(tfrep)[2]),
	subrate = 1, temprate = 3, mu = 1, lambda = 2*mu,
	iteration = 1000000, seed = -7, stagnant = 20000,
	costsub = 1,plot=TRUE)
#########################################################################
#       coronoid:   
#       ----------
#        ridge extraction using modified simulated annealing
#	   Modification of Sridge_annealing, the cost function is
#	   replaced with another one, in which the smoothness penalty
#	   is proportional to the transform modulus.
#
#       Input:
#       ------
# 	 tfrep: wavelet or Gabor transform.
#	 guess: initial guess for ridge function (1D array).
#        tfspec: estimate for the contribution of the noise to the
#               transform modulus (1D array)
#        subrate: subsampling rate for the transform modulus.
#	 temprate: constant (numerator) in the temperature schedule.
#        lambda: coefficient in front of phi' in the cost function
#        mu: coefficient in front of phi'' in the cost function
#        iteration: maximal number of iterations
#        seed: initialization for random numbers generator
#        stagnant: maximum number of steps without move (for the
#                  stopping criterion)
#        costsub: subsampling of the cost function in cost
#               costsub=1 means that the whole cost function
#               is returned
#        plot:	 when set(default), some results will be shown on 
#	        the display	
#
#       Output:
#       -------
#        ridge: 1D array (of length sigsize) containing the ridge
#        cost: 1D array containing the cost function
#
#########################################################################
{

  sigsize <- dim(tfrep)[1]
  nscale <- dim(tfrep)[2]
  costsize <- as.integer(iteration/costsub) + 1	
  cost <- 1:costsize

  modulus <- Mod(tfrep)
  tfspectrum <- tfspec

  cost[] <- 0
  phi <- as.integer(guess)
  count <- 0	
  dim(phi) <- c(sigsize,1)	
  dim(modulus) <- c(sigsize * nscale, 1)

  smodsize <- as.integer(sigsize/subrate)

  if((sigsize/subrate - as.integer(sigsize/subrate)) > 0)
    smodsize <- as.integer(sigsize/subrate) + 1

  smodulus <- matrix(0,smodsize,nscale)
  dim(smodulus) <- c(smodsize * nscale, 1)

  z <- .C("Smodulus_smoothing",
        as.double(modulus),
        smodulus = as.double(smodulus),
	as.integer(sigsize),
        smodsize = as.integer(smodsize),            
        as.integer(nscale),
        as.integer(subrate),
           PACKAGE="Rwave")

  smodulus <- z$smodulus
  smodsize <- z$smodsize
  smodulus <- smodulus * smodulus
  dim(smodulus) <- c(smodsize, nscale)
  for (k in 1:nscale)
    smodulus[,k] <- smodulus[,k] - tfspectrum[k]
  dim(smodulus) <- c(smodsize * nscale, 1)


   z <- .C("Sridge_coronoid",
        cost = as.double(cost),
        as.double(smodulus),
        phi = as.double(phi),
        as.double(lambda),
	as.double(mu),
        as.double(temprate),
	as.integer(sigsize),
        as.integer(nscale),
        as.integer(iteration),
	as.integer(stagnant),
	as.integer(seed),
	nb = as.integer(count),
        as.integer(subrate),
	as.integer(costsub),
        as.integer(smodsize),
           PACKAGE="Rwave")

  count <- z$nb
  cat("Number of iterations:",(count-1)*costsub,"(stagnant=",stagnant,")\n")
  if(plot == TRUE) {	
    image(Mod(tfrep))
    lines(z$phi+1)
  }
  list(ridge = z$phi+1, cost = z$cost[1:count])
}
  

#**************************************************************#
#              (c) Copyright  1997                             #
#                         by                                   #
#     Author: Rene Carmona, Bruno Torresani, Wen L. Hwang      #
#                 Princeton University                         #
#                 All right reserved                           #
#**************************************************************#


## compute the svd (single value decomposition)
## The Input/Output of the command is the same as the commands svd in Splus

SVD <- function(a) {
  m <- dim(a)[1]
  n <- dim(a)[2]
  
  ## diagonal elements
  w <- numeric(n)
  dim(w) <- c(n,1)	 
  
  v <- matrix(0,n,n)
  v <- c(v)
  dim(v) <- c(length(v),1)
  a <- c(a)
  dim(a) <- c(length(a),1)
  
  z <- .C("Ssvdecomp",
          u= as.double(a),
          as.integer(m),
          as.integer(n),
          w = as.double(w),
          v = as.double(v),
          PACKAGE="Rwave")
  
  u <- z$u
  dim(u) <- c(n,n)	
  w <- z$w
  dim(w) <- c(n,1)
  v <- z$v
  dim(v) <- c(n,n)
  
  list(d=w, u=u, v=v)
}

#########################################################################
#      $Log: Pca_Climbers.S,v $
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################





pcacrc <- function(tfrep, tfspec = numeric(dim(tfrep)[2]), grida = 10,
	gridb = 20, pct = 0.1, count = 10000, bstep = 3, iteration = 10000,
	rate = .001, seed = -7, nbclimb = 10, flag.int = TRUE, chain = TRUE,
	flag.temp = FALSE, lineflag = FALSE, flag.cwt = FALSE)
#########################################################################
#  pcacrc:   Time-frequency multiple ridge estimation (pca climbers)
#  ------
# 	use the pca climber algorithm to evaluate ridges of
#    	   continuous Time-Frequency transform
#
#      input:
#      ------
# 	tfrep: wavelet or Gabor transform
#	tfspec: additional potential (coming from learning the noise)
#       grida : window of a
#       gridb : window of b
#       pct : the percent number of points in window 2*grida and
#	  2*gridb to select histogram
#       count : the maximal number of repetitive selection, if
#	  location was chosen before
#       iteration: number of iterations
#       rate: initial value of the temperature
#       seed: initialization for random numbers generator
#       nbclimb: number of crazy climbers
#       bstep: step size for the climber walk in the time direction
#	flag.int: if set to TRUE, computes the integral on the ridge.
#	chain: if set to TRUE, chains the ridges.
#	flag.temp: if set to TRUE, keeps a constant temperature.
#	flag.cwt: if set to TRUE, the bstep as well as the block size
#	 of a and b are adjusted according to the scale of wavelet
#	transform(not implemented yet).
#       linfflag: if set to TRUE, the line segments oriented to the
#                 where the climber will move freely at the block is shown in 
#                 image   	
#       
#      output:
#      -------
#       beemap: 2D array containing the (weighted or unweighted)
#               occupation measure (integrated with respect to time)
#       pcamap: 2D array containing number from 1 to 4, denoting the
#               direction a climber will go at some position; where
#               1 moving freely along b, 3 freely along a, 2 along 
#               line a = -b, and 4 along the line a = b. The restricted
#               move is perdendicular to the free move.
#
#########################################################################
{

   tfspectrum <- tfspec 

   d <- dim(tfrep)
   sigsize <- d[1]
   nscale <- d[2]

   sqmodulus <- Re(tfrep*Conj(tfrep))
   for (k in 1:nscale)
     sqmodulus[,k] <- sqmodulus[,k] - tfspectrum[k]
   image(sqmodulus)

  # percentage of points to be selected in a block  
  # considering overlapping 1/2 on each coordinate with neighborhood 
   nbpoint <- as.integer(2* grida * 2 * gridb * pct)
#   nbpoint <- as.integer(grida * gridb * pct)

  # number of grid size
   nbx <- as.integer(sigsize/gridb)
   nby <- as.integer(nscale/grida)
   if((sigsize/gridb - nbx) > 0) nbx <- nbx + 1
   if((nscale/grida - nby) > 0) nby <- nby + 1

   nbblock <- nbx * nby

  # first two locations at each block stores the lower-left corner of the block
  # followed by the locations of up-right corner and by the coordinates of the 
  # selected points in the block. The locations are in the order of (x, y)

   tstsize <- 2 * nbpoint + 4

   tst <- matrix(0, tstsize, nbblock)
   dim(tst) <- c(nbblock * tstsize,1)

  # the map of points selected in all the block
   pointmap <- matrix(0,sigsize,nscale)
   dim(pointmap) <- c(sigsize * nscale, 1)
   dim(sqmodulus) <- c(sigsize * nscale, 1)

   z <- .C("Spointmap",
           as.double(sqmodulus),
           as.integer(sigsize),
           as.integer(nscale),
           as.integer(gridb),
           as.integer(grida),
           as.integer(nbblock),
           as.integer(nbpoint),
           pointmap = as.integer(pointmap),
           tst =as.double(tst),
           as.integer(tstsize),
           as.integer(count),
           as.integer(seed),
           PACKAGE="Rwave")
  
   pointmap <- z$pointmap
   tst <- z$tst
   dim(pointmap) <- c(sigsize,nscale)
   dim(tst) <- c(tstsize, nbblock)

   

  # principle component analysis and calculate the direction at each block


  pcamap <- matrix(1,sigsize,nscale)

  # first eigenvector of a block
   eigv1 <- matrix(0,nbblock,2)

   # to draw eigenvector in a block 
   if(lineflag) {	
     lng <- min(grida, gridb)
     oldLng <- lng
     linex <- numeric(oldLng)
     liney <- numeric(oldLng)
   }


   for(j in 1:nbblock) {
        
	left <- max(1,as.integer(tst[1,j]))
	down <- max(1,as.integer(tst[2,j]))
	right <- min(as.integer(tst[3,j]),sigsize)
	up <- min(as.integer(tst[4,j]),nscale)

	input <- tst[5:tstsize,j]
	dim(input) <- c(2,nbpoint)
        input <- t(input)
        ctst <- var(input)
        eig<- eigen(ctst)

	# cat(" ratio in eigenvalues =  ",abs(eig$values[1]/eig$values[2])," \n")

        # eigen vector 1
        eigv1[j,] <- eig$vector[,1]


        # shifted center position of a block
	if(lineflag) {
          centerx <- as.integer((left + right)/2)
          centery <- as.integer((down + up)/2)
	}

        # theta of the eigen vector 1; -pi < theta <= pi

        theta <- atan2((eigv1[j,])[2],(eigv1[j,])[1])

        # along x : denote 1 in the pcamap

        if(((theta <= pi/8) && (theta > -pi/8)) ||
	   (theta > 7*pi/8 || theta <= -7*pi/8)) {

	  pcamap[left:(right-1),down:(up-1)] <- 1

	  if(lineflag) {
             Lng <- min(lng,(sigsize-centerx))
             if(Lng != oldLng) {
               linex <- numeric(Lng)
               liney <- numeric(Lng)
             }
             llng <- as.integer(Lng/2)
	     x1 <- max(centerx-llng,1)
             x2 <- min(sigsize,x1 + Lng-1)
             linex[] <- x1:x2
             liney[] <- centery
            lines(linex,liney)
	}
	}

        # along x=y : denoted as 2 in pcamap

        if(((theta > pi/8) && (theta <= 3*pi/8)) ||
	   ((theta > -7*pi/8) && (theta <= -5*pi/8))) {

	  pcamap[left:(right-1),down:(up-1)] <- 2

	  if(lineflag) {
            Lng <- min(lng,sigsize-centerx)
            Lng <- min(Lng,nscale-centery)
            if(Lng != oldLng) {
              linex <- numeric(Lng)
              liney <- numeric(Lng)
            }
            llng <- as.integer(Lng/2)
            x1 <- max(centerx-llng,1)
            x2 <- min(sigsize,x1 + Lng-1)
	    y1 <- max(centery-llng,1)
            y2 <- min(sigsize,y1 + Lng-1)

            linex[] <- x1:x2
            liney[] <- y1:y2
            lines(linex,liney)
           }
	}


        # along y : as 3 in pcamap

        if(((theta > 3*pi/8) && (theta <= 5*pi/8)) ||
	   ((theta > -5*pi/8) && (theta <= -3*pi/8))) {

	  pcamap[left:(right-1),down:(up-1)] <- 3

	  if(lineflag) {
             Lng <- min(lng, nscale-centery)
             if(Lng != oldLng) {
               linex <- numeric(Lng)
               liney <- numeric(Lng)
             }
            llng <- as.integer(Lng/2)
	    y1 <- max(centery-llng,1)
            y2 <- min(sigsize,y1 + Lng-1)

            linex[] <- centerx
            liney[] <- y1:y2
            lines(linex,liney)
          }
	}


        # along x=-y : as 4 in pcamap

        if(((theta > 5*pi/8) && (theta <= 7*pi/8)) ||
	   ((theta > -3*pi/8) && (theta <= -pi/8))) {

	  pcamap[left:(right-1),down:(up-1)] <- 4

	  if(lineflag) {
            Lng <- min(lng,nscale-centery)
            Lng <- min(Lng,sigsize-centerx)
            if(Lng != oldLng) {
               linex <- numeric(Lng)
               liney <- numeric(Lng)
            }
            llng <- as.integer(Lng/2)

	    x1 <- max(centerx-llng,1)
            x2 <- min(sigsize,x1 + Lng-1)
	    y1 <- max(centery-llng,1)
            y2 <- min(sigsize,y1 + Lng-1)

            linex[] <- x1:x2
            liney[] <- y2:y1
            lines(linex,liney)
          }
	}

	  if(lineflag) oldLng <- Lng
   }

# From the following on, it is similar to the process of crazy climbers ....

   beemap <- matrix(0,sigsize,nscale) 
   dim(beemap) <- c(nscale * sigsize, 1)
   dim(pcamap) <- c(nscale * sigsize, 1)
     
   z <- .C("Spca_annealing",
           as.double(sqmodulus),
           beemap= as.double(beemap),
           as.integer(pcamap),
           as.double(rate),
           as.integer(sigsize),
           as.integer(nscale),
           as.integer(iteration),
           as.integer(seed),
           as.integer(bstep),
           as.integer(nbclimb),
           as.integer(flag.int),
           as.integer(chain),
           as.integer(flag.temp),
           PACKAGE="Rwave")

   beemap <- z$beemap
   dim(beemap) <- c(sigsize, nscale)
   dim(pcamap) <- c(sigsize, nscale)
   image(beemap)
   list(beemap = beemap, pcamap = pcamap)
}

   


pcafamily <-function(pcaridge, orientmap,
                     maxchnlng=as.numeric(dim(pcaridge)[1])+10,
                     bstep = 1, nbchain = 100, ptile = 0.05)
#########################################################################
#     pcafamily:
#     ---------
#     chain the ridges obtained by pca climber.
#
#      input:
#      ------
#       pcaridge: ridge found by pca climber
#       orientmap : the first eigen vector direction at each position
#       bstep: maximal length for a gap in a ridge
#       nbchain: maximum number of chains
#       ptile: relative threshold for the ridges 
#       maxchnlng: maximal chain length
#
#      output:
#      ------
#       ordered: ordered map: image containing the ridges
#                (displayed with different colors)
#       chain: 2D array containing the chained ridges, according
#		to the chain data structure:
#		chain[,1]: first point of the ridge
#		chain[,2]: length of the chain
#		chain[,3:(chain[,2]+2)]: values of the ridge
#	nbchain: number of chains.
#
#########################################################################
{
   d <- dim(pcaridge)
   sigsize <- d[1]
   nscale <- d[2]
   threshold <- range(pcaridge)[2] * ptile
   sz <- 2 * (maxchnlng);
   chain <- matrix(-1,nbchain,sz)
   orderedmap <- matrix(0,sigsize,nscale)	
   dim(chain) <- c(nbchain * sz, 1)
   dim(pcaridge) <- c(nscale * sigsize, 1)
   dim(orderedmap) <- c(nscale * sigsize, 1)
   dim(orientmap) <- c(nscale * sigsize, 1)
	
   
   z <- .C("Spca_family",
           as.double(pcaridge),
           as.integer(orientmap),
           orderedmap = as.double(orderedmap),
           chain = as.integer(chain),
           chainnb = as.integer(nbchain),
           as.integer(sigsize),
           as.integer(nscale),
           as.integer(bstep),
           as.double(threshold),
           as.integer(maxchnlng),
           PACKAGE="Rwave")
	
   orderedmap <- z$orderedmap
   chain <- z$chain

   dim(orderedmap) <- c(sigsize,nscale)   
   dim(chain) <- c(nbchain,sz)   
   nbchain <- z$chainnb
   chain <- chain +1
   chain[,1] <- chain[,1]-1

   list(ordered = orderedmap, chain = chain, nbchain=nbchain)
}   



pcamaxima <- function(beemap,orientmap)
{
   d <- dim(beemap)
   sigsize <- d[1]
   nscale <- d[2]  
   tfmaxima <- matrix(0,sigsize,nscale)
   dim(orientmap) <- c(nscale * sigsize, 1)
   dim(beemap) <- c(nscale * sigsize, 1)   
   dim(tfmaxima) <- c(nscale * sigsize, 1)   

   z <- .C("Stf_pcaridge",
           as.double(beemap),
           tfmaxima = as.double(tfmaxima),
           as.integer(sigsize),
           as.integer(nscale),
           as.integer(orientmap),
           PACKAGE="Rwave")
	
   tfmaxima <- z$tfmaxima
   dim(tfmaxima) <- c(sigsize,nscale)   
   tfmaxima
}


simplepcarec <- function(siginput, tfinput, beemap, orientmap, bstep = 5,
                         ptile = .01, plot = 2)
#########################################################################
#     simplepcarec:
#     -------------
#      Simple reconstruction of a real valued signal from ridges found by 
#      pca climbers.
#
#      input:
#      ------
#      siginput: input signal
#      tfinput: continuous time-frequency transform (output of cwt or cgt)
#      beemap: output of pca climber algorithm
#      orientmap: pca dirction of climber
#      bstep: used for the chaining
#      ptile: 
#      plot: if set to 1, displays the signal, the components, and
#            signal and reconstruction one after another. If set to
#            2, displays the signal, the components, and the
#            reconstruction on the same page. Else, no plot.
#
#      output:
#      -------
#      rec: reconstructed signal
#      ordered: image of the ridges (with different colors)
#      comp: 2D array containing the signals reconstructed from ridges
#
#########################################################################
{
   tmp <- pcafamily(beemap,orientmap,ptile=ptile)
   chain <- tmp$chain
   nbchain <- tmp$nbchain
   rec <- numeric(length(siginput))

   if(plot != FALSE) {
     par(mfrow=c(2,1))
     plot.ts(siginput)
     title("Original signal")
     image(tmp$ordered)
     title("Chained Ridges")
   }

   npl(1)

   sigsize <- dim(tfinput)[1]
   nscale <- dim(tfinput)[2]
   rec <- numeric(sigsize)

   tmp3 <- matrix(0+0i,nbchain,sigsize)

   for (j in 1:nbchain){
      for(i in 1:chain[j,1]) {
        cat("The (b,a) at chain", j,"is (",chain[j,2*i+1],chain[j,2*i],")\n")
        tmp3[j,chain[j,2*i+1]] <- tmp3[j,chain[j,2*i+1]]+
                                  2*tfinput[chain[j,2*i+1],chain[j,2*i]]
      }
      rec <- rec + Re(tmp3[j,])
   }

   if(plot == 1) {
      par(mfrow=c(2,1))
      par(cex=1.1)
      plot.ts(siginput)
      title("Original signal")
      plot.ts(rec)
      title("Reconstructed signal")
   }
   else if (plot == 2) {
      par(mfrow=c(nbchain+2,1))
      par(mar=c(2,4,4,4))
      par(cex=1.1)
      par(err=-1)
      plot.ts(siginput)
      title("Original signal")

      for (j in 1:nbchain)
         plot.ts(Re(tmp3[j,]))
        
      plot.ts(rec)
      title("Reconstructed signal")
    }
   list(rec=rec, ordered=tmp$ordered, chain = tmp$chain, comp=tmp3)
}

#########################################################################
#       $Log: Noise.S,v $
# Revision 1.2  1995/04/05  18:56:55  bruno
# *** empty log message ***
#
# Revision 1.1  1995/04/02  01:04:16  bruno
# Initial revision
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################




tfpct <- function(input,percent=.8,plot=TRUE)
#########################################################################
#       tfpct:   
#       ------
# 	 compute a percentile of time-frequency representation frequency 
#		by frequency
#
#       input:
#       ------
# 	 input: modulus of the continuous wavelet transform (2D array)
#	 percent: value of the percentile to be computed
#        plot: if set to TRUE, displays the values of the energy as a 
#                  function of the scale
#
#       output:
#       -------
#        output: 1D array of size nbscales containing the noise estimate
#
#########################################################################
{

  nscale <- dim(input)[2]

  output <- numeric(nscale)
  for(i in 1:nscale) output[i] <- quantile(input[,i],percent)

  if(plot)plot.ts(output)
  output
}


tfmean <- function(input,plot=TRUE)
#########################################################################
#       tfmean:   
#       -------
# 	 compute the mean of time-frequency representation frequency 
#		by frequency
#
#       input:
#       ------
# 	 input: modulus of the continuous wavelet transform (2D array)
#        plot: if set to TRUE, displays the values of the energy as a 
#                  function of the scale
#
#       output:
#       -------
#        output: 1D array of size nbscales containing the noise estimate
#
#########################################################################
{

  nscale <- dim(input)[2]

  output <- numeric(nscale)
  for(i in 1:nscale) output[i] <- mean(input[,i])

  if(plot) plot.ts(output)
  output
}


tfvar <- function(input,plot=TRUE)
#########################################################################
#       tfvar:   
#       ------
# 	 compute the variance of time-frequency representation frequency 
#		by frequency
#
#       input:
#       ------
# 	 input: modulus of the continuous wavelet transform (2D array)
#        plot: if set to TRUE, displays the values of the energy as a 
#                  function of the scale
#
#       output:
#       -------
#        output: 1D array of size nbscales containing the noise estimate
#
#########################################################################
{

  nscale <- dim(input)[2]

  output <- numeric(nscale)
  for(i in 1:nscale) output[i] <- var(input[,i])

  if(plot) plot.ts(output)
  output
}

#########################################################################
#      $Log: Ridge_Icm.S,v $
#########################################################################
#
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################




icm <- function(modulus, guess, tfspec = numeric(dim(modulus)[2]),
	subrate = 1, mu = 1, lambda = 2*mu, iteration = 100)
#########################################################################
#       icm:   
#       ----
#        ridge extraction using icm algorithm
#
#       Input:
#       ------
# 	 modulus: modulus of the wavelet or Gabor transform.
#	 guess: initial guess for ridge function (1D array).
#        tfspec: estimate for the contribution of the noise to the
#               transform square modulus (1D array).
#        subrate: subsampling rate for the transform square modulus.
#        lambda: coefficient in front of phi'' in the cost function
#        mu: coefficient in front of phi' in the cost function
#        iteration: maximal number of iterations
#
#       Output:
#       -------
#        ridge: 1D array (of length sigsize) containing the ridge
#        cost: 1D array containing the cost function
#
#########################################################################
{

  sigsize <- dim(modulus)[1]
  nscale <- dim(modulus)[2]
  costsize <- iteration	
  cost <- 1:costsize
  tfspectrum <- tfspec

  cost[] <- 0
  phi <- as.integer(guess)
  count <- 0	
  dim(phi) <- c(sigsize,1)	
  dim(modulus) <- c(sigsize * nscale, 1)

  smodsize <- as.integer(sigsize/subrate)

  if((sigsize/subrate - as.integer(sigsize/subrate)) > 0)
    smodsize <- as.integer(sigsize/subrate) + 1

  smodulus <- matrix(0,smodsize,nscale)
  dim(smodulus) <- c(smodsize * nscale, 1)

  if (subrate != 1){
  z <- .C("Smodulus_smoothing",
          as.double(modulus),
          smodulus = as.double(smodulus),
          as.integer(sigsize),
          smodsize = as.integer(smodsize),            
          as.integer(nscale),
          as.integer(subrate),
           PACKAGE="Rwave")
  
  smodulus <- z$smodulus
  smodsize <- z$smodsize
  }
  else smodulus <- modulus
  smodulus <- smodulus * smodulus
  dim(smodulus) <- c(smodsize, nscale)
  for (k in 1:nscale)
    smodulus[,k] <- smodulus[,k] - tfspectrum[k]
  dim(smodulus) <- c(smodsize * nscale, 1)

  z <- .C("Sridge_icm",
          cost = as.double(cost),
          as.double(smodulus),
          phi = as.double(phi),
          as.double(lambda),
          as.double(mu),
          as.integer(sigsize),
          as.integer(nscale),
          as.integer(iteration),
          nb = as.integer(count),
          as.integer(subrate),
          as.integer(smodsize),
           PACKAGE="Rwave")

  count <- z$nb
  cat("Number of iterations:",count,"\n")
  list(ridge = z$phi+1, cost = z$cost[1:count])
}
  

## The commands perform the test data of the robust of the
## reconstructions from ridges in wavelet transform
## The command used to generate run of testing 128 run for each db in
## c(25,20,10,5,0) chbat signal with 5 noct, 10 voice, 5 compr
## tt <- RunRec(chbat,5,10,5,128,c(25,20,10,5,0))

## plot.ts(HOWAREYOU)
## cgtHOWAREYOU <- cgt(HOWAREYOU,70,0.01,100)
## clHOWAREYOU <- crc(Mod(cgtHOWAREYOU),nbclimb=1000)
## cfHOWAREYOU <- cfamily(clHOWAREYOU,ptile=0.001)
## image(cfHOWAREYOU$ordered > 0) 
## HOWord <- cfHOWAREYOU$ordered > 0 

robustrec <- function(x, nvoice, freqstep, scale, db, ptile) {
  ## HACK!
  InverseDB <- function(db) 10^(db/10)
  
  lng <- length(x)
  nx <- x
  wn <- rnorm(lng, 0, sqrt(var(nx)/InverseDB(db))) 
  nx <- nx + wn
  
  cgtnx <- cgt(nx, nvoice, freqstep, scale, plot = FALSE)
  crcnx <- crc(Mod(cgtnx), nbclimb = 1000)
  cfnx <- cfamily(crcnx,, ptile = ptile)
  nxordered <- (cfnx$ordered > 0)
  
  nxordered
}

## db is a vector of DB
## number of experiments (nrun) for each db (ndb) and each radius (nr)
## vdb <- c(20,15,10,5,0,-5)
## pvec <- c(0.001,0.001,0.001,0.01,0.01,0.02)
## pr <- c(0,1)
## tt <- RunRec(HOWord,HOWAREYOU,70,0.01,100,1,vdb,pvec,pr)
## MM <- apply(tt,c(1,2),mean)

RunRec <- function(HOWord, x, nvoice, freqstep, scale, nrun, vdb, pvec, pr) {
  ndb <- length(vdb)
  nr <- length(pr)
  Run <- array(0,c(ndb,nr,nrun))
  
  for(ii in 1:nrun) {
    cat("The number of run:",ii,"\n")
    
    for(jj in 1:ndb) {
      db <- vdb[jj]
      ptile <- pvec[jj]
      tt <- robustrec(x,nvoice,freqstep,scale,db,ptile)
      for(kk in 1:nr) {
        rr <- pr[kk]
        Run[jj,kk,ii] <- RidgeDist(tt,HOWord,rr)
      }
    }
  }
  Run
}

## wn <- rnorm(2048,0,sqrt(var(CLICKS)/InverseDB(1)))
## 10*log10(var(CLICKS)/var(wn))
## plot.ts(HOWAREYOU)
## cgtHOWAREYOU <- cgt(HOWAREYOU,70,0.01,100)
## clHOWAREYOU <- crc(Mod(cgtHOWAREYOU),nbclimb=1000)
## cfHOWAREYOU <- cfamily(clHOWAREYOU,ptile=0.001)
## image(cfHOWAREYOU$ordered > 0) 
## HOWord <- cfHOWAREYOU$ordered > 0 

band <- function(x, r) {
  xx <- x
  lng <- length(xx)
  yy <- logical(lng)
  x.rts <- as.ts(xx)
  for(k in 1:r) {
    y.rts <- lag(x.rts,-k) 
    zz <- as.logical(y.rts)
    yy[(1+(k)):lng] <- zz[1:(lng-(k))]
    xx <- yy | xx
    y.rts <- lag(x.rts,k)
    zz <- as.logical(y.rts)
    yy[1:(lng-(k))] <- zz[(1+(k)):lng]
    yy[(lng-(k)+1):lng] <- FALSE
    xx <- yy | xx
  }
  xx
}

Sausage <- function(A, r) {
  if( abs(r) > 0 ) {
    r <- abs(r)
    B <- band(c(A),r)
    dim(B) <- c(dim(A)[1],dim(A)[2])
    C <- band(c(t(B)),r)
    ## C <- band(c(t(A)),r)
    dim(C) <- c(dim(t(A))[1],dim(t(A))[2])
    B <- B | t(C)
  }
  else {
    B <- A
  }
  B
}

## Measure the distance of the two set M1 and M2: [0,1]
## (#(M1 - (M1&Sausage(M2))) +  #(M2 - (M2&Sausage(M1))))/(#M1+#M2)

RidgeDist <- function(m1, m2, r) {
  ms1 <- Sausage(m1,r)
  ms2 <- Sausage(m2,r)
  m3 <- m1 & ms2
  m4 <- m1 & (!m3)
  m5 <- m2 & ms1
  m6 <- m2 & (!m5)
  d <- (sum(m4) + sum(m6))/(sum(m1)+sum(m2))
  d
}

## confidence level:

confident <- function(x, low = 0.05, high = 0.95) {
  ndb <- dim(x)[1]
  nr <- dim(x)[2]
  nrun <- dim(x)[3]
  for(jj in 1:ndb) {
    for(kk in 1:nr) {
      tmp <- x[jj,kk,]
      ttmp <- quantile(c(tmp), c(low,high))
      cat("<dB r> = ", jj, kk, "<low high>=", ttmp, "\n")
    }
  }
}

#########################################################################
#      $Log: Ridge_Recons.S,v $
#########################################################################
#
#               (c) Copyright  1997
#                          by     
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################





regrec <- function(siginput, cwtinput, phi, compr, noct, nvoice,
                   epsilon = 0, w0 = 2*pi, fast = FALSE, plot = FALSE,
                   para = 0, hflag = FALSE, check = FALSE, minnbnodes = 2,
                   real = FALSE)
#########################################################################
#     regrec:
#     -------
#      Reconstruction of a real valued signal from a (continuous) ridge
#      (uses a regular sampling of the ridge)
#
#      input:
#      -------
#      siginput: input signal
#      cwtinput: Continuous wavelet transform (output of cwt)
#      phi: (unsampled) ridge
#      compr: subsampling rate for the wavelet coefficients (at scale 1)
#      noct: number of octaves (powers of 2)
#      nvoice: number of different scales per octave
#      epsilon: coeff of the Q2 term in reconstruction kernel
#      w0: central frequency of Morlet wavelet
#      fast: if set to TRUE, the kernel is computed using Riemann
#           sums instead of Romberg's quadrature
#      plot: if set to TRUE, displays original and reconstructed signals
#      para: constant for extending the support of reconstructed signal
#            outside the ridge. 
#      check: if set to TRUE, computes the wavelet transform of the
#            reconstructed signal
#      minnbnodes: minimum number of nodes for the reconstruction
#      real: if set to TRUE, only uses constraints on the real part
#            of the transform for the reconstruction.
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#      morvelets: array containing the wavelets on sampled ridge.
#      solskel: wavelet transform of sol, restricted to the ridge
#      inputskel: wavelet transform of signal, restricted to the ridge
#      Q2: second part of the reconstruction kernel
#      nbnodes: number of nodes used for the reconstruction.
#
##########################################################################
{
   ## Generate Sampled ridge

   tmp <- wRidgeSampling(phi,compr,nvoice)

   node <- tmp$node
   phinode <- tmp$phinode
   nbnodes <- tmp$nbnodes
   phinode <- as.integer(phinode)	

   if(nbnodes < minnbnodes){
     cat(" Chain too small\n")
     NULL
   }
   else {
   phi.x.min <- 2 * 2^(phinode[1]/nvoice)
   phi.x.max <- 2 * 2^(phinode[length(node)]/nvoice)

   x.min <- node[1]
   x.max <- node[length(node)]
   x.max <- x.max + round(para * phi.x.max)
   x.min <- x.min - round(para * phi.x.min)

   node <- node + 1 - x.min
   x.inc <- 1
   np <- as.integer((x.max - x.min)/x.inc) +1
   cat("(size:",np,",",nbnodes,"nodes):")

   fast <- FALSE

   ## Generating the Q2 term in reconstruction kernel
   if(epsilon == 0)
     Q2 <- 0
   else {
     if (fast == FALSE)
       Q2 <- rkernel(node, phinode, nvoice, x.min = x.min, x.max = x.max,
                     w0 = w0)
     else
       Q2 <- fastkernel(node, phinode, nvoice, x.min = x.min,
                        x.max = x.max, w0 = w0)
   }
   
   ## Generating the Q1 term in reconstruction kernel
   if (hflag == TRUE){
     one <- numeric(np)
     one[] <- 1
   }
   else{
     one <- numeric(np)
     one[] <- 1
   }
   
   if (epsilon !=0 ){
     Q <-  epsilon * Q2
     for(j in 1:np)
       Q[j,j] <- Q[j,j] + one[j]
     Qinv <- solve(Q)
   }
   else{
     Qinv <-  1/one
   }
   
   tmp2 <- ridrec(cwtinput, node, phinode, noct, nvoice,
                  Qinv, epsilon, np, w0=w0, check=check, real=real)
   
   if(plot == TRUE) {
     par(mfrow=c(2,1))
     plot.ts(Re(siginput))
     title("Original signal")
     plot.ts(Re(tmp2$sol))
     title("Reconstructed signal")
   }
   npl(2)
   lam <- tmp2$lam
   if(plot == TRUE) {
     plot.ts(lam,xlab="Number",ylab="Lambda Value")
     title("Lambda Profile")
   }
   N <- length(lam)/2
   mlam <- numeric(N)
   for(j in 1:N)
     mlam[j] <- Mod(lam[j] + lam[N + j]*(1i))
   if(plot == TRUE) plot.ts(sort(mlam))
   
   list(sol = tmp2$sol, A = tmp2$A, lam = tmp2$lam, dualwave = tmp2$dualwave,
        morvelets = tmp2$morvelets, solskel = tmp2$solskel,
        inputskel = tmp2$inputskel, Q2 = Q2, nbnodes = nbnodes)
 }
}


ridrec <- function(cwtinput, node, phinode, noct, nvoice,
	Qinv, epsilon, np, w0 = 2*pi, check = FALSE, real = FALSE)
#########################################################################
#     ridrec:
#     ------
#      Reconstruction of a real valued signal from a ridge, given
#       the kernel of the bilinear form.
#
#      input:
#      ------
#      cwtinput: Continuous wavelet transform (output of cwt)
#      node: time coordinates of the ridge samples
#      phinode: scale coordinates of the ridge samples
#      noct: number of octaves (powers of 2)
#      nvoice: number of different scales per octave
#      Qinv: inverse of the reconstruction kernel
#      epsilon: coefficient of the Q2 term in the reconstruction kernel
#      np: number of samples of the reconstructed signal
#      w0: central frequency of Morlet wavelet
#      check: if set to TRUE, computes the wavelet transform of the
#            reconstructed signal
#      real: if set to TRUE, only uses constraints on the real part
#            of the transform for the reconstruction.
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#      morvelets: array of morlet wavelets located on the ridge samples
#      solskel: wavelet transform of sol, restricted to the ridge
#      inputskel: wavelet transform of signal, restricted to the ridge
#
#########################################################################
{
   N <- length(node)

   aridge <- phinode
   bridge <- node

   if (real == TRUE)
      morvelets <- morwave2(bridge,aridge,nvoice,np,N)
   else
      morvelets <- morwave(bridge,aridge,nvoice,np,N)

   cat("morvelets;  ")


   if( epsilon == 0){
      if (real == TRUE)
         sk <- zeroskeleton2(cwtinput,Qinv,morvelets,bridge,aridge,N)
      else
         sk <- zeroskeleton(cwtinput,Qinv,morvelets,bridge,aridge,N)      
   }
   else { 
      if(real == TRUE) 
         sk <- skeleton2(cwtinput,Qinv,morvelets,bridge,aridge,N)
      else
         sk <- skeleton(cwtinput,Qinv,morvelets,bridge,aridge,N)
   }
   cat("skeleton.\n")

   solskel <- 0 #not needed if check not done
   inputskel <- 0 #not needed if check not done

   if(check == TRUE){
      wtsol <- cwt(Re(sk$sol),noct,nvoice)
      solskel <- complex(N)
      for(j in 1:N) solskel[j] <- wtsol[bridge[j],aridge[j]]

      inputskel <- complex(N)
      for (j in 1:N)
         inputskel[j] <- cwtinput[bridge[j],aridge[j]]
   }

   list(sol=sk$sol,A=sk$A,lam=sk$lam,dualwave=sk$dualwave,morvelets=morvelets,
	solskel=solskel,inputskel = inputskel)
}



morwave <- function(bridge, aridge, nvoice, np, N, w0 = 2*pi)
#########################################################################
#     morwave:
#     -------
#      Generation of the wavelets located on the ridge.
#
#      input:
#      ------
#      bridge: time coordinates of the ridge samples
#      aridge: scale coordinates of the ridge samples
#      nvoice: number of different scales per octave
#      np: size of the reconstruction kernel
#      N: number of complex constraints
#      w0: central frequency of Morlet wavelet
#
#      output:
#      -------
#      morvelets: array of morlet wavelets located on the ridge samples
#
#########################################################################
{

   morvelets <- matrix(0,np,2*N)

   aridge <-  2 * 2^((aridge - 1)/nvoice)
   tmp <- vecmorlet(np,N,bridge,aridge,w0 = w0)
   dim(tmp) <- c(np,N)
   morvelets[,1:N] <- Re(tmp[,1:N])
   morvelets[,(N+1):(2*N)] <- Im(tmp[,1:N])

#  Another way of generating morvelets
#   dirac <- 1:np
#   dirac[] <- 0
#   for(k in 1:N)  {
#      dirac[bridge[k]] <- 1.0;
#      scale <- 2 * 2^((aridge[k]-1)/nvoice);
#      cwtdirac <- vwt(dirac,scale,open=FALSE);
#      morvelets[,k] <- Re(cwtdirac);
#      morvelets[,k+N] <- Im(cwtdirac);
#      dirac[] <- 0
#    }

#  Still another way of generating morvelets
#   for(k in 1:N)  {
#      scale <- 2 * 2^((aridge[k]-1)/nvoice);
#      tmp <- morlet(np,bridge[k],scale)/sqrt(2*pi);
#      morvelets[,k] <- Re(tmp);
#      morvelets[,k+N] <- Im(tmp);
#    }

    morvelets
}



morwave2 <- function(bridge, aridge, nvoice, np, N, w0 = 2*pi)
#########################################################################
#     morwave2:
#     ---------
#      Generation of the real parts of morlet wavelets
#        located on the ridge.
#
#      input:
#      -------
#      bridge: time coordinates of the ridge samples
#      aridge: scale coordinates of the ridge samples
#      nvoice: number of different scales per octave
#      np: size of the reconstruction kernel
#      N: number of real constraints
#      w0: central frequency of Morlet wavelet
#
#      output:
#      -------
#      morvelets: array of morlet wavelets located on the ridge samples
#
#########################################################################
{

   morvelets <- matrix(0,np,N)

   aridge <-  2 * 2^((aridge - 1)/nvoice)
   morvelets <- Re(vecmorlet(np,N,bridge,aridge,w0 = w0))
   dim(morvelets)<- c(np,N)

# changed by Wen 5/22
#
#   aridge <-  2 * 2^((aridge - 1)/nvoice)
#   morvelets <- Re(vecmorlet(np,N,bridge,aridge,w0 = w0))
#   dim(morvelets) <- c(np,N)

   morvelets
}



skeleton <- function(cwtinput, Qinv, morvelets, bridge, aridge, N)
#########################################################################
#     skeleton:
#     --------
#      Computation of the reconstructed signal from the ridge
#
#      input:
#      -------
#      cwtinput: Continuous wavelet transform (output of cwt)
#      Qinv: inverse of the reconstruction kernel (2D array)
#      morvelets: array of morlet wavelets located on the ridge samples
#      bridge: time coordinates of the ridge samples
#      aridge: scale coordinates of the ridge samples
#      N: number of complex constraints
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#
##########################################################################
{
   dualwave <- Qinv %*% morvelets
   A <- t(morvelets) %*% dualwave

   rskel <- numeric(2*N)
   for(j in 1:N) {
      rskel[j] <- Re(cwtinput[bridge[j]-bridge[1]+1,aridge[j]]);
      rskel[N+j] <- -Im(cwtinput[bridge[j]-bridge[1]+1,aridge[j]])
   }

  B <- SVD(A)
  d <- B$d
  Invd <- numeric(length(d))
  for(j in 1:(2*N))
    if(d[j] < 1.0e-6) 
       Invd[j] <- 0
    else Invd[j] <- 1/d[j]

  lam <- B$v %*% diag(Invd) %*% t(B$u) %*% rskel
   sol <- dualwave%*%lam

   list(lam=lam,sol=sol,dualwave=dualwave,A=A)
}


skeleton2 <- function(cwtinput, Qinv, morvelets, bridge, aridge, N)
#########################################################################
#     skeleton2:
#     ---------
#      Computation of the reconstructed signal from the ridge, in the
#        case of real constraints.
#
#      input:
#      -------
#      cwtinput: Continuous wavelet transform (output of cwt)
#      Qinv: inverse of the reconstruction kernel (2D array)
#      morvelets: array of morlet wavelets located on the ridge samples
#      bridge: time coordinates of the ridge samples
#      aridge: scale coordinates of the ridge samples
#      N: number of real constraints
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#
##########################################################################
{
   dualwave <- Qinv %*% morvelets
   A <- t(morvelets) %*% dualwave

   rskel <- numeric(N)
   for(j in 1:N) {
      rskel[j] <- Re(cwtinput[bridge[j]-bridge[1]+1,aridge[j]]);
   }
   B <- SVD(A)
   d <- B$d
   Invd <- numeric(length(d))
   for(j in 1:N)
     if(d[j] < 1.0e-6) 
       Invd[j] <- 0
    else Invd[j] <- 1/d[j]

   lam <- B$v %*% diag(Invd) %*% t(B$u) %*% rskel

   sol <- dualwave%*%lam

   list(lam=lam,sol=sol,dualwave=dualwave,A=A)
}



zeroskeleton <- function(cwtinput, Qinv, morvelets, bridge, aridge, N)
#########################################################################
#     zeroskeleton:
#     -------------
#      Computation of the reconstructed signal from the ridge when
#       the epsilon parameter is set to 0.
#
#      input:
#      -------
#      cwtinput: Continuous wavelet transform (output of cwt)
#      Qinv: 1D array (warning: different from skeleton) containing
#            the diagonal of the inverse of reconstruction kernel.
#      morvelets: array of morlet wavelets located on the ridge samples
#      bridge: time coordinates of the ridge samples
#      aridge: scale coordinates of the ridge samples
#      N: number of complex constraints
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#
##########################################################################
{
   tmp1 <- dim(morvelets)[1]
   tmp2 <- dim(morvelets)[2]
cat(dim(morvelets))
   dualwave <- matrix(0,tmp1,tmp2)
   for (j in 1:tmp1)
      dualwave[j,] <- morvelets[j,]*Qinv[j]
   A <- t(morvelets) %*% dualwave

   rskel <- numeric(2*N)

   for(j in 1:N) {
      rskel[j] <- Re(cwtinput[bridge[j]-bridge[1]+1,aridge[j]]);
      rskel[N+j] <- -Im(cwtinput[bridge[j]-bridge[1]+1,aridge[j]])
   }

   B <- SVD(A)
   d <- B$d
   Invd <- numeric(length(d))
   for(j in 1:(2*N))
     if(d[j] < 1.0e-6) 
       Invd[j] <- 0
    else Invd[j] <- 1/d[j]

   lam <- B$v %*% diag(Invd) %*% t(B$u) %*% rskel

   sol <- dualwave%*%lam

   list(lam=lam,sol=sol,dualwave=dualwave,A=A)
}




zeroskeleton2 <- function(cwtinput, Qinv, morvelets, bridge, aridge, N)
#########################################################################
#     zeroskeleton2:
#     -------------
#      Computation of the reconstructed signal from the ridge when
#       the epsilon parameter is set to 0 and the constraints are real.
#
#      input:
#      -------
#      cwtinput: Continuous wavelet transform (output of cwt)
#      Qinv: 1D array (warning: different than in skeleton) containing
#            the diagonal of the inverse of reconstruction kernel.
#      morvelets: array of morlet wavelets located on the ridge samples
#      bridge: time coordinates of the ridge samples
#      aridge: scale coordinates of the ridge samples
#      N: number of real constraints
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#
##########################################################################
{
   tmp1 <- dim(morvelets)[1]
   tmp2 <- dim(morvelets)[2]
   dualwave <- matrix(0,tmp1,tmp2)
   for (j in 1:tmp1)
      dualwave[j,] <- morvelets[j,]*Qinv[j]
   A <- t(morvelets) %*% dualwave

   rskel <- numeric(N)

   for(j in 1:N) 
     rskel[j] <- Re(cwtinput[bridge[j]-bridge[1]+1,aridge[j]]);

   B <- SVD(A)
   d <- B$d
   Invd <- numeric(length(d))
   for(j in 1:N)
     if(d[j] < 1.0e-6) 
       Invd[j] <- 0
    else Invd[j] <- 1/d[j]
   lam <- B$v %*% diag(Invd) %*% t(B$u) %*% rskel

   sol <- dualwave%*%lam

   list(lam=lam,sol=sol,dualwave=morvelets,A=A)
}





regrec2 <- function(siginput, cwtinput, phi, nbnodes, noct, nvoice, Q2,
	epsilon = 0.5, w0 = 2*pi , plot = FALSE)
#########################################################################
#     regrec2:
#     -------
#      Reconstruction of a real valued signal from a (continuous) ridge
#      (uses a regular sampling of the ridge), from a precomputed kernel.
#
#      input:
#      -------
#      siginput: input signal
#      cwtinput: Continuous wavelet transform (output of cwt)
#      phi: (unsampled) ridge
#      nbnodes: number of samples on the ridge
#      noct: number of octaves (powers of 2)
#      nvoice: number of different scales per octave
#      Q2: second part of the reconstruction kernel
#      epsilon: coeff of the Q2 term in reconstruction kernel
#      w0: central frequency of Morlet wavelet
#      plot: if set to TRUE, displays original and reconstructed signals
#
#      output: same as ridrec
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#      morvelets: array of morlet wavelets located on the ridge samples
#      solskel: wavelet transform of sol, restricted to the ridge
#      inputskel: wavelet transform of signal, restricted to the ridge
#
#########################################################################
{
   tmp <- RidgeSampling(phi,nbnodes)
   node <- tmp$node
   phinode <- tmp$phinode

   np <- dim(Q2)[1]
   one <- diag(np)
   Q <- one + epsilon * Re(Q2)

   if(epsilon == 0)
      Qinv <- one
   else
      Qinv <- solve(Q)

   tmp2 <- ridrec(cwtinput,node,phinode,noct,nvoice,Qinv,epsilon,np)

   if(plot == TRUE){
      par(mfrow=c(2,1))
      plot.ts(Re(siginput))
      title("Original signal")
      plot.ts(Re(tmp2$sol))
      title("Reconstructed signal")
   }
   tmp2
}




RidgeSampling <- function(phi, nbnodes)
#########################################################################
#    RidgeSampling:
#    --------------
#      Given a ridge phi (for the Gabor transform), returns a 
#        (regularly) subsampled version of length nbnodes.
#
#      Input:
#      ------
#      phi: ridge
#      nbnodes: number of samples.
#
#      Output:
#      -------
#      node: time coordinates of the ridge samples
#      phinode: frequency coordinates of the ridge samples
#
#########################################################################
{
   node <- numeric(nbnodes)
   phinode <- numeric(nbnodes)
   N <- nbnodes
   LL <- length(phi)

   for (i in 1:(N+1)) node[i] <- as.integer(((LL-1)*i+nbnodes-LL+1)/nbnodes)
   for (i in 1:(N+1)) phinode[i] <- phi[node[i]]

   list(node = node,phinode = phinode)
}



wRidgeSampling <- function(phi, compr, nvoice)
#########################################################################
#    wRidgeSampling:
#    ---------------
#      Given a ridge phi, returns a subsampled version of length
#      nbnodes (wavelet case).
#
#      Input:
#      ------
#      phi: ridge
#      compr: subsampling rate for the wavelet coefficients (at scale 1)
#             when compr <= 0, uses all the points in a ridge
#
#      Output:
#      -------
#      node: time coordinates of the ridge samples
#      phinode: frequency coordinates of the ridge samples
#      nbnodes: number of samples.
#
#########################################################################
{


   LL <- length(phi)
   node <- numeric(LL)
   phinode <- numeric(LL)

   LN <- 1
   j <- 1
   node[1] <- 1

# We multiply a number on the phi. This number is obtained experimentally
# If we have a ridge which is linear of scale, then the subsampling is
# adapted with s, however, in the wavelet case, the ridge is linear 
# in log(scale), the subsampling rate is therefore adapted to k*s^l
# l here is the constant 100/15, and k is compr 
   aridge <- 2 * 2^((phi-1)/(nvoice * 100/15))

#   while (node[j] < LL){
#      j <- j + 1
#      LN <- round(compr * aridge[node[j-1]])
#      cat("LN=",LN)
#      node[j] <- node[j-1] + LN
#      cat("; node=",node[j],"\n")
#      phinode[j] <- phi[node[j]]
#      cat("; phinode=",phinode[j],"\n")
#   }

   nbnodes <- 0
   while (node[j] < LL){
      phinode[j] <- phi[node[j]]
      nbnodes <- nbnodes + 1

# To guarantee at least advance by one 
       LN <- max(1,round(compr * aridge[node[j]]))

      j <- j + 1
      node[j] <- node[j-1] + LN
   }


   tmpnode <- numeric(nbnodes)
   tmpphinode <- numeric(nbnodes)
   tmpnode <- node[1:nbnodes]
   tmpphinode <- phinode[1:nbnodes]

   list(node = tmpnode,phinode = tmpphinode, nbnodes = nbnodes)
}




sridrec <- function(tfinput, ridge)
#########################################################################
#     sridrec
#     -------
#      Simple reconstruction of a real valued signal from a ridge,
#      by restriction of the wavelet transform.
#
#      Input:
#      ------
#     tfinput: Continuous time-frequency transform (output of cwt or cgt)
#     ridge: (unsampled) ridge
#
#      Output:
#      -------
#      rec: reconstructed signal
#
#########################################################################
{
   bsize <- dim(tfinput)[1]
   asize <- dim(tfinput)[2]
  
   rec <- numeric(bsize)
   rec[] <- 0 + 0i

   for(i in 1:bsize) {
      if(ridge[i] > 0)
        rec[i] <- rec[i] + 2 * tfinput[i,ridge[i]]
   }
  
   Re(rec)
}

############################################################
# Functions processing radar images and their example. 
############################################################

######################################
# processing Radar images from V. Chen
######################################

## b727 <- matrix(scan("b727s.dat"),ncol=512,byrow=TRUE)
## b727 <- matrix(scan("b727r.dat"),ncol=256,byrow=TRUE)

## ncol <- dim(b727)[2]/2
## b727r<- b727[,-1+2*(1:ncol)]   
## b727i<- b727[,2*(1:ncol)]       

## B727 <- t(Conj(b727r + i*b727i))
## nrow <- dim(B727)[1]
## ncol <- dim(B727)[2]

## shift fft 1D data
## -----------------

fftshift <- function(x) {
  lng <- length(x)
  y <- numeric(lng)
  y[1:(lng/2)] <- x[(lng/2+1):(lng)]
  y[(lng/2+1):lng] <- x[1:(lng/2)]
  y
}

## The following tow S-routine concludes our Radar experiments
## -------------------------------------------------------------
## b727 <- matrix(scan("b727s.dat"),ncol=512,byrow=TRUE)
## b727 <- matrix(scan("b727r.dat"),ncol=256,byrow=TRUE)

## Generating the original image
## -----------------------------

## e.g. B727 <- showRadar(b727)

showRadar<- function(x, plot=TRUE) {
  ncol <- dim(x)[2]/2
  xr<- x[,-1+2*(1:ncol)]   
  xi<- x[,2*(1:ncol)]       
  y <- t(Conj(xr + 1i*xi))
  oy <- t(apply(apply(y,2,fftshift),1,fftshift))
  oy <- apply(oy,2,fft)
  oy <- t(apply(apply(oy,2,fftshift),1,fftshift))
  if(plot) image(Mod(t(oy)))
  oy
}

## Enhancing Radar Image by Gabor Transform (V.Chen)
## ------------------------------------------------

## gtime <- 128
## scale <- 50

## e.g. B727 <- cgtRadar(b727,gtime,scale)
## e.g. 
##      b727 <- matrix(scan("b727s.dat"),ncol=512,byrow=TRUE)
##      b727 <- matrix(scan("b727r.dat"),ncol=256,byrow=TRUE)
##      ncol <- dim(b727)[2]/2
##      b727r<- b727[,-1+2*(1:ncol)]   
##      b727i<- b727[,2*(1:ncol)]       

##      b727 <- t(Conj(complex(real=b727r, imag=b727i)))
##      B727 <- cgtRadar(b727,gtime,scale,flag=FALSE)
##      image(t(apply(Mod(B727$cgtout[,2,]),1,fftshift))) 

cgtRadar <- function(x,gtime,scale,flag=TRUE,plot=TRUE)
{
  y <- x
  if(flag) {
    ncol <- dim(x)[2]/2
    xr<- x[,-1+2*(1:ncol)]   
    xi<- x[,2*(1:ncol)]       
    y <- t(Conj(xr + 1i*xi))
  }
  nrow <- dim(y)[1]
  ncol <- dim(y)[2]
  cgty <- array(0+0i,c(ncol,nrow,gtime))
  cgtyy <- array(0+0i,c(ncol,nrow,gtime))
  for(k in 1:ncol) cgty[k,,] <-
    cgt(Re(y[,k]),gtime,2/gtime,scale,plot=FALSE) + 1i*cgt(Im(y[,k]),gtime,2/gtime,scale,plot=FALSE)
  for(k in 1:nrow)
    cgtyy[,k,] <- t(apply(cgty[,k,],1,fftshift))
  oy <- t(apply(apply(Mod(cgty),c(1,3),mean),1,fftshift))
  if(plot)
    image(oy)
  list(output=oy,cgtout=cgtyy)
}

## Generate X, Y, Z for the command : cloud

cloudXYZ <- function(dim1, dim2,dim3)
{
  II <- rep(1:dim1,dim2*dim3)
  dim(II) <- c(dim1,dim2,dim3)
  KK <- rep(1:dim3,dim2)
  dim(KK) <- c(dim3,dim2)
  KK <- t(KK)
  KK <- rep(KK,dim1)
  dim(KK) <- c(dim2 * dim3, dim1)
  KK <- t(KK)
  dim(KK) <- c(dim1, dim2, dim3)
  JJ <- rep(1:dim2,dim1)
  dim(JJ) <- c(dim2,dim1)
  JJ <- t(JJ)
  JJ <- rep(JJ,dim3)
  dim(JJ) <- c(dim1,dim2,dim3)
  list(II=II, JJ=JJ, KK=KK)
}

## Commands show points :

## cgtout <- B727$cgtout
## tt <-  cloudXYZ(dim(cgtout)[1], dim(cgtout)[2], dim(cgtout)[3])
## range(abs(cgtout))
## SS <- (abs(cgtout) > 4.0)
## XX <- tt$II[SS]
## YY <- tt$JJ[SS]
## ZZ <- tt$KK[SS]
## XX[length(XX)+1] <- 0
## XX[length(XX)+1] <- dim1
## YY[length(YY)+1] <- 0
## YY[length(YY)+1] <- dim2
## ZZ[length(ZZ)+1] <- 0
## ZZ[length(ZZ)+1] <- dim3
## cloud(ZZ~XX*YY)

## showpoints <- function(cgtout,low,high) {
## X <- 1:crossrange
## XX <- X %*% t(rep(1,crossrange))
## YY <- t(XX)
## freq <- dim(cgtout)[2]
## ZZ <- matrix(0,crossrange,crossrange)
## modmax <- max(Mod(cgtout))
## for(j in 1:crossrange)
##  for(k in 1:crossrange)
##    ZZ[j,k] <- maxpos(Mod(cgtout[j,,k]),low*modmax,high*modmax)
## cloud(ZZ~XX*YY)
##}

## maxpos <- function(x,low,high) {
##   pos <- 1       
##   lng <- length(x)
##   maxval <- max(x)
##   if((maxval >= low) & (maxval <= high)) { 
##    for(j in 1:lng) {
##      if(x[j] >= maxval) {
##        pos <- j
##      }
##    }
##   }
##  pos
## }

## showpoints <- function(cgtout,low,high) {
##  crossrange <- dim(cgtout)[1]
##  gabortime <- dim(cgtout)[3]
##  freq <- dim(cgtout)[2]
##  modmax <- max(Mod(cgtout))
##  tt <-persp(matrix(1,crossrange,gabortime),zlim=1:freq)
##  TT <- (Mod(cgtout) > low * modmax) * (Mod(cgtout) <= high * modmax)
##  for(k in 1:gabortime) {
##     for(j in 1:freq) {
##       for(i in 1:crossrange) { 
##         if(TT[i,j,k]==TRUE) 
##           points(perspp(i,k,j,tt))
##       }
##     }
##   }
##  tt
## }

#########################################################################
#    (c) Copyright 1997
#               by
#   Author: Rene Carmona, Bruno Torresani, Wen L. Hwang, Andrea Wang
#              Princeton University 
#              All right reserved
########################################################################

mrecons <- function(extrema, filtername="Gaussian1", readflag=FALSE)
#****************************************************************
#  mrecons
#  --------
#    Reconstruct from dyadic extrema. The reconstructed signal
#    preserves locations and values at extrema. This is Carmona's
#    method of extrema reconstruction.	
# 
#  input
#  -----
#    extrema : the extrema representation 
#    filtername : filters (Gaussain1 stands filters corresponding to
#	Mallat and Zhong's wavelet. And, the Haar stands for the
#       filters for Haar basis.	
#    readflag: if set to TRUE, read kernel from a precomputed file.
#
#  output
#  ------
#    f: signal reconstructed from the wavelet transform extrema
#    g: f plus mean of f
#    h: f plus coarse scale of f
#****************************************************************
{
  pure <- extrema$original
  x <- adjust.length(pure)
  pure.data <- x$signal

  data <- extrema$original
  maxresoln <- extrema$maxresoln
  np <- extrema$np

  if(2^maxresoln > np)
    stop("The support of the coarsest scale filter is bigger than signal size")
  if((readflag && (maxresoln > 9)) || (np > 4096))
    stop("Can not use readflag")

  dim(extrema$extrema) <- c(length(extrema$extrema), 1)

  f <- 1:np

  z <- .C("extrema_reconst",
          as.character(filtername),
          a = as.double(f),	
          as.double(extrema$extrema),
          as.integer(maxresoln),
          as.integer(np),
          as.integer(readflag),
           PACKAGE="Rwave")

  f <- z$a 
  g <- f + mean(pure.data)
  h <- f + extrema$Sf

  lim <- range(f, g, h, pure.data)
  par(mfrow=c(3,1))

  plot.ts(f, ylim=lim, xlab="", ylab="", main="Reconstruction")
  plot.ts(g, ylim=lim, xlab="", ylab="", main="Reconstruction + Mean")
  plot.ts(h, ylim=lim, xlab="", ylab="", main="Reconstruction + Sf")

  par(mfrow=c(1,1))

  list(f=f, g=g, h=h)
}

dwinverse <- function(wt, filtername="Gaussian1")
#****************************************************************
#  dwinverse
#  ---------
#    Invert the dyadic wavelet transform.
# 
#  input
#  -----
#    wt: the wavelet transform 
#    filtername : filters used. ("Gaussian1" stands for the filters
#       corresponds to those of Mallat and Zhong's wavlet. And
#       "Haar" stands for the filters of Haar basis.	
#
#  output
#  ------
#    f: the reconstructed signal
#****************************************************************
{
  Sf <- wt$Sf
  Sf <- c(Sf)	
  dim(Sf) <- c(length(Sf), 1)
  Wf <- wt$Wf
  Wf <- c(Wf)	
  dim(Wf) <- c(length(Wf), 1)
  np <- wt$np
  maxresoln <- wt$maxresoln
  fback <- 1:np
  dim(fback) <- c(length(fback), 1)

  z <- .C("Sinverse_wavelet_transform",
          a = as.double(fback),
          as.double(Sf),
          as.double(Wf),
          as.integer(maxresoln),
          as.integer(np), 
          as.character(filtername),
           PACKAGE="Rwave")

  f <- z$a 
  f
}

#########################################################################
#    $log: extrema.S,v $
#########################################################################
#    (c) Copyright 1997
#               by
#   Author: Rene Carmona, Bruno Torresani, Wen L. Hwang, Andrea Wang
#              Princeton University 
#              All right reserved
########################################################################




ext <- function(wt, scale=FALSE, plot=TRUE)
#****************************************************************
# ext
# ---
#   compute the extrema of the dyadic wavelet transform.
#
# input
# -----
#   wt: wavelet transform
#   scale: a flag indicating if the extrema at each 
#	   resolution will be plotted at the same sacle.
#
# output
# ------
#   original: original signal
#   extrema: extrema representation
#   Sf: coarse resolution of signal
#   maxresoln: number of decomposition
#   np: size of signal
#****************************************************************
{
  s <- wt$original
  maxresoln <- wt$maxresoln
  np <- wt$np

  extrema <- matrix(0, nrow=maxresoln, ncol=np)
  extrema <- t(extrema)
  dim(extrema) <- c(length(extrema), 1)

  t(wt$Wf)   # Note: transposed wt is not assigned to wt
  dim(wt$Wf) <- c(length(wt$Wf), 1)

  z <- .C("modulus_maxima", 
          a=as.double(extrema),
          as.double(wt$Wf),
          as.integer(maxresoln), 
          as.integer(np),
           PACKAGE="Rwave")

  extrema <- t(z$a)
  dim(extrema) <- c(np, maxresoln)
  
  cat("number of extrema =", sum(extrema!=0), "\n")

  if(plot)  plotResult(extrema, s, maxresoln, scale)

    list(original=s,extrema=extrema,Sf=wt$Sf,maxresoln=maxresoln,np=np)
}

#########################################################################
#      $Log: MGabor.S,v $
#########################################################################
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################





mcgt <- function(input, nvoice, freqstep = (1/nvoice), nscales = 10,
	scalestep = 5, initscale = 0, crit = 0, plot = TRUE,
	tchatche = FALSE)
#########################################################################
#       mcgt:   
#       ----
#        multiwindow continuous Gabor transform function:
# 	  compute the continuous Gabor transform with gaussian windows.
#	  selects the optimal window using L^p norm or entropy
#         optimization
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#	 nvoice: number of frequency bands
#        freqstep: sampling rate for the frequency axis
#        nscales: number of scales considered
#        scalestep: increment for scale parameter
#        initscale: initial value form the scale parameter
#        crit: criterion for optimization (L^p norm or entropy)
#	 plot: if set to TRUE, displays the modulus of cwt on the graphic
#		device.
#        rchatche: if set to TRUE, prints intermediate results
#
#       output:
#       -------
#        output: optimal continuous (complex) Gabor transform
#
#########################################################################
{
   oldinput <- input
   isize <- length(oldinput)

   tmp <- adjust.length(oldinput)
   input <- tmp$signal
   newsize <- length(input)

   pp <- nvoice
   Routput <- matrix(0,newsize,pp)
   Ioutput <- matrix(0,newsize,pp)
   output <- matrix(0,newsize,pp)
   dim(Routput) <- c(pp * newsize,1)
   dim(Ioutput) <- c(pp * newsize,1)
   dim(input) <- c(newsize,1)


   norm <- 1
   lpoptnorm <- 0
   entoptnorm <- 100000000

   optsca <- 0


#####################
# Loop over scales: #
#####################

   sca <- initscale
   for(k in 1:nscales){

      sca <- sca + scalestep

# Compute Gabor transform
# -----------------------
      z <- .C("Sgabor",
              as.double(input),
              Rtmp = as.double(Routput),
              Itmp = as.double(Ioutput),
              as.integer(nvoice),
              as.double(freqstep),
              as.integer(newsize),
              as.double(sca),
              PACKAGE="Rwave")

      Routput <- z$Rtmp
      Ioutput <- z$Itmp
      dim(Routput) <- c(newsize,pp)
      dim(Ioutput) <- c(newsize,pp)

# Compute L^2 norm for normalization
# ----------------------------------
      pexp <- as.double(2)
      z <- .C("Lpnorm",
              ltwonorm = as.double(norm),
              as.double(pexp),
              as.double(Routput),
              as.double(Ioutput),
              as.integer(newsize),
              as.integer(nvoice),
              PACKAGE="Rwave")
      ## cat("l2 norm=",z$ltwonorm,"\n")

# Normalize
# ---------
      Routput <- Routput/z$ltwonorm
      Ioutput <- Ioutput/z$ltwonorm

      if(crit == 0) {
         z <- .C("entropy",
                 lpnorm = as.double(norm),
                 as.double(Routput),
                 as.double(Ioutput),
                 as.integer(newsize),
                 as.integer(nvoice),
                 PACKAGE="Rwave")
         if(tchatche) {
            cat("     scale=", sca, "; entropy=", z$lpnorm, "\n")
         }

         if (z$lpnorm < entoptnorm){
            entoptnorm <- z$lpnorm
            optsca <- sca
            output <- Routput[1:isize,] + 1i*Ioutput[1:isize,]
         }
      optnorm <- entoptnorm
      }

      else {

        ## Compute L^p norm
        ## ----------------
        pexp <- as.double(crit)
        z <- .C("Lpnorm",
                lpnorm = as.double(norm),
                as.double(pexp),
                as.double(Routput),
                as.double(Ioutput),
                as.integer(newsize),
                as.integer(nvoice),
                PACKAGE="Rwave")
        if(tchatche) {
          cat("     scale=", sca,"; l", pexp," norm=", z$lpnorm, "\n")
        }
        
        if(z$lpnorm > lpoptnorm) {
          lpoptnorm <- z$lpnorm
          optsca <- sca
          output <- Routput[1:isize,] + 1i*Ioutput[1:isize,]
        }
        optnorm <- lpoptnorm
      }
    }
   
   cat("   Optimal scale: ", optsca, "\n")
   
   if(plot) {
     image(Mod(output), xlab="Time", ylab="Frequency")
     title("Gabor Transform Modulus")
   }
   
   output
}

#########################################################################
#       $Log: Util.S,v $
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona,Bruno Torresani,Wen-Liang Hwang,Andra Wang   
#                  Princeton University
#                  All right reserved                           
#########################################################################





smoothwt <- function(modulus, subrate, flag = FALSE)
#########################################################################
#      smoothwt:   
#      --------
#       smooth the wavelet (or Gabor) transform in the b direction
#
#       input:
#       ------
#	 modulus: modulus of the wavelet (or Gabor) transform
#	 subrate: size of the smoothing window
#	 flag: if set to TRUE, subsamples the smoothed transform by
#		subrate.	
#
#       output:
#       -------
#        smoothed transform (2D array)
#
#########################################################################
{
  sigsize <- dim(modulus)[1]
  nscale <- dim(modulus)[2]

  if(flag) {
    smodulus <- matrix(0,sigsize,nscale)
    dim(smodulus) <- c(sigsize * nscale, 1)
  }
  else {
    modsize <- as.integer(sigsize/subrate) + 1
    smodulus <- matrix(0,modsize,nscale)
    dim(smodulus) <- c(modsize * nscale, 1)
  }
	
  dim(modulus) <- c(sigsize * nscale, 1)

  z <- .C("Ssmoothwt",
          sm = as.double(smodulus),
          as.double(modulus),
          as.integer(sigsize),
          as.integer(nscale),
          as.integer(subrate),
          as.integer(flag),
          PACKAGE="Rwave")

  if(flag)
   dim(z$sm) <- c(sigsize, nscale)
  else 	
   dim(z$sm) <- c(modsize, nscale)
  z$sm
}

smoothts <- function(ts, windowsize)
#########################################################################
# smooth a time series by averaging window
#
# Arguments: 
#	<ts> time series
#       <windowsize> window size
#########################################################################
{
   sigsize <- length(ts)
   sts <- numeric(sigsize)
   nscale <- 1   
   stssize <- sigsize
   dim(sts) <- c(sigsize, 1)
   dim(ts) <- c(sigsize, 1)
   subrate <- windowsize # subrate <- 1
   
   z <- .C("Smodulus_smoothing",
           as.double(ts),
           sts = as.double(sts),
           as.integer(sigsize),
           stssize = as.integer(stssize),            
           as.integer(nscale),
           as.integer(subrate),
           PACKAGE="Rwave")

  sts <- z$sts
  sts
}

adjust.length <- function(inputdata)
#########################################################################
# adjust.length adds zeros to the end of the data if necessary so that 
# its length is a power of 2.  It returns the data with zeros added if
# nessary and the length of the adjusted data.
#
# Arguments: 
#	<inputdata> is either a text file or an S object containing
# 		    data.
#########################################################################
{
  if (is.character(inputdata))
    s <- scan(inputdata)
  else
    s <- inputdata
  np <- length(s)
  
  pow <- 1
  while ( 2*pow < np )
    pow <- 2*pow
  new.np <- 2*pow
  
  if ( np == new.np )
    list( signal=s, length=np )
  else {
    new.s <- 1:new.np
    new.s[1:new.np] <- 0
    new.s[1:np] <- s
    list( signal=new.s, length=new.np )
  }
}

#########################################################################
#      npl:
#      ---
#       plots with n rows.
#
#       input:
#       ------
#	 nrow: number of rows
#
#########################################################################
npl <- function(nbrow)
{
  par(mfrow = c(nbrow, 1))
  cat("")
}

#########################################################################
#      SpecGen:
#      --------
#       Estimate power spectrum
#
#       input:
#       ------
#	 input: input signal.
#        spans: length of Daniell's smoother.
#        taper: relative size of tapering window (cosine taper).
#
#########################################################################
SpecGen <- function(input, spans = 9, taper = 0.2)
{
  tmp <- spec.pgram(input,spans,taper)
  tmp1 <- tmp$spec
  tmp <- 10^(tmp1/10)
  spec <- tmp
  spec
}

#########################################################################
#      SampleGen:
#      ----------
#       generate a real sample with prescribed spectrum      
#
#       input:
#       ------
#	 nspec: spectral density
#
#########################################################################
SampleGen <- function(spec)
{
  sqspec <- sqrt(spec)
  d <- length(sqspec)
  size <- d 
  tmp <- rnorm(2 * size)
  real <- numeric(size)
  imag <- numeric(size)
  real <- tmp[1:size]
  a <- size+1
  b <- 2 * size
  imag <- tmp[a:b]
  real1 <- real * sqspec[1:size]
  imag1 <- imag * sqspec[1:size]
  real2 <- numeric(2 * size)
  imag2 <- numeric(2 * size)
  real2[1:size] <- real1
  imag2[1:size] <- imag1
  for(i in 2:size) {
    real2[b-i+2] <- real1[i]
    imag2[b-i+2] <- -imag1[i]
  }	
  imag2[1] <- 0
  tmp1 <-  fft(real2 + 1i*imag2, inverse=TRUE)
  sample <- Re(tmp1)/sqrt((2*size))
  sample
}

hurst.est <- function(wspec, range, nvoice, plot=TRUE)
#########################################################################
#      hurst.est:   
#      ----------
#       estimate Hurst exponent from (part of) wavelet spectrum
#
#       input:
#       ------
#	 wspec: wavelet spectrum.
#	 nvoice: number of voices.
#	 plot: if set to TRUE, displays regression line on current plot.
#
#       output:
#       -------
#        intercept and slope of regression line. Slope is Hurst exponent.
#
#########################################################################
{
  loctmp <- lsfit(range,log(wspec[range],base=2^(2/nvoice)))
  if(plot) abline(loctmp)
  loctmp$coef
}

wspec.pl <- function(wspec, nvoice)
#########################################################################
#      wspec.pl
#      ----------
#       Displays normalized log of wavelet spectrum
#
#       input:
#       ------
#	 wspec: wavelet spectrum.
#	 nvoice: number of voices.
#
#########################################################################
{
  plot.ts(log(wspec, base=2^(2/nvoice)))
  title("log(wavelet spectrum)", xlab="log(scale)", ylab="V(a)")
  cat(" ")
}

#########################################################################
#      $Log: Gabor.S,v $
#########################################################################
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################





cgt <- function(input, nvoice, freqstep = (1/nvoice),
                scale = 1, plot = TRUE)
#########################################################################
#       cgt:   
#       ---
#        continuous Gabor transform function:
# 	  compute the continuous Gabor transform with gaussian window.
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#	 nvoice: number of frequency bands
#        freqstep: sampling rate for the frequency axis
#        scale: size of the window
#	 plot: if set to TRUE, displays the modulus of cwt on the graphic
#		device.
#
#       output:
#       -------
#        output: continuous (complex) gabor transform
#
#########################################################################
{
   oldinput <- input
   isize <- length(oldinput)

   tmp <- adjust.length(oldinput)
   input <- tmp$signal
   newsize <- length(input)

   pp <- nvoice
   Routput <- matrix(0, newsize, pp)
   Ioutput <- matrix(0, newsize, pp)
   output <- matrix(0, newsize, pp)
   dim(Routput) <- c(pp * newsize, 1)
   dim(Ioutput) <- c(pp * newsize, 1)
   dim(input) <- c(newsize, 1)


   z <- .C("Sgabor",
           as.double(input),
           Rtmp = as.double(Routput),
           Itmp = as.double(Ioutput),
           as.integer(nvoice),
           as.double(freqstep),
           as.integer(newsize),
           as.double(scale),
           PACKAGE="Rwave")

   Routput <- z$Rtmp
   Ioutput <- z$Itmp
   dim(Routput) <- c(newsize, pp)
   dim(Ioutput) <- c(newsize, pp)

   output <- Routput[1:isize,] + 1i*Ioutput[1:isize,]
   if(plot) {
      image(1:isize, seq(0, nvoice*freqstep/2, length=nvoice),
            Mod(output), xlab="Time", ylab="Frequency")
      title("Gabor Transform Modulus")
   }
   output
}



vgt <- function(input, frequency, scale, plot = FALSE)
#########################################################################
#      vgt:   
#      ---
#       continuous Gabor transform on one frequency:
# 	 compute the continuous Gabor transform with (complex-valued)
#	 gaussian window
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#        frequency: value of the frequency
#        scale: size of the window
#	 plot: if set to TRUE, plotss the real part of cgt on the graphic
#		device.
#
#       output:
#       -------
#        Routput + i Ioutput: voice gabor transform (complex 1D array)
#
#########################################################################
{
   oldinput <- input
   isize <- length(oldinput)

   tmp <- adjust.length(oldinput)
   input <- tmp$signal
   newsize <- length(input)

   Routput <- numeric(newsize)
   Ioutput <- numeric(newsize)
   dim(input) <- c(newsize,1)

   z <- .C("Svgabor",
            as.double(input),
            Rtmp = as.double(Routput),
            Itmp = as.double(Ioutput),
            as.double(frequency),
            as.integer(newsize),
            as.double(scale),
           PACKAGE="Rwave")

   Routput <- z$Rtmp
   Ioutput <- z$Itmp
   if(plot==TRUE) {
      plot.ts(Re(z$tmp));
      title("Real part of Gabor transform");
   }

   Routput[1:isize] + 1i*Ioutput[1:isize]
}



gabor <- function(sigsize, location, frequency, scale)
#########################################################################
#       gabor:   
#       ------
#        Generates a Gabor for given location and frequency
#
#       input:
#       ------
#        sigsize: signal size (dimension of the array)
#        location: location of the wavelet
#        frequency: value of the frequency
#        scale: size of the window
#
#       output:
#       -------
#        z$gabor.r + z$gabor.i * i: gabor (complex 1D array
#          of size sigsize)
#
#########################################################################
{
   gabor.r <- numeric(sigsize)
   gabor.i <- numeric(sigsize)


   z <- .C("gabor_time",
            as.double(frequency),
            as.double(scale),
            as.integer(location),
            gabor.r = as.double(gabor.r),
            gabor.i = as.double(gabor.i),
            as.integer(sigsize),
           PACKAGE="Rwave")

   z$gabor.r + 1i*z$gabor.i
}


vecgabor <- function(sigsize, nbnodes, location, frequency, scale)
#########################################################################
#       vecgabor:   
#       --------
#        Generates Gabor functions for given locations and frequencies
#	 on a ridge.
#
#       input:
#       ------
#        sigsize: signal size (dimension of the array)
#        nbnodes: number of ridge samples
#        location: b coordinates of the ridge samples
#        frequency: acoordinates of the ridge samples
#        scale: size of the window
#
#       output:
#       -------
#        z$gabor.r + z$gabor.i * i: 2D array containing the gabor
#           functions located on the ridge
#
#########################################################################
{

   
   gabor.r <- numeric(nbnodes * sigsize)
   gabor.i <- numeric(nbnodes * sigsize)


   z <- .C("vgabor_time",
           as.double(frequency),
           as.double(scale),
           as.integer(location),
           gabor.r = as.double(gabor.r),
           gabor.i = as.double(gabor.i),
           as.integer(sigsize),
           as.integer(nbnodes),
           PACKAGE="Rwave")

   z$gabor.r + 1i*z$gabor.i
}

#########################################################################
#      $Log: Crc_Rec.S,v $
# Revision 1.2  1995/04/05  18:56:55  bruno
# *** empty log message ***
#
# Revision 1.1  1995/04/02  01:04:16  bruno
# Initial revision
#
#
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################


#########################################################################
#
#	Functions to reconstruct a signal from the output of
#	 the crazy climber algorithm.
#
#########################################################################

crcirrec <- function(siginput, inputwt, beemap, noct, nvoice, compr,
                     minnbnodes = 2, w0 = 2*pi, bstep = 5, ptile = .01,
                     prob = 0.8, epsilon = .5, fast = FALSE, para = 0,
                     real = FALSE, plot=1)
#########################################################################
#     crcirrec:
#     -------
#      Reconstruction of a real valued signal from ridges found by 
#      crazy climbers on a wavelet transform (sampled irregularly).
#
#      input:
#      ------
#      siginput: input signal
#      inputwt: continuous wavelet transform (output of cwt)
#      beemap: output of crazy climber algorithm
#      noct: number of octaves (powers of 2)
#      nvoice: number of different scales per octave
#      compr: subsampling rate for the ridge
#      bstep: used for the chaining
#      ptile: 
#      epsilon: coeff of the Q2 part of reconstruction kernel
#      fast: if set to TRUE, computes the Q2 kernel by Riemann sums
#            if not, uses a Romberg adaptive step quadrature.
#      para:
#      plot: plot the original and reconstructed signal in display
#      prob: the percentile to keep 
#
#      output:
#      -------
#      rec: reconstructed signal
#      ordered: image of the ridges (with different colors)
#      comp: 2D array containing the signals reconstructed from ridges
#
#########################################################################
{
  tmp <- cfamily(beemap,bstep,ptile=ptile)
  image(tmp$ordered)
  chain <- tmp$chain
  nbchain <- tmp$nbchain
  ordered <- tmp$ordered
  sigsize <- length(siginput)
  rec <- numeric(sigsize)
  plnb <- 0
  
  par(mfrow=c(1,1))
  plot.ts(siginput)
  title("Original signal")
  
  tmp <- matrix(0,nbchain,length(siginput))
  
  totnbnodes <- 0
  idx <- numeric(nbchain)	
  p <- 0
  
  for (j in 1:nbchain){
    phi.x.min <- 2 * 2^(chain[j,3]/nvoice)
    if (chain[j,2] > (para*phi.x.min) ){ 
      
      cat("Chain number",j)
      
      phi.x.max <- 2 * 2^(chain[j,(2+chain[j,2])]/nvoice)
      x.min <- chain[j,1]
      x.max <- chain[j,1] + chain[j,2] - 1
      x.min <- x.min - round(para * phi.x.min)
      x.max <- x.max + round(para * phi.x.max)
      
      tmp2 <- irregrec(siginput[chain[j,1]:(chain[j,1]+chain[j,2]-1)],
                       inputwt[chain[j,1]:(chain[j,1]+chain[j,2]-1),],
                       chain[j,3:(chain[j,2]+2)], compr,noct,nvoice,
                       epsilon, w0 = w0 , prob = prob, fast = fast,
                       para = para, minnbnodes = minnbnodes, real = real);

      totnbnodes <- totnbnodes + tmp2$nbnodes
      
      np <- length(tmp2$sol)
      start <- max(1,x.min)
      end <- min(sigsize,x.min+np-1)
      start1 <- max(1,2-x.min)
      end1 <- min(np, sigsize +1 - x.min)
      end <- end1 - start1 + start
      rec[start:end] <- rec[start:end]+tmp2$sol[start1:end1]
      
      plnb <- plnb + 1
      p <- p + 1
      idx[p] <- j
    }
  }
  
  if(plot == 1) {
    par(mfrow=c(2,1))
    par(cex=1.1)
    plot.ts(siginput)
    title("Original signal")
    title("Reconstructed signal")
  }
  else if (plot == 2) {
    par(mfrow=c(plnb+2,1))
    par(mar=c(2,4,4,4))
    par(cex=1.1)
    par(err=-1)
    plot.ts(siginput)
    title("Original signal")
    
    for (j in 1:p)
      plot.ts(tmp[idx[j],])
    
    plot.ts(Re(rec))	
    title("Reconstructed signal")
   }

  cat("Total number of ridge samples used: ",totnbnodes,"\n")
  par(mfrow=c(1,1))
  list(rec=rec, ordered=ordered, chain = chain, comp=tmp)
}

crcirgrec <- function(siginput, inputgt, beemap, nvoice, freqstep, scale,
                      compr, prob = 0.8, bstep = 5, ptile = 0.01,
                      epsilon = 0.5, fast = TRUE, para = 0,
                      minnbnodes = 3, hflag = FALSE, plot = 2, real = FALSE)
#########################################################################
#     crcirgrec:
#     ----------
#      Reconstruction of a real valued signal from ridges found by 
#      crazy climbers on the gabor transform (irregularly sampled).
#
#      input:
#      ------
#      siginput: input signal
#      inputgt: continuous gabor transform (output of cgt)
#      beemap: output of crazy climber algorithm
#      nvoice: number of different frequencies
#      freqstep: difference between two consecutive frequencies
#      scale: scale of the window
#      compr: subsampling rate for the ridge
#      bstep: used for the chaining
#      ptile: 
#      epsilon: coeff of the Q2 part of reconstruction kernel
#      fast: if set to TRUE, computes the Q2 kernel by Riemann sums
#            if not, uses a Romberg adaptive step quadrature.
#      para:
#      prob: percentile to keep 
#      minnbnodes: minimal number of nodes for a sampled ridge.
#      hflag: if set to FALSE, uses the identity as first term
#             in the reconstruction kernel. If not, uses Q1 instead. 
#      plot: if set to 1, displays the signal, the components, and
#            signal and reconstruction one after another. If set to
#            2, displays the signal, the components, and the
#            reconstruction on the same page. Else, no plot.
#      real: if set to true, uses only real constraints.
#
#      output:
#      -------
#      rec: reconstructed signal
#      ordered: image of the ridges (with different colors)
#      comp: 2D array containing the signals reconstructed from ridges
#
#########################################################################
{
  tmp <- cfamily(beemap,bstep,ptile=ptile)
  image(tmp$ordered)
  chain <- tmp$chain
  nbchain <- tmp$nbchain
  ordered <- tmp$ordered
  sigsize <- length(siginput)
  rec <- numeric(sigsize)
  plnb <- 0
  
  par(mfrow=c(1,1))
  plot.ts(siginput, main="Original signal")
  
  totnbnodes <- 0
  tmp <- matrix(0,nbchain,length(siginput))
  for (j in 1:nbchain){
    if (chain[j,2] > scale){
      nbnodes <- round(chain[j,2]/compr)
      if(nbnodes < minnbnodes)
        nbnodes <- minnbnodes
      
      totnbnodes <- totnbnodes + nbnodes
      
      cat("Chain number", j)
      
      phi.x.min <- scale
      phi.x.max <- scale
      x.min <- chain[j,1]
      x.max <- chain[j,1] + chain[j,2] - 1
      x.min <- x.min - round(para * phi.x.min)
      x.max <- x.max + round(para * phi.x.max)
      x.inc <- 1
      np <- as.integer((x.max-x.min)/x.inc) + 1
      
      tmp2 <- girregrec(siginput[chain[j,1]:(chain[j,1]+chain[j,2]-1)],
                        inputgt[chain[j,1]:(chain[j,1]+chain[j,2]-1),],
                        chain[j,3:(chain[j,2]+2)], nbnodes, nvoice,
                        freqstep, scale, epsilon, fast, prob = prob,
                        para = para, hflag = hflag, real = real)

      start <- max(1,x.min)
      end <- min(sigsize,x.min+np-1)
      start1 <- max(1,2-x.min)
      end1 <- min(np, sigsize +1 - x.min)
      end <- end1 - start1 + start
      rec[start:end] <- rec[start:end]+tmp2$sol[start1:end1]
      tmp[j,start:end] <- tmp2$sol[start1:end1]
      
      plnb <- plnb + 1
      plot.ts(tmp[j,])
    }
    
  }

  if(plot == 1){
    par(mfrow=c(2,1))
    par(cex=1.1)
    plot.ts(siginput, main="Original signal")
    plot.ts(rec, main="Reconstructed signal")
   }
  else if (plot == 2) {
    par(mfrow=c(plnb+2,1))
    par(mar=c(2,4,4,4))
    par(cex=1.1)
    par(err=-1)
    plot.ts(siginput, main="Original signal")
    
    for (j in 1:nbchain)
      plot.ts(tmp[j,])
        
    plot.ts(rec, main="Reconstructed signal")
  }
  
  cat("Total number of ridge samples used: ",totnbnodes,"\n")
  par(mfrow=c(1,1))
  list(rec=rec, ordered=ordered,chain = chain, comp = tmp)
}

#########################################################################
#      $Log: gRidge_Recons.S,v $
# Revision 1.2  1995/04/05  18:56:55  bruno
# *** empty log message ***
#
# Revision 1.1  1995/04/02  01:04:16  bruno
# Initial revision
#
#
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  University of California, Irvine             
#                  All right reserved                           
#########################################################################




girregrec <- function(siginput, gtinput, phi, nbnodes, nvoice,
	freqstep, scale, epsilon = 0.5,fast = FALSE, prob= 0.8, plot = FALSE,
	para = 0, hflag = FALSE, real = FALSE, check = FALSE)
#########################################################################
#     girregrec:
#     ---------
#      Reconstruction of a real valued signal from a (continuous) 
#      Gabor ridge (uses a irregular sampling of the ridge)
#
#      input:
#      -------
#      siginput: input signal
#      gtinput: Continuous gabor transform (output of cgt)
#      phi: (unsampled) ridge
#      nbnodes: number of nodes used for the reconstruction.
#      nvoice: number of different scales per octave
#      freqstep: sampling rate for the frequency axis
#      epsilon: coeff of the Q2 term in reconstruction kernel
#      fast: if set to TRUE, the kernel is computed using Riemann
#           sums instead of Romberg's quadrature
#      plot: if set to TRUE, displays original and reconstructed signals
#      para: no comment !
#      prob: sampling (irregularly) at the places of the ridge where their lambdas 
#            are more than prob in lambda distribution.
#      hflag: 
#      real: if set to TRUE, only uses constraints on the real part
#            of the transform for the reconstruction.
#      check: if set to TRUE, computes the wavelet transform of the
#            reconstructed signal
#      minnbnodes: minimum number of nodes for the reconstruction
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#      solskel: wavelet transform of sol, restricted to the ridge
#      inputskel: wavelet transform of signal, restricted to the ridge
#      Q2: second part of the reconstruction kernel
#########################################################################
{

#
# first performing regular sampling
#

   tmp <- RidgeSampling(phi,nbnodes)

   node <- tmp$node
   phinode <- tmp$phinode

   phi.x.min <- scale
   phi.x.max <- scale
   
   x.min <- node[1]
   x.max <- node[length(node)]
   x.max <- x.max + round(para * phi.x.max)
   x.min <- x.min - round(para * phi.x.min)

   node <- node - x.min + 1
   
   x.inc <- 1
   np <- as.integer((x.max-x.min)/x.inc)+1

   cat(" (np:",np,")")

   if(epsilon == 0)
       Q2 <- 0
   else {
      if (fast == FALSE)
	Q2 <- gkernel(node,phinode,freqstep,scale,x.min = x.min, x.max = x.max)
      else
	Q2 <- fastgkernel(node,phinode,freqstep,scale,x.min = x.min,
		x.max = x.max)
      }
   cat(" kernel;")

# Generating the Q1 term in reconstruction kernel
   if (hflag == TRUE)
      one <- gsampleOne(node,scale,np)
   else{
      one <- numeric(np)
      one[] <- 1
   }

   if (epsilon !=0 ){
     Q <-  epsilon * Q2
     for(j in 1:np)
        Q[j,j] <- Q[j,j] + one[j]
     Qinv <- solve(Q)
    }
    else{
       Qinv <-  1/one
    }

   tmp2 <- gridrec(gtinput,node,phinode,nvoice,
	freqstep,scale,Qinv,epsilon,np, real = real, check = check)

# 
# Now perform the irregular sampling 
#  

   tmp <- RidgeIrregSampling(phinode, node, tmp2$lam, prob)

   node <- tmp$node
   phinode <- tmp$phinode

   phi.x.min <- scale
   phi.x.max <- scale
   
   x.min <- node[1]
   x.max <- node[length(node)]
   x.max <- x.max + round(para * phi.x.max)
   x.min <- x.min - round(para * phi.x.min)

   node <- node - x.min + 1
   
   x.inc <- 1
   np <- as.integer((x.max-x.min)/x.inc)+1

   cat(" (np:",np,")")

   if(epsilon == 0)
       Q2 <- 0
   else {
      if (fast == FALSE)
	Q2 <- gkernel(node,phinode,freqstep,scale,x.min = x.min, x.max = x.max)
      else
	Q2 <- fastgkernel(node,phinode,freqstep,scale,x.min = x.min,
		x.max = x.max)
      }
   cat(" kernel;")

# Generating the Q1 term in reconstruction kernel
   if (hflag == TRUE)
      one <- gsampleOne(node,scale,np)
   else{
      one <- numeric(np)
      one[] <- 1
   }


   if (epsilon !=0 ){
      Q <-  epsilon * Q2
      for(j in 1:np)
         Q[j,j] <- Q[j,j] + one[j]
      Qinv <- solve(Q)
   }
   else{
      Qinv <-  1/one
    }

   tmp2 <- gridrec(gtinput,node,phinode,nvoice,
	freqstep,scale,Qinv,epsilon,np, real = real, check = check)


   if(plot == TRUE){
      par(mfrow=c(2,1))
      plot.ts(Re(siginput))
      title("Original signal")
      plot.ts(Re(tmp2$sol))
      title("Reconstructed signal")
   }

   list(sol=tmp2$sol,A=tmp2$A,lam=tmp2$lam,dualwave=tmp2$dualwave,
	gaborets=tmp2$gaborets, solskel=tmp2$solskel,
	inputskel = tmp2$inputskel, Q2 = Q2)

}




RidgeIrregSampling <- function(phinode, node, lam, prob)
#########################################################################
#    RidgeSamplingData:
#    -----------------
#      Given a ridge phi (for the Gabor transform), and lam returns a 
#        (data-driven) subsampled version of length nbnodes.
#
#      Input:
#      ------
#      phinode: ridge at node
#      lam : vector of 2 * number of regular sampled node
#      prob : the percentage of lam to be preserved
#
#      Output:
#      -------
#      node: time coordinates of the ridge sampled by lambda
#      phinode: frequency coordinates of the ridge sampled by lambda
#
#########################################################################
{
   nbnodes <- length(node)   
   mlam <- numeric(nbnodes)
   for(j in 1:nbnodes) 
     mlam[j] <- Mod(lam[j] + 1i*lam[nbnodes + j])

   pct <- quantile(mlam,prob)

   count <- sum(mlam > pct)

   newnode <- numeric(count)
   newphinode <- numeric(count)

   count <- 0
   for(j in 1:nbnodes) {
     if(mlam[j] > pct) {
        newnode[count+1] <- node[j]
        newphinode[count+1] <- phinode[j]             
        count <- count + 1
     }
   }

   list(node = newnode,phinode = newphinode, nbnodes = count)
}

#shift fft 1D data
#-----------------

fftshift <- function(x) {
    lng <- length(x)
    y <- numeric(lng)
    y[1:(lng/2)] <- x[(lng/2+1):(lng)]
    y[(lng/2+1):lng] <- x[1:(lng/2)]
    y
}


#b727 <- matrix(scan("b727s.dat"),ncol=512,byrow=TRUE)
#b727 <- matrix(scan("b727r.dat"),ncol=256,byrow=TRUE)

#ncol <- dim(b727)[2]/2
#b727r<- b727[,-1+2*(1:ncol)]   
#b727i<- b727[,2*(1:ncol)]       

#B727 <- t(Conj(complex(real=b727r, imag=b727i)))
#nrow <- dim(B727)[1]
#ncol <- dim(B727)[2]

#Generating the original image
#-----------------------------
#* apply fftshift twice to swap the center of the matrix


#o727 <- t(apply(apply(B727,2,fftshift),1,fftshift))
#o727 <- apply(o727,2,fft)
#o727 <- t(apply(apply(o727,2,fftshift),1,fftshift))



#*** only for display to compare with matlab output
#image(Mod(t(o727)))

#Applying Gabor Transform to ...
#-------------------------------
#gtime <- 100
#scale <- 50

#BB727 <- B727
#cgt727 <- array(0+0i,c(ncol,nrow,gtime))
#for(k in 1:ncol) cgt727[k,,] <-
#complex(real=cgt(Re(BB727[,k]),gtime,2/gtime,scale,plot=FALSE),imag=cgt(Im(BB727[,k]),gtime,2/gtime,scale,plot=FALSE))

#image(apply(apply(Mod(cgt727),c(1,3),mean),1,fftshift))


#* The following tow S-routine concludes our Radar experiments
#-------------------------------------------------------------
#b727 <- matrix(scan("b727s.dat"),ncol=512,byrow=TRUE)
#b727 <- matrix(scan("b727r.dat"),ncol=256,byrow=TRUE)

#Generating the original image
#-----------------------------

#e.g. B727 <- showRadar(b727)

showRadar<- function(x) {
   ncol <- dim(x)[2]/2
   xr<- x[,-1+2*(1:ncol)]   
   xi<- x[,2*(1:ncol)]       

   y <- t(Conj(xr + 1i*xi))

   oy <- t(apply(apply(y,2,fftshift),1,fftshift))
   oy <- apply(oy,2,fft)
   oy <- t(apply(apply(oy,2,fftshift),1,fftshift))
   image(Mod(t(oy)))
   oy
}

#Enhancing Radar Image by Gabor Transform
#----------------------------------------


#gtime <- 128
#scale <- 50

#e.g. B727 <- cgtRadar(b727,gtime,scale)
#e.g. 
#     ncol <- dim(b727)[2]/2
#     b727r<- b727[,-1+2*(1:ncol)]   
#     b727i<- b727[,2*(1:ncol)]       

#     b727 <- t(Conj(complex(real=b727r, imag=b727i)))
#     B727 <- cgtRadar(b727,gtime,scale,flag=FALSE)

cgtRadar <- function(x,gtime,scale,flag=TRUE) {

   y <- x

   if(flag) {
     ncol <- dim(x)[2]/2
     xr<- x[,-1+2*(1:ncol)]   
     xi<- x[,2*(1:ncol)]       

     y <- t(Conj(xr + 1i*xi))
   }

   nrow <- dim(y)[1]
   ncol <- dim(y)[2]
   cgty <- array(0+0i,c(ncol,nrow,gtime))
   for(k in 1:ncol) cgty[k,,] <-
     cgt(Re(y[,k]),gtime,2/gtime,scale,plot=FALSE) + 1i*cgt(Im(y[,k]),gtime,2/gtime,scale,plot=FALSE)

   oy <- apply(apply(Mod(cgty),c(1,3),mean),1,fftshift)
   for(k in 1:nrow) cgty[,k,] <- apply(cgty[,k,],1,fftshift)
   image(oy)
   list(output=oy,cgtout=cgty)
}

#########################################################################
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################


#########################################################################
#
#	Functions to reconstruct a signal from the output of
#	 the pca climber algorithm.
#
#########################################################################




pcarec <- function(siginput,inputwt, beemap, orientmap, noct, nvoice, compr,
	maxchnlng=as.numeric(dim(beemap)[1])+10,minnbnodes = 2, 
	w0 = 2*pi, nbchain=100,bstep = 1,ptile =.01,para=5,plot=2,check=FALSE)
#########################################################################
#     pcarec:
#     -------
#      Reconstruction of a real valued signal from ridges found by 
#      pca climbers on a wavelet transform.
#
#      input:
#      ------
#      siginput: input signal
#      inputwt: continuous wavelet transform (output of cwt)
#      beemap: output of pca climber algorithm
#      orientmap: principle direction of pca climber
#      noct: number of octaves (powers of 2)
#      nvoice: number of different scales per octave
#      compr: subsampling rate for the ridge
#      maxchnlng: maxlength of a chain of ridges (a,b)
#      bstep: used for the chaining
#      ptile: 
#      para:
#      plot: plot the original and reconstructed signal in display
#      check: check whether the reconstructed signal keeps the values
#             at ridges
#
#      output:
#      -------
#      rec: reconstructed signal
#      ordered: image of the ridges (with different colors)
#      comp: 2D array containing the signals reconstructed from ridges
#
#########################################################################
{

   tmp <- pcafamily(beemap,orientmap,maxchnlng=maxchnlng,bstep=bstep,nbchain=nbchain,ptile=ptile)
   chain <- tmp$chain
   nbchain <- tmp$nbchain
   ordered <- tmp$ordered
   sigsize <- length(siginput)
   rec <- numeric(sigsize)
   plnb <- 0

   if(plot != FALSE){
     par(mfrow=c(2,1))
     plot.ts(siginput)
     title("Original signal")
     image(tmp$ordered)
     title("Chained Ridges")
   }

   sol <- matrix(0,nbchain,sigsize)

   totnbnodes <- 0
   idx <- numeric(nbchain)	
   p <- 0

   if(check==TRUE) {
      inputskel <- matrix(0+0i,nbchain,sigsize)
      solskel <- matrix(0+0i, nbchain, sigsize)
   }

   for (j in 1:nbchain){
      
      sol[j,] <- 0
      nbnode <- chain[j,1]
      bnode <- numeric(nbnode)
      anode <- numeric(nbnode)
      for(k in 1:nbnode) {
        anode[k] <- chain[j,2*k]
        bnode[k] <- chain[j,2*k+1]
      }
      cat("Chain number",j,"\n")

      tmp2 <- pcaregrec(siginput[min(bnode):max(bnode)],
          inputwt[min(bnode):max(bnode),],
          anode,bnode,compr,noct,nvoice, 
          w0 = w0, para = para,minnbnodes = minnbnodes, check=check);

      if(is.list(tmp2)==TRUE) {
        totnbnodes <- totnbnodes + tmp2$nbnodes
        if((sigsize-min(bnode)) > (length(tmp2$sol)-tmp2$bstart)){
          np <- length(tmp2$sol) - tmp2$bstart
          sol[j,min(bnode):(np+min(bnode))]<-tmp2$sol[tmp2$bstart:length(tmp2$sol)]
        }
        else {
	  np <- sigsize - min(bnode)
          sol[j,min(bnode):sigsize]<-tmp2$sol[tmp2$bstart:(np+tmp2$bstart)]
        }
        if(min(bnode) < tmp2$bstart) {
          np <- min(bnode)-1
          sol[j,1:min(bnode)]<-tmp2$sol[(tmp2$bstart-np):(tmp2$bstart)]
        }          
        else {
          np <- tmp2$bstart-1
          sol[j,(min(bnode)-np):min(bnode)]<-tmp2$sol[1:(tmp2$bstart)]
        }

        if(check==TRUE) {
           bridge <- tmp2$bnode
           aridge <- tmp2$anode
           wtsol <- cwt(sol[j,],noct,nvoice)
           for(k in 1:length(bridge)) solskel[j,k] <- wtsol[bridge[k],aridge[k]]
           for(k in 1:length(bridge)) inputskel[j,k] <- inputwt[bridge[k],aridge[k]]
        }
        rec <- rec+sol[j,]
      }
      plnb <- plnb + 1
      p <- p + 1
      idx[p] <- j
   }

   if(plot == 1){
      par(mfrow=c(2,1))
      par(cex=1.1)
      plot.ts(siginput)
      title("Original signal")
      plot.ts(Re(rec))
	
      title("Reconstructed signal")
   }
   else if (plot == 2){
      par(mfrow=c(plnb+2,1))
      par(mar=c(2,4,4,4))
      par(cex=1.1)
      par(err=-1)
      plot.ts(siginput)
      title("Original signal")

      for (j in 1:p)
        plot.ts(sol[idx[j],]);
      plot.ts(Re(rec))	
      title("Reconstructed signal")
   }

   cat("Total number of ridge samples used: ",totnbnodes,"\n")

   par(mfrow=c(1,1))
   if(check==TRUE) list(rec=rec,ordered=ordered,chain=chain,
                     comp=tmp,inputskel=inputskel,solskel=solskel,lam=tmp2$lam)
   else list(rec=rec, ordered=ordered,chain=chain,comp=tmp)
}

PcaRidgeSampling <- function(anode, bnode, compr)
#########################################################################
#    PcaRidgeSampling:
#    ----------------
#      Given a ridge (a,b)(for the Gabor transform), returns a 
#        (regularly) subsampled version of length nbnodes.
#
#      Input:
#      ------
#      anode: scale coordinates of the (unsampled) ridge
#      bnode: time coordinates of the (unsampled) ridge
#      compr: compression ratio to obtain from the ridge
#
#      Output:
#      -------
#      bnode: time coordinates of the ridge samples (from 1 to nbnodes
#             step by compr)
#      anode: scale coordinates of the ridge samples
#      nbnode: number of node sampled
#
#########################################################################
{
   # number of node at the ridge
   nbnode <- length(anode)

   # compr to be integer
   compr <- as.integer(compr)
   if(compr < 1) compr <- 1

   # sample rate is compr at the ridge
   k <- 1
   count <- 1
   while(k < nbnode) {
     anode[count] <- anode[k]
     bnode[count] <- bnode[k]
     k <- k + compr 
     count <- count + 1
   }

   anode[count] <- anode[nbnode]
   bnode[count] <- bnode[nbnode]
   
   aridge <- numeric(count)
   bridge <- numeric(count)
   aridge <- anode[1:count]
   bridge <- bnode[1:count]
   
   list(anode = aridge, bnode = bridge, nbnodes = count)
}


pcaregrec <- function(siginput,cwtinput,anode,bnode,compr,noct,nvoice,
	w0 = 2*pi, plot = FALSE, para = 5, minnbnodes = 2, check=FALSE)
#########################################################################
#     pcaregrec:
#     ---------
#      Reconstruction of a real valued signal from a (continuous) ridge
#      (uses a regular sampling of the ridge)
#
#      input:
#      -------
#      siginput: input signal
#      cwtinput: Continuous wavelet transform (output of cwt)
#      anode: the scale coordinates of the (unsampled) ridge
#      bnode: the time coordinates of the (unsampled) ridge
#      compr: subsampling rate for the wavelet coefficients (at scale 1)
#      noct: number of octaves (powers of 2)
#      nvoice: number of different scales per octave
#      epsilon: coeff of the Q2 term in reconstruction kernel
#      w0: central frequency of Morlet wavelet
#      fast: if set to TRUE, the kernel is computed using Riemann
#           sums instead of Romberg's quadrature
#      plot: if set to TRUE, displays original and reconstructed signals
#      para: constant for extending the support of reconstructed signal
#            outside the ridge. 
#      check: if set to TRUE, computes the wavelet transform of the
#            reconstructed signal
#      minnbnodes: minimum number of nodes for the reconstruction
#      real: if set to TRUE, only uses constraints on the real part
#            of the transform for the reconstruction.
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#      Q2: second part of the reconstruction kernel
#      nbnodes: number of nodes used for the reconstruction.
#
##########################################################################
{

#  Generate Sampled ridge
#   tmp <- wRidgeSampling(anode,compr,nvoice)
#   bnode <- tmp$node
#   anode <- tmp$phinode
#   nbnodes <- tmp$nbnodes

   tmp <- PcaRidgeSampling(anode, bnode, compr)
   bnode <- tmp$bnode
   anode <- tmp$anode
   nbnodes <- tmp$nbnodes

   cat("Sampled nodes (b,a): \n")
   for(j in 1:nbnodes) cat("(",bnode[j],anode[j],")")
   cat("\n")

   if(nbnodes < minnbnodes){
      cat(" Chain too small\n")
      NULL
   }
   else {

    a.min <- 2 * 2^(min(anode)/nvoice)
    a.max <- 2 * 2^(max(anode)/nvoice)
    b.min <- min(bnode)
    b.max <- max(bnode)
    b.max <- (b.max-b.min+1) + round(para * a.max)
    b.min <- (b.min-b.min+1) - round(para * a.max)

# location 2-b.min is the place where the min(bnode) is.
# The position at 2-b.min of returned signal is aligned to 
# the position at min(b.node) for the reconstruction

    bnode <- bnode-min(bnode)+2-b.min
    b.inc <- 1
    np <- as.integer((b.max - b.min)/b.inc) +1
    cat("(size:",np,",",nbnodes,"sampled nodes):\n")

    # Generating the Q2 term in reconstruction kernel
    Q2 <- 0
	
    # Generating the Q1 term in reconstruction kernel
    one <- numeric(np)
    one[] <- 1
    Qinv <-  1/one

    tmp2 <- pcaridrec(cwtinput,bnode,anode,noct,nvoice,
              Qinv,np,w0=w0,check=check)

    if(plot == TRUE){
       par(mfrow=c(2,1))
       plot.ts(Re(siginput))
       title("Original signal")
       plot.ts(Re(tmp2$sol))
       title("Reconstructed signal")
    }
    lam <- tmp2$lam
#    if(check==TRUE) {
#      N <- length(lam)/2
#      mlam <- numeric(N)
#      for(j in 1:N)
#         mlam[j] <- Mod(lam[j] + i * lam[N + j])
#      npl(2)
#      plot.ts(lam,xlab="Number",ylab="Lambda Value")
#      title("Lambda Profile")
#      plot.ts(sort(mlam),xlab="Number",ylab="Mod of Lambda")
#    }
    list(sol = tmp2$sol,A = tmp2$A,
          lam = tmp2$lam, dualwave = tmp2$dualwave, 
          morvelets = tmp2$morvelets,pQ2 = Q2, nbnodes=nbnodes,
          bstart=2-b.min, anode=tmp$anode,bnode=tmp$bnode)
   }
	
}


pcaridrec <- function(cwtinput,bnode,anode,noct,nvoice,Qinv,np,
                      w0 = 2*pi, check = FALSE)
#########################################################################
#     pcaridrec:
#     ---------
#      Reconstruction of a real valued signal from a ridge, given
#       the kernel of the bilinear form.
#
#      input:
#      ------
#      cwtinput: Continuous wavelet transform (output of cwt)
#      bnode: time coordinates of the ridge samples
#      anode: scale coordinates of the ridge samples
#      noct: number of octaves (powers of 2)
#      nvoice: number of different scales per octave
#      Qinv: inverse of the reconstruction kernel
#      epsilon: coefficient of the Q2 term in the reconstruction kernel
#      np: number of samples of the reconstructed signal
#      w0: central frequency of Morlet wavelet
#      check: if set to TRUE, computes the wavelet transform of the
#            reconstructed signal
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      morwave: array of morlet wavelets located on the ridge samples
#      dualwave: array containing the dual wavelets.
#      solskel: wavelet transform of sol, restricted to the ridge
#      inputskel: wavelet transform of signal, restricted to the ridge
#
#########################################################################
{
   # number of sampled nodes in a ridge
   N <- length(bnode)

   aridge <- anode
   bridge <- bnode

   morvelets <- pcamorwave(bridge,aridge,nvoice,np,N)

   cat("morvelets;  ")

   sk <- pcazeroskeleton(cwtinput,Qinv,morvelets,bridge,aridge,N)    

   cat("skeleton.\n")

   solskel <- 0 #not needed if check not done
   inputskel <- 0 #not needed if check not done

   list(sol=sk$sol,A=sk$A,lam=sk$lam,dualwave=sk$dualwave,morvelets=morvelets,
	solskel=solskel,inputskel = inputskel)
}


pcazeroskeleton <- function(cwtinput,Qinv,morvelets,bridge,aridge,N)
#########################################################################
#     pcazeroskeleton:
#     ----------------
#      Computation of the reconstructed signal from the ridge when
#       the epsilon parameter is set to 0.
#
#      input:
#      -------
#      cwtinput: Continuous wavelet transform (output of cwt)
#      Qinv: 1D array (warning: different from skeleton) containing
#            the diagonal of the inverse of reconstruction kernel.
#      morvelets: array of morlet wavelets located on the ridge samples
#      bridge: time coordinates of the ridge samples
#      aridge: scale coordinates of the ridge samples
#      N: number of complex constraints
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#
##########################################################################
{
   tmp1 <- dim(morvelets)[1]
   constraints2 <- dim(morvelets)[2]
   dualwave <- matrix(0,tmp1,constraints2)
   for (j in 1:tmp1) {
      dualwave[j,] <- morvelets[j,]*Qinv[j]
   }
   A <- t(morvelets) %*% dualwave

   rskel <- numeric(2*N)

   if(is.vector(cwtinput) == TRUE) {
     for(j in 1:N) {
      rskel[j] <- Re(cwtinput[aridge[j]])
      rskel[N+j] <- -Im(cwtinput[aridge[j]])
     }
   }
   else {
     for(j in 1:N) {
      rskel[j] <- Re(cwtinput[bridge[j]-bridge[1]+1,aridge[j]])
      rskel[N+j] <- -Im(cwtinput[bridge[j]-bridge[1]+1,aridge[j]])
     }
   }

   B <- SVD(A)
   d <- B$d
   Invd <- numeric(length(d))
   for(j in 1:(2*N))
     if(d[j] < 1.0e-6) 
       Invd[j] <- 0
    else Invd[j] <- 1/d[j]
   lam <- B$v %*% diag(Invd) %*% t(B$u) %*% rskel

   sol <- dualwave%*%lam
   list(lam=lam,sol=sol,dualwave=dualwave,A=A)
}


pcamorwave <- function(bridge, aridge, nvoice, np, N, w0 = 2*pi)
#########################################################################
#     pcamorwave: ( the same function of morwave )
#     -----------
#      Generation of the wavelets located on the ridge.
#
#      input:
#      ------
#      bridge: time coordinates of the ridge samples
#      aridge: scale coordinates of the ridge samples
#      nvoice: number of different scales per octave
#      np: size of the reconstruction kernel
#      N: number of complex constraints
#      w0: central frequency of Morlet wavelet
#
#      output:
#      -------
#      morvelets: array of morlet wavelets located on the ridge samples
#
#########################################################################
{

   morvelets <- matrix(0,np,2*N)

   aridge <-  2 * 2^((aridge - 1)/nvoice)
   tmp <- vecmorlet(np,N,bridge,aridge,w0 = w0)
   dim(tmp) <- c(np,N)
   morvelets[,1:N] <- Re(tmp[,1:N])
   morvelets[,(N+1):(2*N)] <- Im(tmp[,1:N])

#  Another way of generating morvelets
#   dirac <- 1:np
#   dirac[] <- 0
#   for(k in 1:N)  {
#      dirac[bridge[k]] <- 1.0;
#      scale <- 2 * 2^((aridge[k]-1)/nvoice);
#      cwtdirac <- vwt(dirac,scale);
#      morvelets[,k] <- Re(cwtdirac);
#      morvelets[,k+N] <- Im(cwtdirac);
#      dirac[] <- 0
#    }

#  Still another way of generating morvelets
#   for(k in 1:N)  {
#      scale <- 2 * 2^((aridge[k]-1)/nvoice);
#      tmp <- morlet(np,bridge[k],scale)/sqrt(2*pi);
#      morvelets[,k] <- Re(tmp);
#      morvelets[,k+N] <- Im(tmp);
#    }

    morvelets
}

#########################################################################
#      $Log: Crc_Rec.S,v $
#########################################################################
#
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################


#########################################################################
#
#	Functions to reconstruct a signal from the output of
#	 the crazy climber algorithm.
#
#########################################################################

crcrec <- function(siginput, inputwt, beemap, noct, nvoice, compr,
                   minnbnodes = 2, w0 = 2*pi, bstep = 5, ptile = 0.01,
                   epsilon = 0, fast = FALSE, para = 5, real = FALSE,
                   plot = 2)
#########################################################################
#     crcrec:
#     -------
#      Reconstruction of a real valued signal from ridges found by 
#      crazy climbers on a wavelet transform.
#
#      input:
#      ------
#      siginput: input signal
#      inputwt: continuous wavelet transform (output of cwt)
#      beemap: output of crazy climber algorithm
#      noct: number of octaves (powers of 2)
#      nvoice: number of different scales per octave
#      compr: subsampling rate for the ridge
#      bstep: used for the chaining
#      ptile: 
#      epsilon: coeff of the Q2 part of reconstruction kernel
#      fast: if set to TRUE, computes the Q2 kernel by Riemann sums
#            if not, uses a Romberg adaptive step quadrature.
#      para:
#      plot: plot the original and reconstructed signal in display
#
#      output:
#      -------
#      rec: reconstructed signal
#      ordered: image of the ridges (with different colors)
#      comp: 2D array containing the signals reconstructed from ridges
#
#########################################################################
{
  tmp <- cfamily(beemap,bstep,ptile=ptile)
  chain <- tmp$chain
  nbchain <- tmp$nbchain
  ordered <- tmp$ordered
  sigsize <- length(siginput)
  rec <- numeric(sigsize)
  plnb <- 0
  
  if(plot != FALSE) {
    par(mfrow=c(2,1))
    plot.ts(siginput, main="Original signal")
    image(tmp$ordered, main="Chained Ridges")
  }
  
  tmp <- matrix(0,nbchain,length(siginput))
  
  totnbnodes <- 0
  idx <- numeric(nbchain)	
  p <- 0
  
  for(j in 1:nbchain) {
    phi.x.min <- 2 * 2^(chain[j,3]/nvoice)
    if(chain[j,2] > (para*phi.x.min)) { 
      
      cat("Chain number",j)
      
      phi.x.max <- 2 * 2^(chain[j,(2+chain[j,2])]/nvoice)
      x.min <- chain[j,1]
      x.max <- chain[j,1] + chain[j,2] - 1
      x.min <- x.min - round(para * phi.x.min)
      x.max <- x.max + round(para * phi.x.max)
      
      tmp2 <- regrec(siginput[chain[j,1]:(chain[j,1]+chain[j,2]-1)],
                     inputwt[chain[j,1]:(chain[j,1]+chain[j,2]-1),],
                     chain[j,3:(chain[j,2]+2)], compr,noct,nvoice,
                     epsilon, w0 = w0 ,fast = fast, para = para,
                     minnbnodes = minnbnodes, real = real)
      
      if(is.list(tmp2)==TRUE) {
        totnbnodes <- totnbnodes + tmp2$nbnodes
        
        np <- length(tmp2$sol)
        start <- max(1,x.min)
        end <- min(sigsize,x.min+np-1)
        start1 <- max(1,2-x.min)
        end1 <- min(np, sigsize +1 - x.min)
        end <- end1 - start1 + start
        rec[start:end] <- rec[start:end] + tmp2$sol[start1:end1]
        
        tmp[j,start:end] <- Re(tmp2$sol[start1:end1])
      }
      plnb <- plnb + 1
      p <- p + 1
      idx[p] <- j
    }
  }
  
  if(plot == 1) {
    par(mfrow=c(2,1))
    par(cex=1.1)
    plot.ts(siginput, main="Original signal")
    plot.ts(Re(rec), main="Reconstructed signal")
  }
  else {
    if(plot == 2) {
      par(mfrow=c(plnb+2,1))
      par(mar=c(2,0,0,0))
      par(cex=1.1)
      par(err=-1)
      plot.ts(siginput, main="Original signal")
      
      for (j in 1:p)
        plot.ts(tmp[idx[j],])
      plot.ts(Re(rec), main="Reconstructed signal")
    }
  }
  
  cat("Total number of ridge samples used: ", totnbnodes, "\n")
  par(mfrow=c(1,1))
  list(rec=rec, ordered = ordered, chain = chain, comp = tmp)
}

gcrcrec <- function(siginput, inputgt, beemap, nvoice, freqstep, scale,
                    compr, bstep = 5, ptile = .01, epsilon = 0,
                    fast = TRUE, para = 5, minnbnodes = 3,
                    hflag = FALSE, real= FALSE, plot = 2)
#########################################################################
#     gcrcrec:
#     -------
#      Reconstruction of a real valued signal from ridges found by 
#      crazy climbers on the gabor transform.
#
#      input:
#      ------
#      siginput: input signal
#      inputgt: continuous gabor transform (output of cgt)
#      beemap: output of crazy climber algorithm
#      nvoice: number of different frequencies
#      freqstep: difference between two consecutive frequencies
#      scale: scale of the window
#      compr: subsampling rate for the ridge
#      bstep: used for the chaining
#      ptile: 
#      epsilon: coeff of the Q2 part of reconstruction kernel
#      fast: if set to TRUE, computes the Q2 kernel by Riemann sums
#            if not, uses a Romberg adaptive step quadrature.
#      para:
#      minnbnodes: minimal number of nodes for a sampled ridge.
#      hflag: if set to FALSE, uses the identity as first term
#             in the reconstruction kernel. If not, uses Q1 instead. 
#      plot: if set to 1, displays the signal, the components, and
#            signal and reconstruction one after another. If set to
#            2, displays the signal, the components, and the
#            reconstruction on the same page. Else, no plot.
#      real: if set to true, uses only real constraints.
#
#      output:
#      -------
#      rec: reconstructed signal
#      ordered: image of the ridges (with different colors)
#      comp: 2D array containing the signals reconstructed from ridges
#
#########################################################################
{
  tmp <- cfamily(beemap,bstep,ptile=ptile)
  chain <- tmp$chain
  nbchain <- tmp$nbchain
  ordered <- tmp$ordered
  sigsize <- length(siginput)
  rec <- numeric(sigsize)
  plnb <- 0
  
  if(plot != FALSE) {
    par(mfrow=c(2,1))
    plot.ts(siginput, main="Original signal")
    image(tmp$ordered, main="Chained Ridges")
  }
  
  totnbnodes <- 0
  tmp <- matrix(0,nbchain,length(siginput))
  for(j in 1:nbchain) {
    if(chain[j,2] > scale) {
      nbnodes <- round(chain[j,2]/compr)
      if(nbnodes < minnbnodes)
        nbnodes <- minnbnodes
      
      totnbnodes <- totnbnodes + nbnodes
      
      cat("Chain number",j)
      
      phi.x.min <- scale
      phi.x.max <- scale
      x.min <- chain[j,1]
      x.max <- chain[j,1] + chain[j,2] - 1
      x.min <- x.min - round(para * phi.x.min)
      x.max <- x.max + round(para * phi.x.max)
      x.inc <- 1
      np <- as.integer((x.max-x.min)/x.inc) + 1
      
      tmp2 <- gregrec(siginput[chain[j,1]:(chain[j,1]+chain[j,2]-1)],
                      inputgt[chain[j,1]:(chain[j,1]+chain[j,2]-1),],
                      chain[j,3:(chain[j,2]+2)], nbnodes, nvoice,
                      freqstep, scale, epsilon, fast, para = para,
                      hflag = hflag, real = real)

      start <- max(1,x.min)
      end <- min(sigsize,x.min+np-1)
      start1 <- max(1,2-x.min)
      end1 <- min(np, sigsize +1 - x.min)
      end <- end1 - start1 + start
      rec[start:end] <- rec[start:end] + tmp2$sol[start1:end1]
      tmp[j,start:end] <- tmp2$sol[start1:end1]
      
      plnb <- plnb + 1
      plot.ts(tmp[j,])
    }
    
  }
  
  if(plot == 1) {
    par(mfrow=c(2,1))
    par(cex=1.1)
    plot.ts(siginput, main="Original signal")
    plot.ts(rec, main="Reconstructed signal")
  }
  else if (plot == 2) {
    par(mfrow=c(plnb+2,1))
    par(mar=c(2,4,4,4))
    par(cex=1.1)
    par(err=-1)
    plot.ts(siginput, main="Original signal")
    
    for (j in 1:nbchain)
      plot.ts(tmp[j,])
    plot.ts(rec, main="Reconstructed signal")
  }
  
  cat("Total number of ridge samples used: ", totnbnodes, "\n")
  par(mfrow=c(1,1))
  list(rec = rec, ordered = ordered, chain = chain, comp = tmp)
}

scrcrec <- function(siginput, tfinput, beemap, bstep = 5, ptile = 0.01,
                    plot = 2)
#########################################################################
#     scrcrec:
#     --------
#      Simple reconstruction of a real valued signal from ridges found by 
#      crazy climbers.
#
#      input:
#      ------
#      siginput: input signal
#      tfinput: continuous time-frequency transform (output of cwt or cgt)
#      beemap: output of crazy climber algorithm
#      bstep: used for the chaining
#      ptile: 
#      plot: if set to 1, displays the signal, the components, and
#            signal and reconstruction one after another. If set to
#            2, displays the signal, the components, and the
#            reconstruction on the same page. Else, no plot.
#
#      output:
#      -------
#      rec: reconstructed signal
#      ordered: image of the ridges (with different colors)
#      comp: 2D array containing the signals reconstructed from ridges
#
#########################################################################
{
  tmp <- cfamily(beemap,bstep, ptile=ptile)
  chain <- tmp$chain
  nbchain <- tmp$nbchain
  rec <- numeric(length(siginput))
  
  if(plot != FALSE) {
    par(mfrow=c(2,1))
    plot.ts(siginput, main="Original signal")
    image(tmp$ordered, main="Chained Ridges")
  }
  
  npl(1)
  tmp3 <- matrix(0,nbchain,length(siginput))
  rdg <- numeric(dim(tfinput)[1])
  
  for (j in 1:nbchain) {
    bnext <- chain[j,1]
    for(k in 1:chain[j,2]) {
      rdg[bnext] <- chain[j,2+k]
      bnext <- bnext + 1
    }
    tmp3[j,] <- sridrec(tfinput,rdg)
    rec <- rec + tmp3[j,]
    rdg[] <- 0
    ## plot.ts(tmp3[j,])
  }
  
  if(plot <= 2) {
    par(mfrow=c(2,1))
    plot.ts(siginput, main="Original signal")
    plot.ts(rec, main="Reconstructed signal")
  }
  else {
    par(mfrow=c(nbchain+2,1))
    par(mar=rep(2,4))
    par(err=-1)
    plot.ts(siginput, main="Original signal")
    
    for(j in 1:nbchain)
      plot.ts(tmp3[j,],main=j)
      
    plot.ts(rec, main="Reconstructed signal")
  }
  list(rec=rec, ordered=tmp$ordered, chain=tmp$chain, comp=tmp3)
}

#########################################################################
#      $Log: Crazy_Climbers.S,v $
#########################################################################
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################

crc <- function(tfrep, tfspec = numeric(dim(tfrep)[2]), bstep = 3,
                iteration = 10000, rate = .001, seed = -7, nbclimb=10,
                flag.int = TRUE, chain = TRUE, flag.temp = FALSE)
#########################################################################
#  crc:   Time-frequency multiple ridge estimation (crazy climbers)
#  ----
# 	use the crazy climber algorithm to evaluate ridges of
#    	   continuous Time-Frequency transform
#
#      input:
#      ------
# 	tfrep: wavelet or Gabor transform
#	tfspec: additional potential (coming from learning the noise)
#       iteration: number of iterations
#       rate: initial value of the temperature
#       seed: initialization for random numbers generator
#       nbclimb: number of crazy climbers
#       bstep: step size for the climber walk in the time direction
#	flag.int: if set to TRUE, computes the integral on the ridge.
#	chain: if set to TRUE, chains the ridges.
#	flag.temp: if set to TRUE, keeps a constant temperature.
#
#      output:
#      -------
#       beemap: 2D array containing the (weighted or unweighted)
#               occupation measure (integrated with respect to time)
#
#########################################################################
{
  tfspectrum <- tfspec 
  
  d <- dim(tfrep)
  sigsize <- d[1]
  nscale <- d[2]
  beemap <- matrix(0,sigsize,nscale)
  sqmodulus <- Re(tfrep*Conj(tfrep))
  for (k in 1:nscale)
    sqmodulus[,k] <- sqmodulus[,k] - tfspectrum[k]
  dim(beemap) <- c(nscale * sigsize, 1)
  dim(sqmodulus) <- c(nscale * sigsize, 1)

  z <- .C("Sbee_annealing",
          as.double(sqmodulus),
          beemap= as.double(beemap),
          as.double(rate),
          as.integer(sigsize),
          as.integer(nscale),
          as.integer(iteration),
          as.integer(seed),
          as.integer(bstep),
          as.integer(nbclimb),
          as.integer(flag.int),
          as.integer(chain),
          as.integer(flag.temp),
          PACKAGE="Rwave")
  
  beemap <- z$beemap
  dim(beemap) <- c(sigsize,nscale)   
  if(dev.set() != 1) image(beemap)
  beemap
}

cfamily <- function(ccridge, bstep = 1, nbchain = 100, ptile = 0.05)
#########################################################################
#     cfamily:
#     --------
#     chain the ridges obtained by crazy climber.
#
#      input:
#      ------
#       ccridge: unchained ridge (output of Bee_Annealing)
#       bstep: maximal length for a gap in a ridge
#       nbchain: maximum number of chains
#       ptile: relative threshold for the ridges 
#
#      output:
#      ------
#       ordered: ordered map: image containing the ridges
#                (displayed with different colors)
#       chain: 2D array containing the chained ridges, according
#		to the chain data structure:
#		chain[,1]: first point of the ridge
#		chain[,2]: length of the chain
#		chain[,3:(chain[,2]+2)]: values of the ridge
#	nbchain: number of chains.
#
#########################################################################
{
  d <- dim(ccridge)
  sigsize <- d[1]
  nscale <- d[2]
  threshold <- range(ccridge)[2] * ptile
  sz <- sigsize + 2   	
  chain <- matrix(-1,nbchain,sz)
  orderedmap <- matrix(0,sigsize,nscale)	
  
  dim(chain) <- c(nbchain * sz, 1)
  dim(ccridge) <- c(nscale * sigsize, 1)
  dim(orderedmap) <- c(nscale * sigsize, 1)
   
  z <- .C("Scrazy_family",
          as.double(ccridge),
          orderedmap = as.double(orderedmap),
          chain = as.integer(chain),
          chainnb = as.integer(nbchain),
          as.integer(sigsize),
          as.integer(nscale),
          as.integer(bstep),
          as.double(threshold),
          PACKAGE="Rwave")
	
  orderedmap <- z$orderedmap
  chain <- z$chain

  dim(orderedmap) <- c(sigsize,nscale)   
  dim(chain) <- c(nbchain,sz)   
  nbchain <- z$chainnb
  chain <- chain +1
  chain[,2] <- chain[,2]-1
  
  list(ordered = orderedmap, chain = chain, nbchain=nbchain)
}   

crfview <- function(beemap, twod=TRUE)
#########################################################################
#     crfview:
#     --------
#     displays a family of chained ridges
#
#########################################################################
{
  if (twod)
    image(beemap$ordered > 0)
  else {
    Dim <- dim(beemap$ordered)
    matmp <- matrix(0,Dim[1],Dim[2])
    matmp[1,1] <- 1
    image(matmp)
    for (k in 1:beemap$nbchain){
      start <- beemap$chain[k,1]
      end <- start + beemap$chain[k,2]  
      lines(start:(end-1), beemap$chain[k,3:(end-start+2)], type="l")
    }
  }
  title(" Chained Ridges")
  cat("")
}

#########################################################################
#      $Log: WV.S,v $
#########################################################################
#
#               (c) Copyright  1998
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################





WV <- function(input, nvoice, freqstep = (1/nvoice), plot = TRUE)
#########################################################################
#       WV:   
#       ---
#        Wigner-Ville function
# 	  compute the Wigner-Ville transform, without any smoothing
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#	 nvoice: number of frequency bands
#        freqstep: sampling rate for the frequency axis
#	 plot: if set to TRUE, displays the modulus of cwt on the graphic
#		device.
#
#       output:
#       -------
#        output: (complex) Wigner-Ville transform
#
#########################################################################
{
  oldinput <- input
  isize <- length(oldinput)
  
  tmp <- adjust.length(oldinput)
  input <- tmp$signal
  newsize <- length(input)
  
  ## pp <- nvoice
  pp <- newsize
  Routput <- matrix(0, newsize, pp)
  Ioutput <- matrix(0, newsize, pp)
  output <- matrix(0, newsize, pp)
  dim(Routput) <- c(pp * newsize, 1)
  dim(Ioutput) <- c(pp * newsize, 1)
  dim(input) <- c(newsize, 1)
  
  z <- .C("WV",
          as.double(input),
          Rtmp = as.double(Routput),
          Itmp = as.double(Ioutput),
          as.integer(nvoice),
          as.double(freqstep),
          as.integer(newsize),
          PACKAGE="Rwave")
  
  Routput <- z$Rtmp
  Ioutput <- z$Itmp
  dim(Routput) <- c(newsize, pp)
  dim(Ioutput) <- c(newsize, pp)
  
  output <- Routput[1:isize,] + 1i*Ioutput[1:isize,]
  if(plot) {
    image(Mod(output[,1:(isize/2)]),
          xlab="Time", ylab="Frequency")
    title("Wigner-Ville Transform Modulus")
  }
  output
}

#########################################################################
#       $Log: TF_Maxima.S,v $
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################





tfgmax <- function(input, plot = TRUE)
#########################################################################
#  tfgmax:  
#  -------
# 	 Continuous time-frequency transform global maxima:
#          compute the continuous wavelet transform global maxima (for
#    	   fixed position)
#
#      input:
#      ------
# 	input: continuous time-frequency transform (2D array)
#	plot: if set to TRUE, displays the maxima of cwt on the graphic
#          device.
#
#      output:
#      -------
#       output: values of the maxima (1D array)
#       pos: positions of the maxima (1D array)
#       
#########################################################################
{

  sigsize <- dim(input)[1]
  pp <- dim(input)[2]
  input1 <- input
	
  output <- matrix(0,sigsize,pp)
  dim(input1) <- c(sigsize * pp,1)
  dim(output) <- c(sigsize * pp,1)
  posvector <- 1:sigsize
  posvector[] <- 0

  z <- .C("Scwt_gmax",
           as.double(input1),
           output = as.double(output),
           as.integer(sigsize),
           as.integer(pp),
           pos = as.integer(posvector),
           PACKAGE="Rwave")

  output <- z$output
  pos <- z$pos

  dim(output) <- c(sigsize, pp)
  if(plot)image(output)
  list(output=output, pos= pos)
}



tflmax <- function(input, plot = TRUE)
#########################################################################
#  tflmax:
#  -------
# 	continuous time-frequency transform local maxima:
#        compute the time-frequency transform local maxima (for
#    	 fixed position)
#
#      input:
#      ------
# 	input: continuous time-frequency transform (2D array)
#	plot: if set to TRUE, displays the maxima of cwt on the graphic
#          device.
#
#      output:
#      -------
#       output: values of the maxima (2D array)
#
#########################################################################
{

  sigsize <- dim(input)[1]
  pp <- dim(input)[2]
  input1 <- input

  output <- matrix(0,sigsize,pp)
  dim(input1) <- c(sigsize * pp,1)
  dim(output) <- c(sigsize * pp,1)

  z <- .C("Scwt_mridge",
           as.double(input1),
           output = as.double(output),
           as.integer(sigsize),
           as.integer(pp),
           PACKAGE="Rwave")

  output <- z$output
  dim(output) <- c(sigsize, pp)
  if(plot)image(output)
  output
}



cleanph <- function(tfrep, thresh = .01, plot = TRUE)
#########################################################################
#  cleanph:
#  --------
# 	sets to zero the phase of time-frequency transform when
#        modulus is below a certain value.
#
#      input:
#      ------
# 	tfrep: continuous time-frequency transform (2D array)
#       thresh: (relative) threshold.
#	plot: if set to TRUE, displays the maxima of cwt on the graphic
#          device.
#
#      output:
#      -------
#       output: thresholded phase (2D array)
#
#########################################################################
{
  thrmod1 <- Mod(tfrep)
  thrmod2 <- Mod(tfrep)
  limit <- range(thrmod1)[2] * thresh
  thrmod1 <- (Mod(tfrep) > limit)
  thrmod2 <- (Mod(tfrep) <= limit)

  output <- thrmod1 * Arg(tfrep) - pi * thrmod2

  if(plot) image(output)
  output
}

#########################################################################
#    (c) Copyright 1997
#               by
#   Author: Rene Carmona, Bruno Torresani, Wen L. Hwang, Andrea Wang
#              Princeton University
#              All right reserved
########################################################################


plotwt <- function(original, psi, phi, maxresoln, scale=FALSE, yaxtype="s")
#*********************************************************************#
# plotwt
# ------
# Plot wavelet transform
# Output the original signal, wavelet transform Wf starting resoln 1,
# and Sf at the last resoln  
# Used by mw and dw
#*********************************************************************#
{
  par.orig <- par(no.readonly = TRUE)  # Save the original plot parameters

  par(mfrow = c((maxresoln+2), 1))
  par(mar=c(2.0, 2.0, 0.5, 0.5))
  par(oma=c(1,0,0,0)) # Change 1 to a larger number to allow a larger
		      # bottom margin 

  if ( !scale )
  {
    plot.ts(original,bty="n",yaxt=yaxtype)
    for (j in 1:maxresoln)
      plot.ts(psi[,j],bty="n",yaxt=yaxtype)
    plot.ts(phi, bty="n",yaxt=yaxtype)
  }
  else
  {
    limit <- range(original, psi, phi)
    plot.ts(original, ylim=limit, bty="n",yaxt=yaxtype)
    for (j in 1:maxresoln)
      plot.ts(psi[,j], ylim=limit, bty="n",yaxt=yaxtype)
    plot.ts(phi, ylim=limit, bty="n",yaxt=yaxtype)
  }

  par(par.orig)
}


plotResult <- function(result, original, maxresoln, scale=FALSE, yaxtype="s")
#*********************************************************************#
# plotResult
# -----------
#    function for the output of the following S functions:
# 	dnpval, dbpval, region, dntrim
#	mnpval,	ext, mntrim, localvar
#*********************************************************************#

{
  par.orig <- par(no.readonly = TRUE)  # Save the original plot parameters
  par(mar=c(2.0, 2.0, 0.5, 0.5))
  par(oma=c(1,0,0,0)) # Change 1 to a larger number to allow a larger
		      # bottom margin 

  par(mfrow = c(maxresoln+1, 1))

  if ( !scale )
  {
    plot.ts(original, bty="n",yaxt=yaxtype)
    for (j in 1:maxresoln)
      plot.ts(result[,j], bty="n",yaxt=yaxtype)
  }
  else
  {
    ymin <- min(result)
    ymax <- max(result)
    plot.ts(original, bty="n")
    for (j in 1:maxresoln)
      plot.ts(result[,j], ylim=c(ymin, ymax), bty="n",yaxt=yaxtype)
  }
 
  par(par.orig)
  par(mfrow=c(1,1))
}


wpl <- function(dwtrans)
#*********************************************************************#
# wpl
# ---
# Plot dyadic wavelet transform (output of mw).
#*********************************************************************#
{
  maxresoln <- dwtrans$maxresoln
  plotwt(dwtrans$original, dwtrans$Wf, dwtrans$Sf,maxresoln)
  cat("")
}


epl <- function(dwext)
#*********************************************************************#
# epl
# ---
# Plot wavelet transform extrema (output of ext).
#*********************************************************************#
{
  maxresoln <- dwext$maxresoln
  plotResult(dwext$extrema, dwext$original, maxresoln)
  cat("")
}

#########################################################################
#      $Log: Ridge_Recons.S,v $
# Revision 1.2  1995/04/05  18:56:55  bruno
# *** empty log message ***
#
# Revision 1.1  1995/04/02  01:04:16  bruno
# Initial revision
#
#
#               (c) Copyright  1997                             
#                          by     
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################





irregrec <- function(siginput, cwtinput,phi,compr,noct,nvoice,
                     epsilon = 0.5, w0 = 2*pi, prob = 0.8, fast = FALSE,
                     plot = FALSE, para = 0, hflag = FALSE, check = FALSE,
                     minnbnodes = 2, real = FALSE)
#########################################################################
#     irregrec:
#     ---------
#      Reconstruction of a real valued signal from a (continuous) ridge
#      (uses a irregular sampling of the ridge)
#
#      input:
#      -------
#      siginput: input signal
#      cwtinput: Continuous wavelet transform (output of cwt)
#      phi: (unsampled) ridge
#      compr: subsampling rate for the wavelet coefficients (at scale 1)
#      noct: number of octaves (powers of 2)
#      nvoice: number of different scales per octave
#      epsilon: coeff of the Q2 term in reconstruction kernel
#      w0: central frequency of Morlet wavelet
#      fast: if set to TRUE, the kernel is computed using Riemann
#           sums instead of Romberg's quadrature
#      plot: if set to TRUE, displays original and reconstructed signals
#      para: constant for extending the support of reconstructed signal
#            outside the ridge. 
#      check: if set to TRUE, computes the wavelet transform of the
#            reconstructed signal
#      minnbnodes: minimum number of nodes for the reconstruction
#      real: if set to TRUE, only uses constraints on the real part
#            of the transform for the reconstruction.
#      prob: only keep the lambda's values greater than this percential after regular sampling
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <wavelets,dualwavelets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#      solskel: wavelet transform of sol, restricted to the ridge
#      inputskel: wavelet transform of signal, restricted to the ridge
#      Q2: second part of the reconstruction kernel
#      nbnodes: number of nodes used for the reconstruction.
#
##########################################################################
{

#
#  Generate (regularly) sampled ridge
#


   tmp <- wRidgeSampling(phi,compr,nvoice)

   node <- tmp$node
cat("node at = ", node, "\n")
   phinode <- tmp$phinode
   nbnodes <- tmp$nbnodes
   phinode <- as.integer(phinode)	

   if(nbnodes < minnbnodes){
      cat(" Chain too small\n")
      NULL 
   }

   phi.x.min <- 2 * 2^(phinode[1]/nvoice)
   phi.x.max <- 2 * 2^(phinode[length(node)]/nvoice)

   x.min <- node[1]
   x.max <- node[length(node)]
   x.max <- x.max + round(para * phi.x.max)
   x.min <- x.min - round(para * phi.x.min)

   node <- node + 1 - x.min
   x.inc <- 1
   np <- as.integer((x.max - x.min)/x.inc) +1

    # Generating the Q2 term in reconstruction kernel
    if(epsilon == 0)
       Q2 <- 0
    else {
       if (fast == FALSE)
         Q2 <- rkernel(node, phinode, nvoice, x.min = x.min,
                       x.max = x.max,w0 = w0)
       else
	 Q2 <- fastkernel(node, phinode, nvoice, x.min = x.min,
                          x.max = x.max,w0 = w0)
     }
    cat(" kernel; ")

    # Generating the Q1 term in reconstruction kernel
    if (hflag == TRUE){
       one <- numeric(np)
       one[] <- 1
     }
    else{
       one <- numeric(np)
       one[] <- 1
    }

    if (epsilon !=0 ){
      Q <-  epsilon * Q2
      for(j in 1:np)
         Q[j,j] <- Q[j,j] + one[j]
      Qinv <- solve(Q)
    }
    else{
       Qinv <-  1/one
     }

    tmp2 <- ridrec(cwtinput, node, phinode, noct, nvoice, Qinv,
                   epsilon, np, w0 = w0, check = check, real = real)

# 
# Now perform the irregular sampling 
#
# C and Splus ...

   tmp <- RidgeIrregSampling(phi, node, tmp2$lam, prob)
   node <- tmp$node

  cat("node at  ", node,"\n")

   phinode <- tmp$phinode

  cat("phinode at  ", phinode,"\n")
   nbnodes <- tmp$nbnodes
   phinode <- as.integer(phinode)	

   if(nbnodes < minnbnodes){
      cat(" Chain too small\n")
      NULL 
   }

   phi.x.min <- 2 * 2^(phinode[1]/nvoice)
   phi.x.max <- 2 * 2^(phinode[length(node)]/nvoice)

   x.min <- node[1]
   x.max <- node[length(node)]

   x.max <- x.max + round(para * phi.x.max)
   x.min <- x.min - round(para * phi.x.min)

   node <- node + 1 - x.min
   x.inc <- 1


   np <- as.integer((x.max - x.min)/x.inc) +1
   cat("(size:",np,",",nbnodes,"nodes):")

    # Generating the Q2 term in reconstruction kernel
    if(epsilon == 0)
       Q2 <- 0
    else {
       if (fast == FALSE)
         Q2 <- rkernel(node, phinode, nvoice, x.min = x.min,
                       x.max = x.max,w0 = w0)
       else
	 Q2 <- fastkernel(node, phinode, nvoice, x.min = x.min,
                          x.max = x.max,w0 = w0)
     }
    cat(" kernel; ")

    # Generating the Q1 term in reconstruction kernel
    if (hflag == TRUE){
       one <- numeric(np)
       one[] <- 1
     }
    else{
       one <- numeric(np)
       one[] <- 1
    }

    if (epsilon !=0 ){
      Q <-  epsilon * Q2
      for(j in 1:np)
        Q[j,j] <- Q[j,j] + one[j]
      Qinv <- solve(Q)
    }
    else{
      Qinv <-  1/one
    }


    tmp2 <- ridrec(cwtinput, node, phinode, noct, nvoice, Qinv,
                   epsilon, np, w0 = w0, check = check, real = real)


    if(plot == TRUE){
       par(mfrow=c(2,1))
       plot.ts(Re(siginput))
       title("Original signal")
       plot.ts(Re(tmp2$sol))
       title("Reconstructed signal")
    }


    list(sol = tmp2$sol, A = tmp2$A, lam = tmp2$lam, dualwave = tmp2$dualwave,
	  morvelets = tmp2$morvelets, solskel = tmp2$solskel,
          inputskel = tmp2$inputskel, Q2 = Q2, nbnodes = nbnodes)
}

#########################################################################
#      $Log: gRidge_Recons.S,v $
# Revision 1.2  1995/04/05  18:56:55  bruno
# *** empty log message ***
#
# Revision 1.1  1995/04/02  01:04:16  bruno
# Initial revision
#
#
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University 
#                  All right reserved                           
#########################################################################





gregrec <- function(siginput, gtinput, phi, nbnodes, nvoice,
	freqstep, scale, epsilon = 0, fast = FALSE, plot = FALSE,
	para = 0, hflag = FALSE, real = FALSE, check = FALSE)
#########################################################################
#     gregrec:
#     -------
#      Reconstruction of a real valued signal from a (continuous) 
#      Gabor ridge (uses a regular sampling of the ridge)
#
#      input:
#      -------
#      siginput: input signal
#      gtinput: Continuous gabor transform (output of cgt)
#      phi: (unsampled) ridge
#      nbnodes: number of nodes used for the reconstruction.
#      nvoice: number of different scales per octave
#      freqstep: sampling rate for the frequency axis
#      epsilon: coeff of the Q2 term in reconstruction kernel
#      fast: if set to TRUE, the kernel is computed using Riemann
#           sums instead of Romberg's quadrature
#      plot: if set to TRUE, displays original and reconstructed signals
#      para: scale parameter for extrapolating the ridges.
#      hflag:if set to TRUE, uses $Q_1$ as first term in the kernel.
#      real: if set to TRUE, only uses constraints on the real part
#            of the transform for the reconstruction.
#      check: if set to TRUE, computes the wavelet transform of the
#            reconstructed signal
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <gaborlets,dualgaborlets> matrix 
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual wavelets.
#      gaborets: array containing the wavelets on sampled ridge.
#      solskel: Gabor transform of sol, restricted to the ridge
#      inputskel: Gabor transform of signal, restricted to the ridge
#      Q2: second part of the reconstruction kernel
#########################################################################
{
   tmp <- RidgeSampling(phi,nbnodes)
   node <- tmp$node
   phinode <- tmp$phinode

   phi.x.min <- scale
   phi.x.max <- scale
   
   x.min <- node[1]
   x.max <- node[length(node)]
   x.max <- x.max + round(para * phi.x.max)
   x.min <- x.min - round(para * phi.x.min)

   node <- node - x.min + 1
   
   x.inc <- 1
   np <- as.integer((x.max-x.min)/x.inc)+1

   cat(" (np:",np,")")

   if(epsilon == 0)
       Q2 <- 0
   else {
      if (fast == FALSE)
	Q2 <- gkernel(node,phinode,freqstep,scale,x.min = x.min, x.max = x.max)
      else
	Q2 <- fastgkernel(node,phinode,freqstep,scale,x.min = x.min,
		x.max = x.max)
      }
   cat(" kernel;")

# Generating the Q1 term in reconstruction kernel
   if (hflag == TRUE)
      one <- gsampleOne(node,scale,np)
   else{
      one <- numeric(np)
      one[] <- 1
   }


   if (epsilon !=0 ){
     Q <-  epsilon * Q2
       for(j in 1:np)
            Q[j,j] <- Q[j,j] + one[j]
         Qinv <- solve(Q)
      }
      else{
         Qinv <-  1/one
	 }

   tmp2 <- gridrec(gtinput,node,phinode,nvoice,
	freqstep,scale,Qinv,epsilon,np, real = real, check = check)

   if(plot == TRUE){
      par(mfrow=c(2,1))
      plot.ts(Re(siginput))
      title("Original signal")
      plot.ts(Re(tmp2$sol))
      title("Reconstructed signal")
   }

npl(2)
lam <- tmp2$lam
plot.ts(lam,xlab="Number",ylab="Lambda Value")
title("Lambda Profile")
N <- length(lam)/2
mlam <- numeric(N)
for(j in 1:N)
   mlam[j] <- Mod(lam[j] + 1i*lam[N + j])
plot.ts(sort(mlam))

   list(sol=tmp2$sol,A=tmp2$A,lam=tmp2$lam,dualwave=tmp2$dualwave,
	gaborets=tmp2$gaborets, solskel=tmp2$solskel,
	inputskel = tmp2$inputskel, Q2 = Q2)

}




gridrec <- function(gtinput, node, phinode, nvoice,
	freqstep, scale, Qinv, epsilon, np, real = FALSE, check = FALSE)
#########################################################################
#     gridrec:
#     --------
#      Reconstruction of a real valued signal from a gabor ridge.
#
#      input:
#      ------
#      gtinput: Continuous gabor transform (output of cgt)
#      node: time coordinates of the ridge samples.
#      phinode: frequency coordinates of the ridge samples.
#      nvoice: number of different frequencies.
#      freqstep: sampling rate for the frequency axis.
#      scale: scale of the window.
#      Qinv: inverse of the reconstruction kernel
#      epsilon: coefficient of the Q2 term in the reconstruction kernel
#      np: number of samples of the reconstructed signal
#      real: if set to TRUE, only uses constraints on the real part
#            of the transform for the reconstruction.
#      check: if set to TRUE, computes the Gabor transform of the
#            reconstructed signal.
#
#      output:
#      -------
#      sol: reconstruction from a ridge
#      A: <gaborlets,dualgaborlets> matrix.
#      lam: coefficients of dual wavelets in reconstructed signal.
#      dualwave: array containing the dual gaborlets.
#      gaborets: array of gaborlets located on the ridge samples
#      solskel: Gabor transform of sol, restricted to the ridge
#      inputskel: Gabor transform of signal, restricted to the ridge
#
#########################################################################
{
   N <- length(node)


   omegaridge <- phinode
   bridge <- node
   if(real == TRUE)
      gaborets <- gwave2(bridge,omegaridge,nvoice,freqstep,scale,np,N)
   else
      gaborets <- gwave(bridge,omegaridge,nvoice,freqstep,scale,np,N)

   cat("gaborets;")

   if(epsilon == 0){
      if(real == TRUE)
         sk <- zeroskeleton2(gtinput,Qinv,gaborets,bridge,omegaridge,N)
      else
         sk <- zeroskeleton(gtinput,Qinv,gaborets,bridge,omegaridge,N)
      }

   else
      sk <- skeleton(gtinput,Qinv,gaborets,bridge,omegaridge,N)

   cat("skeleton.\n")

   solskel <- 0 #not needed if check not done
   inputskel <- 0 #not needed if check not done

   if(check == TRUE){
      solskel <- complex(N)
      inputskel <- complex(N)
      gtsol <- cgt(sk$sol,nvoice,freqstep,plot=FALSE)
      for(j in 1:N) solskel[j] <- gtsol[bridge[j],omegaridge[j]]

      for (j in 1:N)
         inputskel[j] <- gtinput[bridge[j],omegaridge[j]]
   }

   list(sol=sk$sol,A=sk$A,lam=sk$lam,dualwave=sk$dualwave,gaborets=gaborets,
	solskel=solskel,inputskel = inputskel)
}


gwave <- function(bridge,omegaridge,nvoice,freqstep,scale,np,N)
#########################################################################
#     gwave:
#     ------
#      Generation of the gaborets located on the ridge
#
#      input:
#      ------
#      bridge: time coordinates of the ridge samples
#      omegaridge: frequency coordinates of the ridge samples
#      nvoice: number of different scales per octave
#      freqstep: sampling rate for the frequency axis
#      scale: scale of the window
#      np: size of the reconstruction kernel
#      N: number of complex constraints
#
#      output:
#      -------
#      gaborets: array of morlet wavelets located on the ridge samples
#
#########################################################################
{

   gaborets <- matrix(0,np,2*N)

    omegaridge <- omegaridge * freqstep
    tmp <- vecgabor(np,N,bridge,omegaridge,scale)
    dim(tmp) <- c(np,N)
    gaborets[,1:N] <- Re(tmp[,1:N])
    gaborets[,(N+1):(2*N)] <- Im(tmp[,1:N])

# Alternative way of generating gaborets
#   for(k in 1:N)  {
#      omega <- omegaridge[k]*freqstep;
#      tmp <- gabor(np,bridge[k],omega,scale);
#      gaborets[,k] <- Re(tmp);
#      gaborets[,k+N] <- Im(tmp);
#    }


# Still another way of generating gaborets
#
#   dirac <- 1:np
#   dirac[] <- 0
#   for(k in 1:N)  {
#      dirac[bridge[k]] <- 1.0;
#      omega <- omegaridge[k]*freqstep;
#      gtdirac <- vgt(dirac,omega,scale,open=FALSE,plot=FALSE);
#      gaborets[,k] <- Re(gtdirac);
#      gaborets[,k+N] <- Im(gtdirac);
#      dirac[] <- 0
#    }

    gaborets
}



gwave2 <- function(bridge,omegaridge,nvoice,freqstep,scale,np,N)
#########################################################################
#     gwave2:
#     -------
#      Generation of the real parts of gaborets located on the ridge
#
#      input:
#      ------
#      bridge: time coordinates of the ridge samples
#      omegaridge: frequency coordinates of the ridge samples
#      nvoice: number of different scales per octave
#      freqstep: sampling rate for the frequency axis
#      scale: scale of the window
#      np: size of the reconstruction kernel
#      N: number of complex constraints
#
#      output:
#      -------
#      gaborets: array of morlet wavelets located on the ridge samples
#
#########################################################################
{
    omegaridge <- omegaridge * freqstep
    gaborets <- Re(vecgabor(np,N,bridge,omegaridge,scale))
    dim(gaborets) <- c(np,N)


#   for(k in 1:N)  {
#      omega <- omegaridge[k]*freqstep;
#      tmp <- gabor(np,bridge[k],omega,scale);
#      gaborets[,k] <- Re(tmp);
#    }
    gaborets
}




gsampleOne <- function(node,scale,np)
#########################################################################
#     gsampleOne:
#     -----------
#
#       Generate a ``sampled identity"
#
#     input:
#     ------
#      node: location of the reconstruction gabor functions
#      scale: scale of the gabor functions
#      np: size of the reconstructed signal
#
#
#     output:
#     -------
#      dia: diagonal of the ``sampled'' Q1 term (1D vector)
#
#########################################################################
{
   dia <- numeric(np)
   N <- length(node)

   normalization <- sqrt(pi) * scale

   for(j in 1:np) {
     tmp1 <- (j-node)/scale
     tmp1 <- exp(-(tmp1 * tmp1))

     dia[j] <- sum(tmp1) #/normalization
    }
   dia

#   for(j in 1:np) {
#     tmp <- 0
#     for(k in 1:N) {
#       b <- node[k]
#       tmp1 <- (j-b)/scale
#       tmp1 <- exp(-(tmp1 * tmp1))
#       tmp <- tmp + tmp1
#     }
#     dia[j] <- tmp #/normalization
#   }
   dia
}

#########################################################################
#      $Log: Skernel.S,v $
# Revision 1.2  1995/04/05  18:56:55  bruno
# *** empty log message ***
#
# Revision 1.1  1995/04/02  01:04:16  bruno
# Initial revision
#
#               (c) Copyright  1997                             
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################





rwkernel <- function(node, phinode, nvoice, x.inc = 1, x.min = node[1],
	x.max = node[length(node)], w0 = 2*pi, plot = FALSE)
#########################################################################
#     rwkernel:   
#     ------
#      Computes the cost from the sample of points on the estimated ridge
#      and the matrix used in the reconstruction of the original signal
#      The output is a lng x lng matrix of complex numbers, lng being the
#      number of points at which the signal is to be reconstructed. 
#      The dependence upon the original signal is only through the 
#      sample (node,phinode) of the ridge. This should be the output
#      of a previously run estimation procedure.
#
#     Input:
#     ------
#      node: values of the variable b for the nodes of the ridge
#      phinode: values of the scale variable a for the nodes of the ridge
#      nvoice: number of scales within 1 octave
#      x.inc: step unit for the computation of the kernel
#      x.min: minimal value of x for the computation of Q2
#      x.max: maximal value of x for the computation of Q2
#      w0: central frequency of the wavelet
#      plot: if set to TRUE, displays the modulus of the matrix of Q2
#
#     Output:
#     -------
#      ker: matrix of the Q2 kernel
#
#########################################################################
{

cat("x.min = ",x.min,"\n")
cat("x.max = ",x.max,"\n")
cat("x.inc = ",x.inc,"\n")
   lng <- as.integer((x.max-x.min)/x.inc)+1
   nbnode <- length(node)

   cat("lng = ",lng,"\n");

   b.start <- x.min - 50
   b.end <- x.max + 50
   
   ker.r <- matrix(0, lng, lng)
   ker.i <- matrix(0, lng, lng)

   dim(ker.r) <- c(lng * lng, 1)
   dim(ker.i) <- c(lng * lng, 1)
   phinode <-  2 * 2^(phinode/nvoice)
  

  z <- .C("kernel",
        ker.r = as.double(ker.r),
        ker.i = as.double(ker.i),
        as.integer(x.min),
        as.integer(x.max),
	as.integer(x.inc),
	as.integer(lng),
        as.double(node),
        as.double(phinode),
        as.integer(nbnode),
        as.double(w0),
        as.double(b.start),
        as.double(b.end),
           PACKAGE="Rwave")


  ker.r <- z$ker.r
  ker.i <- z$ker.i
  dim(ker.r) <- c(lng, lng)
  dim(ker.i) <- c(lng, lng)
  ker <- matrix(0, lng, lng)
  ker <- ker.r + 1i*ker.i

  if(plot == TRUE){
     par(mfrow=c(1,1))
     image(Mod(ker))
     title("Matrix of the reconstructing kernel (modulus)")
  }

  ker
}

rkernel <- function(node, phinode, nvoice, x.inc = 1, x.min = node[1],
	x.max = node[length(node)], w0 = 2*pi, plot = FALSE)
#########################################################################
#     rkernel:   
#     -------
#      Same as kernel, except that a real valued kernel is computed
#      (precisely the real part of the previous kernel); this applies to
#      real signals.
#
#     Input:
#     ------
#      node: values of the variable b for the nodes of the ridge
#      phinode: values of the scale variable a for the nodes of the ridge
#      nvoice: number of scales within 1 octave
#      x.inc: step unit for the computation of the kernel
#      x.min: minimal value of x for the computation of Q2
#      x.max: maximal value of x for the computation of Q2
#      w0: central frequency of the wavelet
#      plot: if set to TRUE, displays the modulus of the matrix of Q2
#
#     Output:
#     -------
#      ker: matrix of the Q2 kernel
#
#########################################################################
{
   lng <- as.integer((x.max-x.min)/x.inc)+1
   nbnode <- length(node)

   b.start <- x.min - 50
   b.end <- x.max + 50

   ker <- matrix(0, lng, lng)
   dim(ker) <- c(lng * lng, 1)
   phinode <-  2 * 2^(phinode/nvoice)

  z <- .C("rkernel",
        ker = as.double(ker),
        as.integer(x.min),
        as.integer(x.max),
	as.integer(x.inc),
	as.integer(lng),
        as.double(node),
        as.double(phinode),
        as.integer(nbnode),
        as.double(w0),
        as.double(b.start),
        as.double(b.end),
           PACKAGE="Rwave")

  ker <- z$ker
  dim(ker) <- c(lng, lng)

  if(plot == TRUE){
     par(mfrow=c(1,1))
     image(Mod(ker))
     title("Matrix of the Q2 kernel (modulus)")
  }

  ker
}



fastkernel <- function(node, phinode, nvoice, x.inc = 1, x.min = node[1],
	x.max = node[length(node)], w0 = 2*pi, plot = FALSE)
#########################################################################
#     fastkernel:   
#     -----------
#	   Same as kernel, except that the kernel is computed
#	     using Riemann sums instead of Romberg integration.
#
#     Input:
#     ------
#      node: values of the variable b for the nodes of the ridge
#      phinode: values of the scale variable a for the nodes of the ridge
#      nvoice: number of scales within 1 octave
#      x.inc: step unit for the computation of the kernel
#      x.min: minimal value of x for the computation of Q2
#      x.max: maximal value of x for the computation of Q2
#      w0: central frequency of the wavelet
#      plot: if set to TRUE, displays the modulus of the matrix of Q2
#
#     Output:
#     -------
#      ker: matrix of the Q2 kernel
#
#########################################################################
{
   lng <- as.integer((x.max-x.min)/x.inc)+1
   nbnode <- length(node)

   b.start <- x.min - 50
   b.end <- x.max + 50

   ker.r <- matrix(0, lng, lng)
   ker.i <- matrix(0, lng, lng)
   dim(ker.r) <- c(lng * lng, 1)
   dim(ker.i) <- c(lng * lng, 1)
   phinode <-  2 * 2^(phinode/nvoice)

  z <- .C("fastkernel",
        ker.r = as.double(ker.r),
        ker.i = as.double(ker.i),
        as.integer(x.min),
        as.integer(x.max),
	as.integer(x.inc),
	as.integer(lng),
        as.double(node),
        as.double(phinode),
        as.integer(nbnode),
        as.double(w0),
        as.double(b.start),
        as.double(b.end),
           PACKAGE="Rwave")


  ker.r <- z$ker.r
  ker.i <- z$ker.i
  dim(ker.r) <- c(lng, lng)
  dim(ker.i) <- c(lng, lng)
  ker <- matrix(0, lng, lng)
  ker <- ker.r + 1i*ker.i

  if(plot == TRUE){
     par(mfrow=c(1,1))
     image(Mod(ker))
     title("Matrix of the reconstructing kernel (modulus)")
  }

  ker
}



zerokernel <- function(x.inc = 1, x.min,x.max)
#########################################################################
#     zerokernel:   
#     -----------
#	Returns a zero kernel.
#
#     Input:
#     ------
#      x.inc: step unit for the computation of the kernel
#      x.min: minimal value of x for the computation of Q2
#      x.max: maximal value of x for the computation of Q2
#
#     Output:
#     -------
#      ker: matrix of the Q2 kernel
#
#########################################################################
{
   lng <- as.integer((x.max-x.min)/x.inc)+1

   ker <- matrix(0, lng, lng)

   ker
}




gkernel <- function(node, phinode, freqstep, scale, x.inc = 1,
	x.min = node[1], x.max = node[length(node)], plot = FALSE)
#########################################################################
#     gkernel:   
#     -------
#	Same as kernel, for the case of Gabor transform.
#
#     input:
#     ------
#      node: values of the variable b for the nodes of the ridge
#      phinode: values of the frequency variable for the ridge nodes
#      freqstep: sampling rate for the frequency axis
#      scale: size of the window
#      x.inc: step unit for the computation of the kernel
#      x.min: minimal value of x for the computation of Q2
#      x.max: maximal value of x for the computation of Q2
#      plot: if set to TRUE, displays the modulus of the matrix of Q2
#
#     output:
#     -------
#      ker: matrix of the Q2 kernel
#
#########################################################################
{
   lng <- as.integer((x.max-x.min)/x.inc)+1
   nbnode <- length(node)
   b.start <- node[1] - 50
   b.end <- node[length(node)] + 50
   ker <- matrix(0, lng, lng)
   dim(ker) <- c(lng * lng, 1)

   phinode <- phinode * freqstep


  z <- .C("gkernel",
        ker = as.double(ker),
        as.integer(x.min),
        as.integer(x.max),
	as.integer(x.inc),
	as.integer(lng),
        as.double(node),
        as.double(phinode),
        as.integer(nbnode),
        as.double(scale),
        as.double(b.start),
        as.double(b.end),
           PACKAGE="Rwave")


  ker <- z$ker
  dim(ker) <- c(lng, lng)

  if(plot == TRUE){
     par(mfrow=c(1,1))
     image(Mod(ker))
     title("Matrix of the reconstructing kernel (modulus)")
  }

  ker
}



fastgkernel <- function(node, phinode, freqstep, scale, x.inc = 1,
	x.min = node[1], x.max = node[length(node)], plot = FALSE)
#########################################################################
#     fastgkernel:   
#     ------------
#	Same as gkernel, except that the kernel is computed
#	  using Riemann sums instead of Romberg integration.
#
#
#     input:
#     ------
#      node: values of the variable b for the nodes of the ridge
#      phinode: values of the frequency variable for the ridge nodes
#      freqstep: sampling rate for the frequency axis
#      scale: size of the window
#      x.inc: step unit for the computation of the kernel
#      x.min: minimal value of x for the computation of Q2
#      x.max: maximal value of x for the computation of Q2
#      plot: if set to TRUE, displays the modulus of the matrix of Q2
#
#     output:
#     -------
#      ker: matrix of the Q2 kernel
#
#########################################################################
{
   lng <- as.integer((x.max-x.min)/x.inc)+1
   nbnode <- length(node)

   b.start <- x.min - 50
   b.end <- x.max + 50

   ker <- matrix(0, lng, lng)
   dim(ker) <- c(lng * lng, 1)
   phinode <-  phinode*freqstep


  z <- .C("fastgkernel",
        ker = as.double(ker),
        as.integer(x.min),
        as.integer(x.max),
	as.integer(x.inc),
	as.integer(lng),
        as.double(node),
        as.double(phinode),
        as.integer(nbnode),
        as.double(scale),
        as.double(b.start),
        as.double(b.end),
           PACKAGE="Rwave")


  ker <- z$ker
  dim(ker) <- c(lng, lng)

  if(plot == TRUE){
     par(mfrow=c(1,1))
     image(Mod(ker))
     title("Matrix of the reconstructing kernel (modulus)")
  }

  ker
}

#########################################################################
#      $Log: Cwt_Squeezing.S,v $
#########################################################################
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################






cwtsquiz <- function(input, noctave, nvoice = 1, w0 = 2*pi,
	twoD = TRUE, plot = TRUE)
#########################################################################
#      cwtsquiz:
#      --------
#       squeezed wavelet transform function
#
#       Input:
#       ------
# 	 input: input signal (possibly complex-valued)
#	 noctave: number of powers of 2 for the scale variable
#	 nvoice: number of scales between 2 consecutive powers of 2
#        w0: central frequency of Morlet wavelet
#	 twoD: if set to TRUE, organizes the output as a 2D array 
#			(signal_size X nb_scales)
#		      if not: 3D array (signal_size X noctave X nvoice)
#	 plot: if set to TRUE, displays the modulus of cwt on the graphic
#		device.
#
#       output:
#       -------
#        tmp: continuous (complex) squeezed wavelet transform
#
#########################################################################
{
   oldinput <- input
   isize <- length(oldinput)

   tmp <- adjust.length(oldinput)
   input <- tmp$signal
   newsize <- length(input)

   pp <- noctave * nvoice
   Routput <- matrix(0,newsize,pp)
   Ioutput <- matrix(0,newsize,pp)
   output <- matrix(0,newsize,pp)
   dim(Routput) <- c(pp * newsize,1)
   dim(Ioutput) <- c(pp * newsize,1)
   dim(input) <- c(newsize,1)

   z <- .C("Scwt_squeezed",
           as.double(input),
           Rtmp = as.double(Routput),
           Itmp = as.double(Ioutput),
           as.integer(noctave),
           as.integer(nvoice),
           as.integer(newsize),
           as.double(w0),
           PACKAGE="Rwave")

   Routput <- z$Rtmp
   Ioutput <- z$Itmp
   dim(Routput) <- c(newsize,pp)
   dim(Ioutput) <- c(newsize,pp)
   if(twoD) {
     output <- Routput[1:isize,] + 1i*Ioutput[1:isize,]
     if(plot){
        image(Mod(output),xlab="Time", ylab="log(scale)")
	title("Squeezed Wavelet Transform Modulus")
     }
     output
   } 
   else {
     Rtmp <- array(0,c(isize,noctave,nvoice))
     Itmp <- array(0,c(isize,noctave,nvoice))
     for(i in 1:noctave)
       for(j in 1:nvoice) {
         Rtmp[,i,j] <- Routput[1:isize,(i-1)*nvoice+j]
         Itmp[,i,j] <- Ioutput[1:isize,(i-1)*nvoice+j]
      }
     Rtmp + 1i*Itmp
   }
}

#########################################################################
#    $log: mw.S,v $
#########################################################################
#
#    (c) Copyright 1997
#               by
#   Author: Rene Carmona, Bruno Torresani, Wen L. Hwang, Andrea Wang
#              Princeton University 
#              All right reserved
########################################################################




check.maxresoln <- function( maxresoln, np )
#*********************************************************************#
# check.maxresoln
# ---------------
# stop when the size of 2^maxresoln is no less than signal size
#
# input 
# -----
# maxresoln: number of decomposition
# np: signal size
#
# output
# ------
#*********************************************************************#
{
  if ( 2^(maxresoln+1) > np )
    stop("maxresoln is too large for the given signal")
}


mw <- function(inputdata,maxresoln,filtername="Gaussian1",scale=FALSE,
	       plot=TRUE)
#*********************************************************************#
# mw
# --
#   mw computes the wavelet decomposition by Mallat and Zhong's wavelet.
#
# input
# -----
#   inputdata: either a text file or an S object of input data.
#   maxresoln: number of decomposition
#   filename: name of filter (Gaussian1 stands for Mallat and Zhong's filter ;
#             Haar stands for the Haar basis).	
#   scale: when set, the wavelet transform at each scale will be plotted 
#          with the same scale.
#   plot : indicate if the wavelet transform at each scale will be plotted.
#          		
# output
# ------
#   original: original signal
#   Wf: wavelet transform of signal
#   Sf: signal at a lower resolution
#   maxresoln: number of decomposition
#   np: size of signal
#*********************************************************************#
{
  x <- adjust.length(inputdata)
  s <- x$signal
  np <- x$length

  Sf <- matrix(0, nrow=(maxresoln+1), ncol=np)
  Wf <- matrix(0, nrow=maxresoln, ncol=np)  

  ## Convert a matrix maxresoln by np matrix into a vector
  Sf <- t(Sf)
  dim(Sf) <- c(length(Sf),1)
  Wf <- t(Wf)
  dim(Wf) <- c(length(Wf),1)

  y <- .C("Sf_compute", 
	Sf=as.double(Sf), 
	as.double(s), 
	as.integer(maxresoln), 
	as.integer(np),
	as.character(filtername),
           PACKAGE="Rwave")

  z <- .C("Wf_compute",
	Wf=as.double(Wf),
	as.double(y$Sf),
	as.integer(maxresoln),
	as.integer(np),
	as.character(filtername),
           PACKAGE="Rwave")

  ## Convert the vectors into the original matrix
  Sf <- t(y$Sf)

  Sf <- Sf[(maxresoln*np+1):((maxresoln+1)*np)]

  Wf <- t(z$Wf)
  dim(Wf) <- c(np, maxresoln)

  if(plot)
    plotwt(s, Wf, Sf, maxresoln, scale)

  list( original=s, Wf=Wf, Sf=Sf, maxresoln=maxresoln, np=np )
}

#########################################################################
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################

dw <- function(inputdata, maxresoln, scale=FALSE, NW=6, plot=TRUE)
#*********************************************************************#
# dw computes the Daubechies wavelet transform from resolution 1 to
# the given maximum resolution.  If phi.flag is TRUE, it returns a 
# list consisting psi and phi wavelet transforms as two matrices.
#*********************************************************************#
{
  if(! ((NW > 1) && (NW <11)))
    stop("NW has to be between 2 and 10")
  
  x <- adjust.length(inputdata)
  s <- x$signal
  np <- x$length
  check.maxresoln(maxresoln, np)
  phi <- matrix(0, nrow=maxresoln+1, ncol=np)
  psi <- matrix(0, nrow=maxresoln, ncol=np)

  ## Convert matrices into vectors
  phi <- t(phi)
  dim(phi) <- c(length(phi), 1)
  psi <- t(psi)
  dim(psi) <- c(length(psi), 1)
  
  z <- .C("daubechies_wt", 
          phi=as.double(phi),
          psi=as.double(psi),
          as.double(s),
          as.integer(NW),
          as.integer(maxresoln),
          as.integer(np),
           PACKAGE="Rwave")
  
  ## Convert vectors into original matrices
  phi <- t(z$phi)
  dim(phi) <- c(np, maxresoln+1)
  psi <- t(z$psi)
  dim(psi) <- c(np, maxresoln)
  
  if(plot)
    plotwt(s, psi, phi, maxresoln, scale)

  phi <- matrix(phi[,(maxresoln+1)], ncol=1, nrow=np)
  list(original=s, Wf=psi, Sf=phi, maxresoln=maxresoln, np=np, NW=NW)
}

ddw <- function(inputdata, maxresoln, scale=FALSE, NW=6)
#*********************************************************************#
# ddw computes the discrete Daubechies wavelet transform from 
# resolution 1 to the given maximum resolution.  
#*********************************************************************#
{
  if(! ((NW > 1) && (NW < 11)))
    stop("NW has to be between 2 and 10")

  x <- adjust.length(inputdata)
  s <- x$signal
  np <- x$length	
  check.maxresoln(maxresoln, np)
  phi <- matrix(0, nrow=maxresoln+1, ncol=np)
  psi <- matrix(0, nrow=maxresoln, ncol=np)

  ## Convert matrices into vectors
  phi <- t(phi)
  dim(phi) <- c(length(phi), 1)
  psi <- t(psi)
  dim(psi) <- c(length(psi), 1)
  
  z <- .C("compute_ddwave", 
          phi=as.double(phi),
          psi=as.double(psi),
          as.double(s),
          as.integer(maxresoln),
          as.integer(np),
          as.integer(NW),
           PACKAGE="Rwave")
  
  ## Convert vectors into original matrices
  phi <- t(z$phi)
  dim(phi) <- c(np, maxresoln+1)
  psi <- t(z$psi)
  dim(psi) <- c(np, maxresoln)
  plotwt(s, psi, phi, maxresoln, scale)
  phi <- matrix(phi[,(maxresoln+1)], ncol=1, nrow=np)
  list(original=s, Wf=psi, Sf=phi, maxresoln=maxresoln, np=np, NW=NW)
}

#########################################################################
#       $Log: Cwt_DOG.S,v $
#########################################################################
#
#               (c) Copyright  1997
#                          by                                   
#      Author: Rene Carmona, Bruno Torresani, Wen-Liang Hwang   
#                  Princeton University
#                  All right reserved                           
#########################################################################

DOG <- function(input, noctave, nvoice = 1, moments, twoD = TRUE, plot = TRUE)
#########################################################################
#       DOG: Derivative of Gaussian  
#       ----
# 	 continuous wavelet transform function:
#         compute the continuous wavelet transform with (complex-valued)
#	  derivative of gaussians wavelet
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#	 noctave: number of powers of 2 for the scale variable
#	 nvoice: number of scales between 2 consecutive powers of 2
#        moments: number of vanishing moments for the wavelet
#	 twoD: if set to TRUE, organizes the output as a 2D array 
#			(signal_size X nb_scales)
#		      if not: 3D array (signal_size X noctave X nvoice)
#	 plot: if set to TRUE, displays the modulus of cwt on the graphic
#		device.
#
#       output:
#       -------
#        tmp: continuous (complex) wavelet transform
#
#########################################################################
{
  oldinput <- input
  isize <- length(oldinput)
  
  tmp <- adjust.length(oldinput)
  input <- tmp$signal
  newsize <- length(input)
  
  pp <- noctave * nvoice
  Routput <- matrix(0,newsize,pp)
  Ioutput <- matrix(0,newsize,pp)
  output <- matrix(0,newsize,pp)
  dim(Routput) <- c(pp * newsize,1)
  dim(Ioutput) <- c(pp * newsize,1)
  dim(input) <- c(newsize,1)
  
  z <- .C("Scwt_DOG",
          as.double(Re(input)),
          as.double(Im(input)),
          Rtmp = as.double(Routput),
          Itmp = as.double(Ioutput),
          as.integer(noctave),
          as.integer(nvoice),
          as.integer(newsize),
          as.integer(moments),
           PACKAGE="Rwave")
  
  Routput <- z$Rtmp
  Ioutput <- z$Itmp
  dim(Routput) <- c(newsize,pp)
  dim(Ioutput) <- c(newsize,pp)
  if(twoD) {
    output <- Routput[1:isize,] + 1i*Ioutput[1:isize,]
    if(plot) image(Mod(output))
    output
  } 
  else {
    Rtmp <- array(0,c(isize,noctave,nvoice))
    Itmp <- array(0,c(isize,noctave,nvoice))
    for(i in 1:noctave)
      for(j in 1:nvoice) {
        Rtmp[,i,j] <- Routput[1:isize,(i-1)*nvoice+j]
        Itmp[,i,j] <- Ioutput[1:isize,(i-1)*nvoice+j]
      }
    Rtmp + 1i * Itmp
  }
}

vDOG <- function(input, scale, moments)
#########################################################################
#       vDOG:   
#       -----
#        continuous wavelet transform on one scale:
# 	 compute the continuous wavelet transform with (complex-valued)
#	  derivative of gaussians wavelet
#
#       input:
#       ------
# 	 input: input signal (possibly complex-valued)
#        scale: value of the scale at which the transform is computed
#        moments: number of vanishing moments
#
#       output:
#       -------
#        Routput + i Ioutput: voice wavelet transform (complex 1D array)
#
#########################################################################
{
  oldinput <- input
  isize <- length(oldinput)
  
  tmp <- adjust.length(oldinput)
  input <- tmp$signal
  newsize <- length(input)
  
  Routput <- numeric(newsize)
  Ioutput <- numeric(newsize)
  dim(input) <- c(newsize,1)
  
  z <- .C("Svwt_DOG",
          as.double(Re(input)),
          as.double(Im(input)),
          Rtmp = as.double(Routput),
          Itmp = as.double(Ioutput),
          as.double(scale),
          as.integer(newsize),
          as.integer(moments),
           PACKAGE="Rwave")
  
  Routput <- z$Rtmp
  Ioutput <- z$Itmp
  Routput[1:isize] + 1i*Ioutput[1:isize]
}

\name{Undocumented}
\alias{PcaRidgeSampling}
\alias{RidgeDist}
\alias{RidgeIrregSampling}
\alias{RunRec}
\alias{SampleGen}
\alias{Sausage}
\alias{SpecGen}
\alias{band}
\alias{cgtRadar}
\alias{cloudXYZ}
\alias{confident}
\alias{crcirgrec}
\alias{crcirrec}
\alias{ddw}
\alias{dw}
\alias{fftshift}
\alias{girregrec}
\alias{hescrc}
\alias{irregrec}
\alias{mbpval}
\alias{mcgt}
\alias{mnpval}
\alias{pcacrc}
\alias{pcafamily}
\alias{pcamaxima}
\alias{pcamorwave}
\alias{pcarec}
\alias{pcaregrec}
\alias{pcaridrec}
\alias{pcazeroskeleton}
\alias{robustrec}
\alias{showRadar}
\alias{simplepcarec}
\alias{vwtTh}
\title{Undocumented Functions in Rwave}
\description{
  Numerous functions were not documented in the original Swave help files.
}
%\usage{}
%\arguments{}
%\value{}
%\details{}
\references{
  See discussions in the text of ``Practical Time-Frequency Analysis''.
}
%\seealso{}
\keyword{ts}

\name{morlet}
\alias{morlet}
\title{
 Morlet Wavelets
}
\description{
Computes a Morlet wavelet at the point of the time-scale
plane given in the input
}
\usage{
morlet(sigsize, location, scale, w0=2 * pi)
}
\arguments{
\item{sigsize}{
length of the output.
}
\item{location}{
time location of the wavelet.
}
\item{scale}{
scale of the wavelet.
}
\item{w0}{
central frequency of the wavelet.
}}
\value{
Returns the values of the complex Morlet wavelet at the point of
the time-scale plane given in the input
}
\details{
The details of this construction (including the definition formulas)
are given in the text.
}
\references{


See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{gabor}}.
}
\examples{

m1 = morlet(1024, 512, 20, w0=2 * pi)
plot.ts(Re(m1) )


}

\keyword{ts}

\name{morwave2}
\alias{morwave2}
\title{
Real Ridge Morvelets
}
\description{
Generates the real parts of the Morlet wavelets at the sample 
points of a ridge
}
\usage{
morwave2(bridge, aridge, nvoice, np, N, w0=2 * pi)
}
\arguments{
\item{bridge}{
time coordinates of the ridge samples.
}
\item{aridge}{
scale coordinates of the ridge samples.
}
\item{nvoice}{
number of different scales per octave.
}
\item{np}{
number of samples in the input signal.
}
\item{N}{
size of reconstructed signal.
}
\item{w0}{
central frequency of the wavelet.
}}
\value{
Returns the real parts of the Morlet wavelets at the samples of 
the time-scale plane given in the input:
array of Morlet wavelets located on the ridge samples
}
%\details{}
\references{
See discussions in the text of \dQuote{Time-Frequency Analysis}.
}
\seealso{
\code{\link{morwave}}, \code{\link{gwave}}, \code{\link{gwave2}}.
}
\keyword{ts}

\name{gcrcrec}
\alias{gcrcrec}
\title{Crazy Climbers Reconstruction by Penalization}
\description{
  Reconstructs a real-valued signal from ridges found by 
  crazy climbers on a Gabor transform.
}
\usage{
gcrcrec(siginput, inputgt, beemap, nvoice, freqstep, scale, compr,
        bstep=5, ptile=0.01, epsilon=0, fast=TRUE, para=5, minnbnodes=3,
        hflag=FALSE, real=FALSE, plot=2)
}
\arguments{
  \item{siginput}{original signal.}
  \item{inputgt}{Gabor transform.}
  \item{beemap}{occupation measure, output of \code{\link{crc}}.}
  \item{nvoice}{number of frequencies.}
  \item{freqstep}{sampling step for frequency axis.}
  \item{scale}{size of windows.}
  \item{compr}{compression rate to be applied to the ridges.}
  \item{bstep}{size (in the time direction) of the steps for chaining.}
  \item{ptile}{threshold of ridge}
  \item{epsilon}{constant in front of the smoothness term in penalty function.}
  \item{fast}{if set to TRUE, uses trapezoidal rule to evaluate \eqn{Q_2}.}
  \item{para}{scale parameter for extrapolating the ridges.}
  \item{minnbnodes}{minimal number of points per ridge.}
  \item{hflag}{if set to FALSE, uses the identity as first term
    in the kernel.  If not, uses \eqn{Q_1} instead.}
  \item{real}{if set to \code{TRUE}, uses only real constraints.}
  \item{plot}{ 
    \describe{
      \item{1}{displays signal,components, and reconstruction one after 
        another.}
      \item{2}{displays signal, components and reconstruction.}
    }
  }
}
\details{
  When \code{ptile} is high, boundary effects may appear.  \code{para} 
  controls extrapolation of the ridge.
}
\value{
  Returns a structure containing the following elements:
  \item{rec}{reconstructed signal.}
  \item{ordered}{image of the ridges (with different colors).}
  \item{comp}{2D array containing the signals reconstructed from ridges.}
}
\references{
  See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
  \code{\link{crc}}, \code{\link{cfamily}}, \code{\link{crcrec}},
  \code{\link{scrcrec}}.
}
\keyword{ts}

\name{Ekg}
\alias{Ekg}
\title{Heart Rate Data}
\description{Successive beat-to-beat intervals for a normal patient.
}
\usage{data(Ekg)
}
\format{A vector containing 16,042 observations.
}
\source{
  See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\references{
  Carmona, R. A., W. L. Hwang and B Torresani (1998, eBook ISBN:978008053942)
  \emph{Practical Time-Frequency Analysis: Gabor and Wavelet Transforms
    with an Implementation in S}, Academic Press, San Diego.
}
\examples{
data(Ekg)
plot.ts(Ekg)
}
\keyword{datasets}

\name{adjust.length}
\alias{adjust.length}
\title{
Zero Padding
}
\description{
Add zeros to the end of the data if necessary so that 
its length is a power of 2.  It returns the data with zeros
added if nessary and the length of the adjusted data.
}
\usage{
adjust.length(inputdata)
}
\arguments{
\item{inputdata}{
either a text file or an S object containing
data.
}}
\value{
Zero-padded 1D array.
}
%\details{}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
%\seealso{}
\keyword{ts}
\keyword{ts}

\name{crfview}
\alias{crfview}
\title{
Display chained ridges
}
\description{
displays a family of chained ridges, output of \code{\link{cfamily}}.
}
\usage{
crfview(beemap, twod=TRUE)
}
\arguments{
\item{beemap}{
Family of chained ridges, output of \code{\link{cfamily}}. 
}
\item{twod}{
If set to T, displays the ridges as an image. If set to F,
displays as a series of curves.
}}
%\value{}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{crc}},\code{\link{cfamily}} for crazy climbers and corresponding chaining algorithms.
}
\keyword{ts}

\name{ridrec}
\alias{ridrec}
\title{
Reconstruction from a Ridge
}
\description{
Reconstructs signal from sample of a ridge,
in the wavelet case.
}
\usage{
ridrec(cwtinput, node, phinode, noct, nvoice, Qinv, epsilon, np,
w0=2 * pi, check=FALSE, real=FALSE)
}
\arguments{
\item{cwtinput}{
wavelet transform, output of \code{\link{cwt}}.
}
\item{node}{
time coordinates of the ridge samples.
}
\item{phinode}{
scale coordinates of the ridge samples.
}
\item{noct}{
number of octaves (powers of 2).
}
\item{nvoice}{
number of different scales per octave.
}
\item{Qinv}{
inverse of the matrix \eqn{Q} of the quadratic form.
}
\item{epsilon}{
coefficient of the \eqn{Q_2} term in reconstruction kernel
}
\item{np}{
number of samples of the reconstructed signal.
}
\item{w0}{
central frequency of Morlet wavelet.
}
\item{check}{
if set to TRUE, computes \code{\link{cwt}} of reconstructed signal.
}
\item{real}{
if set to TRUE, uses only constraints on the real part of the transform.
}}
\value{
Returns a list containing the reconstructed signal and the chained ridges.
\item{sol}{reconstruction from a ridge}
\item{A}{<wavelets,dualwavelets> matrix }
\item{lam}{coefficients of dual wavelets in reconstructed signal.}
\item{dualwave}{array containing the dual wavelets.}
\item{morvelets}{array of morlet wavelets located on the ridge samples.}
\item{solskel}{wavelet transform of sol, restricted to the ridge}
\item{inputskel}{wavelet transform of signal, restricted to the ridge}
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{sridrec}}, \code{\link{regrec}}, \code{\link{regrec2}}.
}
\keyword{ts}

\name{gsampleOne}
\alias{gsampleOne}
\title{
Sampled Identity
}
\description{
Generate a sampled identity matrix.
}
\usage{
gsampleOne(node, scale, np)
}
\arguments{
\item{node}{
location of the reconstruction gabor functions.
}
\item{scale}{
scale of the gabor functions.
}
\item{np}{
size of the reconstructed signal.
}}
\value{
diagonal of the ``sampled'' \eqn{Q_1} term (1D vector)
}
%\details{}
\references{
See discussions in the text of ``Time-Frequency Analysis''.
}
\seealso{
\code{\link{kernel}}, \code{\link{gkernel}}.
}
\keyword{ts}

\name{cwtsquiz}
\alias{cwtsquiz}
\title{
Squeezed Continuous Wavelet Transform
}
\description{
Computes the synchrosqueezed continuous wavelet transform with
the (complex-valued) Morlet wavelet.
}
\usage{
cwtsquiz(input, noctave, nvoice=1, w0=2 * pi, twoD=TRUE, plot=TRUE)
}
\arguments{
\item{input}{
input signal (possibly complex-valued)
}
\item{noctave}{
number of powers of 2 for the scale variable
}
\item{nvoice}{
number of scales in each octave (i.e. between two consecutive powers of 2).
}
\item{w0}{
central frequency of the wavelet.
}
\item{twoD}{
logical variable set to T to organize the output as a 2D array
(signal size \eqn{\times}{x} nb scales), otherwise, the output is a 3D
array (signal size \eqn{\times}{x} noctave \eqn{\times}{x} nvoice).
}
\item{plot}{
logical variable set to T to T to display the modulus of the squeezed
wavelet transform on the graphic device.
}}
\value{
synchrosqueezed continuous (complex) wavelet transform
}
\details{
The output contains the (complex) values of the squeezed wavelet
transform of the input signal.  The format of the output can be 

2D array (signal size \eqn{\times}{x} nb scales),

3D array (signal size \eqn{\times}{x} noctave \eqn{\times}{x} nvoice).
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{cwt}}, \code{\link{cwtp}}, \code{\link{DOG}},
\code{\link{cgt}}.
}
\keyword{ts}

\name{vgt}
\alias{vgt}
\title{
Gabor Transform on one Voice
}
\description{
Compute Gabor transform for fixed frequency.
}
\usage{
vgt(input, frequency, scale, plot=FALSE)
}
\arguments{
\item{input}{
Input signal (1D array).
}
\item{frequency}{
frequency at which the Gabor transform is to be computed.
}
\item{scale}{
frequency at which the Gabor transform is to be computed.
}
\item{plot}{
if set to TRUE, plots the real part of cgt on the graphic device.
}}
\value{
1D (complex) array containing Gabor transform at specified frequency.
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{vwt}}, \code{\link{vDOG}}.
}
\keyword{ts}

\name{crcrec}
\alias{crcrec}
\title{
Crazy Climbers Reconstruction by Penalization
}
\description{
Reconstructs a real valued signal from the output of \code{\link{crc}}
(wavelet case) by minimizing an appropriate quadratic form.
}
\usage{
crcrec(siginput, inputwt, beemap, noct, nvoice, compr, minnbnodes=2,
w0=2 * pi, bstep=5, ptile=0.01, epsilon=0, fast=FALSE, para=5, real=FALSE,
plot=2)
}
\arguments{
\item{siginput}{
original signal.
}
\item{inputwt}{
wavelet transform.
}
\item{beemap}{
occupation measure, output of \code{\link{crc}}.
}
\item{noct}{
number of octaves.
}
\item{nvoice}{
number of voices per octave.
}
\item{compr}{
compression rate for sampling the ridges.
}
\item{minnbnodes}{
minimal number of points per ridge.
}
\item{w0}{
center frequency of the wavelet.
}
\item{bstep}{
size (in the time direction) of the steps for chaining.
}
\item{ptile}{
relative threshold of occupation measure.
}
\item{epsilon}{
constant in front of the smoothness term in penalty function.
}
\item{fast}{
if set to TRUE, uses trapezoidal rule to evaluate $Q_2$.
}
\item{para}{
scale parameter for extrapolating the ridges.
}
\item{real}{
if set to TRUE, uses only real constraints.
}
\item{plot}{
1: displays signal,components,and
reconstruction one after another. 2: displays
signal, components and reconstruction.
}}
\value{
Returns a structure containing the following elements:
\item{rec}{
  reconstructed signal.
}
\item{ordered}{
  image of the ridges (with different colors).
}
\item{comp}{
  2D array containing the signals reconstructed from ridges.
}
}
\details{
When ptile is high, boundary effects may appeare.
para controls extrapolation of the ridge.
}
%\references{}
\seealso{
\code{\link{crc}}, \code{\link{cfamily}}, \code{\link{scrcrec}}.
}
\keyword{ts}

\name{back1.220}
\alias{back1.220}
\title{Acoustic Returns}
\description{Acoustic returns from an underwater metallic object.
}
\usage{data(back1.220)
}
\format{A vector containing 7936 observations.
}
\source{
  See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\references{
  Carmona, R. A., W. L. Hwang and B Torresani (1998, eBook ISBN:978008053942)
  \emph{Practical Time-Frequency Analysis: Gabor and Wavelet Transforms
    with an Implementation in S}, Academic Press, San Diego.
}
\examples{

data(back1.220)
plot.ts(back1.220)

}


\keyword{datasets}

\name{cwtpolar}
\alias{cwtpolar}
\title{
Conversion to Polar Coordinates
}
\description{
Converts one of the possible outputs of the function \code{\link{cwt}}
to modulus and phase.
}
\usage{
cwtpolar(cwt, threshold=0)
}
\arguments{
\item{cwt}{
3D array containing the values of a continuous wavelet
transform in the format (signal size \eqn{\times}{x} noctave
\eqn{\times}{x} nvoice) as in the output of the function
\code{\link{cwt}} with the logical flag \code{twodimension} set to
FALSE.
}
\item{threshold}{
value of a level for the absolute value of the modulus below which 
the value of the argument of the output is set to \eqn{-\pi}{-pi}.
}}
\value{
Modulus and Argument of the values of the continuous wavelet transform
\item{output1}{
  3D array giving the values (in the same format as the input) of the
  modulus of the input.
}
\item{output2}{
  3D array giving the values of the argument of the input.
}}
\details{
The output contains the (complex) values of the wavelet transform of the
input signal. The format of the output can be 

2D array (signal size \eqn{\times}{x} nb\_scales)

3D array (signal size \eqn{\times}{x} noctave \eqn{\times}{x} nvoice) 
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{cwt}}, \code{\link{DOG}}, \code{\link{cwtimage}}.
}
\examples{
    x <- 1:512
    chirp <- sin(2*pi * (x + 0.002 * (x-256)^2 ) / 16)
    retChirp <- cwt(chirp, noctave=5, nvoice=12, twoD=FALSE, plot=FALSE)
    retPolar <- cwtpolar(retChirp)
}
\keyword{ts}

\name{dwinverse}
\alias{dwinverse}
\title{
Inverse Dyadic Wavelet Transform
}
\description{
Invert the dyadic wavelet transform.
}
\usage{
dwinverse(wt, filtername="Gaussian1")
}
\arguments{
\item{wt}{
dyadic wavelet transform
}
\item{filtername}{
filters used. ("Gaussian1" stands for the filters
corresponds to those of Mallat and Zhong's wavlet. And
"Haar" stands for the filters of Haar basis.	
}}
\value{
Reconstructed signal
}
%\details{}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{mw}}, \code{\link{ext}}, \code{\link{mrecons}}.
}
\keyword{ts}

\name{WV}
\alias{WV}
\title{
  Wigner-Ville function
}
\description{
  Compute the Wigner-Ville transform, without any smoothing.
}
\usage{
WV(input, nvoice, freqstep = (1/nvoice), plot = TRUE)
}
\arguments{
  \item{input}{input signal (possibly complex-valued)}
  \item{nvoice}{number of frequency bands}
  \item{freqstep}{sampling rate for the frequency axis}
  \item{plot}{if set to TRUE, displays the modulus of CWT on the graphic
    device.}
}
\value{
  (complex) Wigner-Ville transform.
}
%\details{}
\references{
  See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
%\seealso{}
\keyword{ts}

\name{smoothts}
\alias{smoothts}
\title{
Smoothing Time Series
}
\description{
Smooth a time series by averaging window.
}
\usage{
smoothts(ts, windowsize)
}
\arguments{
\item{ts}{
Time series.
}
\item{windowsize}{
Length of smoothing window.
}}
\value{
Smoothed time series (1D array).
}
%\details{}
\references{
See discussions in the text of \dQuote{Time-Frequency Analysis}.
}
%\seealso{}
\keyword{ts}

\name{check.maxresoln}
\alias{check.maxresoln}
\title{
Verify Maximum Resolution
}
\description{
Stop when \eqn{2^{maxresoln}} is larger than the signal size.
}
\usage{
check.maxresoln(maxresoln, np)
}
\arguments{
\item{maxresoln}{
number of decomposition scales.
}
\item{np}{
signal size.
}}
%\value{}
%\details{}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{mw}}, \code{\link{mrecons}}.
}
\keyword{ts}

\name{DOG}
\alias{DOG}
\title{
Continuous Wavelet Transform with
derivative of Gaussian
}
\description{
Computes the continuous wavelet transform with for (complex-valued) 
derivative of Gaussian wavelets.
}
\usage{
DOG(input, noctave, nvoice=1, moments, twoD=TRUE, plot=TRUE)
}
\arguments{
\item{input}{
input signal (possibly complex-valued).
}
\item{noctave}{
number of powers of 2 for the scale variable.
}
\item{moments}{
number of vanishing moments of the wavelet
(order of the derivative).
}
\item{nvoice}{
number of scales in each octave (i.e. between two
consecutive powers of 2)
}
\item{twoD}{
logical variable set to T to organize the
output as a 2D array 
(signal\_size x nb\_scales), otherwise, the output is a 3D array 
(signal\_size x noctave x nvoice)
}
\item{plot}{
if set to T, display the modulus of the
continuous wavelet transform on the graphic device
}}
\value{
continuous (complex) wavelet transform
}
\details{
The output contains the (complex) values of the wavelet transform of the
input signal.
The format of the output can be 


2D array (signal\_size x nb\_scales)


3D array (signal\_size x noctave x nvoice) 
}
\references{
  See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{cwt}}, \code{\link{cwtp}}, \code{\link{cwtsquiz}},
\code{\link{cgt}}.
}
\examples{
 x <- 1:512
    chirp <- sin(2*pi * (x + 0.002 * (x-256)^2 ) / 16)
  
 DOG(chirp, noctave=5, nvoice=12, 3, twoD=TRUE, plot=TRUE)


}
\keyword{ts}

\name{skeleton}
\alias{skeleton}
\title{
Reconstruction from Dual Wavelets
}
\description{
Computes the reconstructed signal from the ridge, given
the inverse of the matrix Q.
}
\usage{
skeleton(cwtinput, Qinv, morvelets, bridge, aridge, N)
}
\arguments{
\item{cwtinput}{
continuous wavelet transform (as the output of cwt)
}
\item{Qinv}{
inverse of the reconstruction kernel (2D array)
}
\item{morvelets}{
array of Morlet wavelets located at the ridge samples
}
\item{bridge}{
time coordinates of the ridge samples
}
\item{aridge}{
scale coordinates of the ridge samples
}
\item{N}{
size of reconstructed signal
}}
\value{
Returns a list of the elements of the reconstruction of a signal from
sample points of a ridge
\item{sol}{reconstruction from a ridge}
\item{A}{matrix of the inner products}
\item{lam}{coefficients of dual wavelets in reconstructed signal.
  They are the Lagrange multipliers \eqn{\lambda}{lambda}'s of the
  text.}
\item{dualwave}{array containing the dual wavelets.}
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{skeleton2}}, \code{\link{zeroskeleton}},
\code{\link{zeroskeleton2}}.
}
\keyword{ts}

\name{zeroskeleton2}
\alias{zeroskeleton2}
\title{
Reconstruction from Dual Wavelets
}
\description{
Computes the the reconstructed signal from the ridge when the epsilon
parameter is set to zero, in the case of real constraints.
}
\usage{
zeroskeleton2(cwtinput, Qinv, morvelets, bridge, aridge, N)
}
\arguments{
\item{cwtinput}{
continuous wavelet transform (output of \code{\link{cwt}}).
}
\item{Qinv}{
inverse of the reconstruction kernel (2D array).
}
\item{morvelets}{
array of Morlet wavelets located at the ridge samples.
}
\item{bridge}{
time coordinates of the ridge samples.
}
\item{aridge}{
scale coordinates of the ridge samples.
}
\item{N}{
size of reconstructed signal.
}}
\value{
Returns a list of the elements of the reconstruction of a signal from
sample points of a ridge
\item{sol}{reconstruction from a ridge.}
\item{A}{matrix of the inner products.}
\item{lam}{coefficients of dual wavelets in reconstructed signal. They
  are the Lagrange multipliers \eqn{\lambda}{lambda}'s of the text.}
\item{dualwave}{array containing the dual wavelets.}
}
\details{
The details of this reconstruction are the same as for the function
skeleton. They can be found in the text
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
  \code{\link{skeleton}}, \code{\link{skeleton2}},
  \code{\link{zeroskeleton}}.
}
\keyword{ts}

\name{cwt}
\alias{cwt}
\title{
Continuous Wavelet Transform
}
\description{
Computes the continuous wavelet transform with for the (complex-valued) 
Morlet wavelet.
}
\usage{
cwt(input, noctave, nvoice=1, w0=2 * pi, twoD=TRUE, plot=TRUE)
}
\arguments{
\item{input}{
input signal (possibly complex-valued)
}
\item{noctave}{
number of powers of 2 for the scale variable
}
\item{nvoice}{
number of scales in each octave
(i.e. between two consecutive powers of 2).
}
\item{w0}{
central frequency of the wavelet.
}
\item{twoD}{
logical variable set to T to organize the output as a 2D array 
(signal_size x nb_scales), otherwise, the output is a 3D array 
(signal_size x noctave x nvoice).
}
\item{plot}{
if set to T, display the modulus of the
continuous wavelet transform on the graphic device.
}}
\value{
continuous (complex) wavelet transform
}
\details{

  The time series is padded with zeroes to avoid problems with
  circular versus linear convolution. This does not affect usage,
  as the matrix returned has the added columns removed. (JML Sep 29, 2021).
  
The output contains the (complex) values of the wavelet transform of the
input signal. The format of the output can be

2D array (signal_size x nb_scales)

3D array (signal_size x noctave x nvoice)

Since Morlet's wavelet is not strictly speaking a wavelet (it is not of
vanishing integral), artifacts may occur for certain signals.
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{cwtp}}, \code{\link{cwtTh}}, \code{\link{DOG}},
\code{\link{gabor}}.
}
\examples{
    x <- 1:512
    chirp <- sin(2*pi * (x + 0.002 * (x-256)^2 ) / 16)
    retChirp <- cwt(chirp, noctave=5, nvoice=12)
}
\keyword{ts}

\name{crc}
\alias{crc}
\title{
Ridge Extraction by Crazy Climbers
}
\description{
Uses the "crazy climber algorithm" to detect ridges in the modulus of
a continuous wavelet or a Gabor transform.
}
\usage{
crc(tfrep, tfspec=numeric(dim(tfrep)[2]), bstep=3, iteration=10000,
rate=0.001, seed=-7, nbclimb=10, flag.int=TRUE, chain=TRUE,
flag.temp=FALSE)
}
\arguments{
\item{tfrep}{
modulus of the (wavelet or Gabor) transform.
}
\item{tfspec}{
numeric vector which gives, for each value of the scale or frequency the
expected size of the noise contribution.
}
\item{bstep}{
stepsize for random walk of the climbers.
}
\item{iteration}{
number of iterations.
}
\item{rate}{
initial value of the temperature.
}
\item{seed}{
initial value of the random number generator.
}
\item{nbclimb}{
number of crazy climbers.
}
\item{flag.int}{
if set to TRUE, the weighted occupation measure is computed.
}
\item{chain}{
if set to TRUE, chaining of the ridges is done.
}
\item{flag.temp}{
if set to TRUE: constant temperature.
}}
\value{
Returns a 2D array called beemap containing the (weighted or unweighted)
occupation measure (integrated with respect to time)
}
%\details{}
\references{
See discussion in text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{corona}}, \code{\link{icm}}, \code{\link{coronoid}},
\code{\link{snake}}, \code{\link{snakoid}} for ridge estimation,
\code{\link{cfamily}} for chaining and
\code{\link{crcrec}},\code{\link{gcrcrec}},\code{\link{scrcrec}} for
reconstruction. 
}
\examples{
   data(HOWAREYOU)
 plot.ts(HOWAREYOU)
 
cgtHOWAREYOU <- cgt(HOWAREYOU,70,0.01,100)

clHOWAREYOU <- crc(Mod(cgtHOWAREYOU),nbclimb=1000)

}

\keyword{ts}

\name{regrec2}
\alias{regrec2}
\title{
Reconstruction from a Ridge
}
\description{
Reconstructs signal from a ``regularly sampled'' ridge,
in the wavelet case, from a precomputed kernel.
}
\usage{
regrec2(siginput, cwtinput, phi, nbnodes, noct, nvoice, Q2,
epsilon=0.5, w0=2 * pi, plot=FALSE)
}
\arguments{
\item{siginput}{
input signal.
}
\item{cwtinput}{
wavelet transform, output of \code{\link{cwt}}.
}
\item{phi}{
unsampled ridge.
}
\item{nbnodes}{
number of samples on the ridge
}
\item{noct}{
number of octaves (powers of 2)
}
\item{nvoice}{
number of different scales per octave
}
\item{Q2}{
second term of the reconstruction kernel
}
\item{epsilon}{
coefficient of the \eqn{Q_2} term in reconstruction kernel
}
\item{w0}{
central frequency of Morlet wavelet
}
\item{plot}{
if set to TRUE, displays original and reconstructed signals
}}
\value{
Returns a list containing:
\item{sol}{
  reconstruction from a ridge.
}
\item{A}{
  <wavelets,dualwavelets> matrix.
}
\item{lam}{
  coefficients of dual wavelets in reconstructed signal.
}
\item{dualwave}{
  array containing the dual wavelets.
}
\item{morvelets}{
  array containing the wavelets on sampled ridge.
}
\item{solskel}{
  wavelet transform of sol, restricted to the ridge.
}
\item{inputskel}{
  wavelet transform of signal, restricted to the ridge.
}
\item{nbnodes}{
  number of nodes used for the reconstruction.
}}
\details{
The computation of the kernel may be time consuming. This function
avoids recomputing it if it was computed already.
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{regrec}}, \code{\link{gregrec}}, \code{\link{ridrec}},
\code{\link{sridrec}}. 
}
\keyword{ts}

\name{smoothwt}
\alias{smoothwt}
\title{
Smoothing and Time Frequency Representation
}
\description{
smooth the wavelet (or Gabor) transform in the time direction.
}
\usage{
smoothwt(modulus, subrate, flag=FALSE)
}
\arguments{
\item{modulus}{
Time-Frequency representation (real valued).
}
\item{subrate}{
Length of smoothing window.
}
\item{flag}{
If set to TRUE, subsample the representation.
}}
\value{
2D array containing the smoothed transform.
}
%\details{}
\references{
See discussions in the text of \dQuote{Time-Frequency Analysis}.
}
\seealso{
\code{\link{corona}}, \code{\link{coronoid}}, \code{\link{snake}},
\code{\link{snakoid}}.
}
\keyword{ts}

\name{scrcrec}
\alias{scrcrec}
\title{
Simple Reconstruction from Crazy Climbers Ridges
}
\description{
Reconstructs signal from ridges obtained by \code{\link{crc}},
using the restriction of the transform to the ridge.
}
\usage{
scrcrec(siginput, tfinput, beemap, bstep=5, ptile=0.01, plot=2)
}
\arguments{
\item{siginput}{
input signal.
}
\item{tfinput}{
time-frequency representation (output of \code{\link{cwt}}
or \code{\link{cgt}}.
}
\item{beemap}{
output of crazy climber algorithm
}
\item{bstep}{
used for the chaining (see \code{\link{cfamily}}).
}
\item{ptile}{
threshold on the measure beemap (see \code{\link{cfamily}}).
}
\item{plot}{
  1: displays signal,components, and reconstruction one after another.\cr
  2: displays signal, components and reconstruction.\cr
  Else, no plot.
}}
\value{
Returns a list containing the reconstructed signal and the chained ridges.
\item{rec}{reconstructed signal}
\item{ordered}{image of the ridges (with different colors)}
\item{comp}{2D array containing the signals reconstructed from ridges}
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{crc}},\code{\link{cfamily}} for crazy climbers method,
\code{\link{crcrec}} for reconstruction methods.
}
\keyword{ts}

\name{npl}
\alias{npl}
\title{
Prepare Graphics Environment
}
\description{
Splits the graphics device into prescrivbed number of windows.
}
\usage{
npl(nbrow)
}
\arguments{
\item{nbrow}{
number of plots.
}}
%\value{}
%\details{}
%\references{}
%\seealso{}
\keyword{ts}

\name{tflmax}
\alias{tflmax}
\title{
Time-Frequency Transform Local Maxima
}
\description{
Computes the local maxima (for each fixed value of the time variable)
of the modulus of a time-frequency transform.
}
\usage{
tflmax(input, plot=TRUE)
}
\arguments{
\item{input}{
time-frequency transform (real 2D array).
}
\item{plot}{
 if set to T, displays the local maxima on the graphic device.
}}
\value{
values of the maxima (2D array).
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{tfgmax}}.
}
\keyword{ts}

\name{rkernel}
\alias{rkernel}
\title{
Kernel for Reconstruction from Wavelet Ridges
}
\description{
Computes the cost from the sample of points on the estimated ridge
and the matrix used in the reconstruction of the original signal,
in the case of real constraints. Modification of the function
\code{\link{kernel}}.
}
\usage{
rkernel(node, phinode, nvoice, x.inc=1, x.min=node[1],
x.max=node[length(node)], w0=2 * pi, plot=FALSE)
}
\arguments{
\item{node}{
values of the variable b for the nodes of the ridge.
}
\item{phinode}{
values of the scale variable a for the nodes of the ridge.
}
\item{nvoice}{
number of scales within 1 octave.
}
\item{x.inc}{
step unit for the computation of the kernel.
}
\item{x.min}{
minimal value of x for the computation of \eqn{Q_2}.
}
\item{x.max}{
maximal value of x for the computation of \eqn{Q_2}.
}
\item{w0}{
central frequency of the wavelet.
}
\item{plot}{
if set to TRUE, displays the modulus of the matrix of \eqn{Q_2}.
}}
\value{
matrix of the \eqn{Q_2} kernel
}
\details{
Uses Romberg's method for computing the kernel.
}
\references{
See discussions in the text of "Time-Frequency Analysis".
}
\seealso{
\code{\link{kernel}}, \code{\link{fastkernel}}, \code{\link{gkernel}},
\code{\link{zerokernel}}.
}
\keyword{ts}

\name{vecgabor}
\alias{vecgabor}
\title{
Gabor Functions on a Ridge
}
\description{
Generate Gabor functions at specified positions on a ridge.
}
\usage{
vecgabor(sigsize, nbnodes, location, frequency, scale)
}
\arguments{
\item{sigsize}{
Signal size.
}
\item{nbnodes}{
Number of wavelets to be generated.
}
\item{location}{
b coordinates of the ridge samples (1D array of length nbnodes).
}
\item{frequency}{
frequency coordinates of the ridge samples (1D array of length nbnodes).
}
\item{scale}{
size parameter for the Gabor functions.
}}
\value{
size parameter for the Gabor functions.
}
%\details{}
%\references{}
\seealso{
\code{\link{vecmorlet}}.
}
\keyword{ts}

\name{tfpct}
\alias{tfpct}
\title{
Percentile frequency by frequency
}
\description{
Compute a percentile of time-frequency representation frequency 
by frequency.
}
\usage{
tfpct(input, percent=0.8, plot=TRUE)
}
\arguments{
\item{input}{
time-frequency transform (output of \code{\link{cwt}} or \code{\link{cgt}}).
}
\item{percent}{
percentile to be retained.
}
\item{plot}{
if set to T, displays the values of the energy as a 
function of the scale (or frequency).
}}
\value{
1D array containing the noise estimate.
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{tfmean}},\code{\link{tfvar}}.
}
\keyword{ts}

\name{wspec.pl}
\alias{wspec.pl}
\title{Log of Wavelet Spectrum Plot}
\description{
  Displays normalized log of wavelet spectrum.
}
\usage{wspec.pl(wspec, nvoice)
}
\arguments{
  \item{wspec}{
    wavelet spectrum.
  }
  \item{nvoice}{
    number of voices.
  }
}
%\value{}
%\details{}
\references{
  See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{\code{\link{hurst.est}}.
}
\keyword{ts}
\keyword{hplot}

\name{mbtrim}
\alias{mbtrim}
\title{
Trim Dyadic Wavelet Transform Extrema
}
\description{
Trimming of dyadic wavelet transform local extrema, using
bootstrapping.
}
\usage{
mbtrim(extrema, scale=FALSE, prct=0.95)
}
\arguments{
  \item{extrema}{
    dyadic wavelet transform extrema (output of \code{\link{ext}}).
  }
  \item{scale}{
    when set, the wavelet transform at each scale will be plotted 
    with the same scale.
  }
  \item{prct}{percentage critical value used for thresholding}
}
\value{
Structure containing
\item{original}{
  original signal.
}
\item{extrema}{
  trimmed extrema representation.
}
\item{Sf}{
  coarse resolution of signal.
}
\item{maxresoln}{
  number of decomposition scales.
}
\item{np}{
  size of signal.
}}
\details{
The distribution of extrema of dyadic wavelet transform at each scale is
generated by bootstrap method, and the 95\% critical value is used for
thresholding the extrema of the signal.
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{mntrim}}, \code{\link{mrecons}}, \code{\link{ext}}.
}
\keyword{ts}

\name{sig_W_tilda.1}
\alias{sig_W_tilda.1}
\title{Pixel from Amber Camara}
\description{Pixel from amber camara.
}
\usage{data(sig_W_tilda.1)
}
\format{A vector containing observations.
}
\source{
  See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\references{
  Carmona, R. A., W. L. Hwang and B Torresani (1998, eBook ISBN:978008053942)
  \emph{Practical Time-Frequency Analysis: Gabor and Wavelet Transforms
    with an Implementation in S}, Academic Press, San Diego.
}
\examples{

data(sig_W_tilda.1)
plot.ts(sig_W_tilda.1)

}

\keyword{datasets}

\name{tfgmax}
\alias{tfgmax}
\title{
Time-Frequency Transform Global Maxima
}
\description{
Computes the maxima (for each fixed value of the time variable)
of the modulus of a continuous wavelet transform.
}
\usage{
tfgmax(input, plot=TRUE)
}
\arguments{
\item{input}{
wavelet transform (as the output of the function \code{\link{cwt}})
}
\item{plot}{
if set to TRUE, displays the values of the energy as
a function of the scale.
}}
\value{
\item{output}{values of the maxima (1D array)}
\item{pos}{positions of the maxima (1D array)}
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{tflmax}}.
}
\keyword{ts}

\name{RidgeSampling}
\alias{RidgeSampling}
\title{
Sampling Gabor Ridge
}
\description{
Given a ridge phi (for the Gabor transform), returns a 
(regularly) subsampled version of length nbnodes.
}
\usage{
RidgeSampling(phi, nbnodes)
}
\arguments{
\item{phi}{
ridge (1D array).
}
\item{nbnodes}{
number of samples.
}}
\value{
Returns a list containing the discrete values of the ridge.
\item{node}{
  time coordinates of the ridge samples.
}
\item{phinode}{
  frequency coordinates of the ridge samples.
}}
\details{
Gabor ridges are sampled uniformly.
}
\references{
See discussions in the text of "Time-Frequency Analysis''.
}
\seealso{
\code{\link{wRidgeSampling}}.
}
\keyword{ts}

\name{C0}
\alias{C0}
\title{Transient Signal}
\description{Transient signal.
}
\usage{data(C0)
}
\format{A vector containing 1024 observations.
}
\source{
  See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\references{
  Carmona, R. A., W. L. Hwang and B Torresani (1998, eBook ISBN:978008053942)
  \emph{Practical Time-Frequency Analysis: Gabor and Wavelet Transforms
    with an Implementation in S}, Academic Press, San Diego.
}
\examples{

data(C0)
plot.ts(C0)

}


\keyword{datasets}

\name{cgt}
\alias{cgt}
\title{
Continuous Gabor Transform
}
\description{
Computes the continuous Gabor transform with Gaussian window.
}
\usage{
cgt(input, nvoice, freqstep=(1/nvoice), scale=1, plot=TRUE)
}
\arguments{
\item{input}{
input signal (possibly complex-valued).
}
\item{nvoice}{
number of frequencies for which gabor transform
is to be computed.
}
\item{freqstep}{
Sampling rate for the frequency axis.
}
\item{scale}{
Size parameter for the window.
}
\item{plot}{
logical variable set to TRUE to display the modulus of the
continuous gabor transform on the graphic device.
}}
\value{
continuous (complex) gabor transform (2D array).
}
\details{
The output contains the (complex) values of the gabor transform of the
input signal. The format of the output is
a 2D array (signal\_size x nb\_scales).
}
\references{
See discussion in text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{cwt}}, \code{\link{cwtp}}, \code{\link{DOG}} for continuous wavelet transforms.
\code{\link{cwtsquiz}} for synchrosqueezed wavelet transform.
}
\examples{
data(HOWAREYOU)
   plot.ts(HOWAREYOU)
 
cgtHOWAREYOU <- cgt(HOWAREYOU,70,0.01,100)

}

\keyword{ts}
\section{Warning}{
freqstep must be less than 1/nvoice to avoid aliasing. freqstep=1/nvoice
corresponds to the Nyquist limit.
}

\name{SVD}
\alias{SVD}
\title{
Singular Value Decomposition
}
\description{
Computes singular value decomposition of a matrix.
}
\usage{
SVD(a)
}
\arguments{
\item{a}{
input matrix.
}}
\value{
a structure containing the 3 matrices of the singular value
decomposition of the input.
}
\details{
\R interface for Numerical Recipes singular value decomposition routine.
}
\references{
See discussions in the text of \dQuote{Time-Frequency Analysis}.
}
%\seealso{}
\examples{
   hilbert <- function(n) { i <- 1:n; 1 / outer(i - 1, i, "+") }
     X <- hilbert(6)
     z  = SVD(X)
     z
}
\keyword{ts}

\name{gridrec}
\alias{gridrec}
\title{
Reconstruction from a Ridge
}
\description{
Reconstructs signal from sample of a ridge, in the Gabor case.
}
\usage{
gridrec(gtinput, node, phinode, nvoice, freqstep, scale, Qinv,
epsilon, np, real=FALSE, check=FALSE)
}
\arguments{
\item{gtinput}{
Gabor transform, output of \code{\link{cgt}}.
}
\item{node}{
time coordinates of the ridge samples.
}
\item{phinode}{
frequency coordinates of the ridge samples.
}
\item{nvoice}{
number of different frequencies.
}
\item{freqstep}{
sampling rate for the frequency axis.
}
\item{scale}{
scale of the window.
}
\item{Qinv}{
inverse of the matrix \eqn{Q} of the quadratic form.
}
\item{epsilon}{
coefficient of the \eqn{Q_2} term in reconstruction kernel
}
\item{np}{
number of samples of the reconstructed signal.
}
\item{real}{
if set to TRUE, uses only constraints on the real part
of the transform.
}
\item{check}{
if set to TRUE, computes \code{\link{cgt}} of
reconstructed signal.
}}
\value{
Returns a list containing the reconstructed signal and the chained ridges.
\item{sol}{
  reconstruction from a ridge.
}
\item{A}{
  <gaborlets,dualgaborlets> matrix.
}
\item{lam}{
  coefficients of dual gaborlets in reconstructed signal.
}
\item{dualwave}{
  array containing the dual gaborlets.
}
\item{gaborets}{
  array of gaborlets located on the ridge samples.
}
\item{solskel}{
  Gabor transform of sol, restricted to the ridge.
}
\item{inputskel}{
  Gabor transform of signal, restricted to the ridge.
}}
%\details{}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{sridrec}}, \code{\link{gregrec}}, \code{\link{regrec}},
\code{\link{regrec2}}.
}
\keyword{ts}

\name{cleanph}
\alias{cleanph}
\title{
Threshold Phase based on Modulus
}
\description{
Sets to zero the phase of time-frequency transform when
modulus is below a certain value.
}
\usage{
cleanph(tfrep, thresh=0.01, plot=TRUE)
}
\arguments{
\item{tfrep}{
continuous time-frequency transform (2D array)
}
\item{thresh}{
(relative) threshold.
}
\item{plot}{
if set to TRUE, displays the maxima of cwt on the graphic
device.
}}
\value{
thresholded phase (2D array)
}
%\details{}
\references{
See discussion in text of ``Practical Time-Frequency Analysis''.
}
%\seealso{}
\keyword{ts}

\name{wpl}
\alias{wpl}
\title{
Plot Dyadic Wavelet Transform.
}
\description{
Plot dyadic wavelet transform(output of \code{\link{mw}}).
}
\usage{
wpl(dwtrans)
}
\arguments{
\item{dwtrans}{
dyadic wavelet transform (output of \code{\link{mw}}).
}}
%\value{}
%\details{}
%\references{}
\seealso{
\code{\link{mw}}, \code{\link{ext}},\code{\link{epl}}.
}
\keyword{ts}

\name{gkernel}
\alias{gkernel}
\title{
Kernel for Reconstruction from Gabor Ridges
}
\description{
Computes the cost from the sample of points on the estimated ridge
and the matrix used in the reconstruction of the original signal.
}
\usage{
gkernel(node, phinode, freqstep, scale, x.inc=1, x.min=node[1],
x.max=node[length(node)], plot=FALSE)
}
\arguments{
\item{node}{
values of the variable b for the nodes of the ridge.
}
\item{phinode}{
values of the scale variable a for the nodes of the ridge.
}
\item{freqstep}{
sampling rate for the frequency axis.
}
\item{scale}{
size of the window.
}
\item{x.inc}{
step unit for the computation of the kernel.
}
\item{x.min}{
minimal value of x for the computation of \eqn{Q_2}.
}
\item{x.max}{
maximal value of x for the computation of \eqn{Q_2}.
}
\item{plot}{
if set to TRUE, displays the modulus of the matrix of \eqn{Q_2}.
}}
\value{
matrix of the \eqn{Q_2} kernel
}
%\details{}
\references{
See discussions in the text of ``Time-Frequency Analysis''.
}
\seealso{
\code{\link{fastgkernel}}, \code{\link{kernel}}, \code{\link{rkernel}},
\code{\link{fastkernel}}, \code{\link{zerokernel}}.
}
\keyword{ts}

\name{sridrec}
\alias{sridrec}
\title{
Simple Reconstruction from Ridge
}
\description{
Simple reconstruction of a real valued signal from a ridge,
by restriction of the transform to the ridge.
}
\usage{
sridrec(tfinput, ridge)
}
\arguments{
\item{tfinput}{
time-frequency representation.
}
\item{ridge}{
ridge (1D array).
}}
\value{
(real) reconstructed signal (1D array)
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{ridrec}}, \code{\link{gridrec}}.
}
\keyword{ts}

\name{cwtimage}
\alias{cwtimage}
\title{
Continuous Wavelet Transform Display
}
\description{
Converts the output (modulus or argument) of cwtpolar to a 
2D array and displays on the graphic device.
}
\usage{
cwtimage(input)
}
\arguments{
\item{input}{
3D array containing a continuous wavelet transform
}}
\value{
2D array continuous (complex) wavelet transform
}
\details{
The output contains the (complex) values of the wavelet transform of the
input signal. The format of the output can be 
% format of the input??

2D array (signal\_size x nb\_scales)

3D array (signal\_size x noctave x nvoice) 
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{cwtpolar}}, \code{\link{cwt}}, \code{\link{DOG}}.
}
\examples{
    x <- 1:512
    chirp <- sin(2*pi * (x + 0.002 * (x-256)^2 ) / 16)
    retChirp <- cwt(chirp, noctave=5, nvoice=12, twoD=FALSE, plot=FALSE)
    retPolar <- cwtpolar(retChirp)
    retImageMod <- cwtimage(retPolar$modulus)
    retImageArg <- cwtimage(retPolar$argument)
}
\keyword{ts}

\name{mw}
\alias{mw}
\title{
Dyadic Wavelet Transform
}
\description{
Dyadic wavelet transform, with Mallat's wavelet.
The reconstructed signal preserves locations and values at extrema.
}
\usage{
mw(inputdata, maxresoln, filtername="Gaussian1", scale=FALSE, plot=TRUE)
}
\arguments{
\item{inputdata}{
either a text file or an \R object containing data.
}
\item{maxresoln}{
number of decomposition scales.
}
\item{filtername}{
name of filter (either Gaussian1 for Mallat and Zhong's wavelet or
Haar wavelet).
}
\item{scale}{
when set, the wavelet transform at each scale is plotted 
with the same scale.
}
\item{plot}{
indicate if the wavelet transform at each
scale will be plotted.
}}
\value{
Structure containing
\item{original}{
  original signal.
}
\item{Wf}{
  dyadic wavelet transform of signal.
}
\item{Sf}{
  multiresolution of signal.
}
\item{maxresoln}{
  number of decomposition scales.
}
\item{np}{
  size of signal.
}}
\details{
The decomposition goes from resolution 1 to the given maximum resolution.  
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{dwinverse}}, \code{\link{mrecons}}, \code{\link{ext}}.
}
\keyword{ts}

\name{gabor}
\alias{gabor}
\title{
Generate Gabor function
}
\description{
Generates a Gabor for given location and frequency.
}
\usage{
gabor(sigsize, location, frequency, scale)
}
\arguments{
\item{sigsize}{
length of the Gabor function.
}
\item{location}{
position of the Gabor function.
}
\item{frequency}{
frequency of the Gabor function.
}
\item{scale}{
size parameter for the Gabor function. See details.
}}
\value{
complex 1D array of size sigsize.
}
\details{The size parameter here corresponds to the
standard deviation for a gaussian.  In the Carmona (1998, eBook ISBN:978008053942) book, equation 3.23 has a different scale factor. }
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{morlet}}.
}
\examples{

m1 = gabor(1024, 512,  2 * pi, 20 )

plot.ts(Re(m1) )


}

\keyword{ts}

\name{ext}
\alias{ext}
\title{
Extrema of Dyadic Wavelet Transform
}
\description{
Compute the local extrema of the dyadic wavelet transform modulus.
}
\usage{
ext(wt, scale=FALSE, plot=TRUE)
}
\arguments{
\item{wt}{
dyadic wavelet transform.
}
\item{scale}{
flag indicating if the extrema at each 
resolution will be plotted at the same scale.
}
\item{plot}{
if set to TRUE, displays the transform on the graphics device.
}}
\value{
Structure containing:
\item{original}{
  original signal.
}
\item{extrema}{
  extrema representation.
}
\item{Sf}{
  coarse resolution of signal.
}
\item{maxresoln}{
  number of decomposition scales.
}
\item{np}{
  size of signal.
}
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{mw}}, \code{\link{mrecons}}.
}
\keyword{ts}

\name{zerokernel}
\alias{zerokernel}
\title{
Reconstruction from Wavelet Ridges
}
\description{
Generate a zero kernel for reconstruction from ridges.
}
\usage{
zerokernel(x.inc=1, x.min, x.max)
}
\arguments{
\item{x.min}{
minimal value of x for the computation of \eqn{Q_2}.
}
\item{x.max}{
maximal value of x for the computation of \eqn{Q_2}.
}
\item{x.inc}{
step unit for the computation of the kernel.
}}
\value{
matrix of the \eqn{Q_2} kernel
}
%\details{}
%\references{}
\seealso{
\code{\link{kernel}}, \code{\link{fastkernel}}, \code{\link{gkernel}},
\code{\link{gkernel}}.
}
\keyword{ts}

\name{gwave}
\alias{gwave}
\title{
Gabor Functions on a Ridge
}
\description{
Generation of Gabor functions located on the ridge.
}
\usage{
gwave(bridge, omegaridge, nvoice, freqstep, scale, np, N)
}
\arguments{
\item{bridge}{
time coordinates of the ridge samples
}
\item{omegaridge}{
frequency coordinates of the ridge samples
}
\item{nvoice}{
number of different scales per octave
}
\item{freqstep}{
sampling rate for the frequency axis
}
\item{scale}{
scale of the window
}
\item{np}{
size of the reconstruction kernel
}
\item{N}{
number of complex constraints
}}
\value{
Array of Gabor functions located on the ridge samples
}
%\details{}
\references{
See discussions in the text of "Time-Frequency Analysis''.
}
\seealso{
\code{\link{gwave2}}, \code{\link{morwave}}, \code{\link{morwave2}}.
}
\keyword{ts}

\name{vecmorlet}
\alias{vecmorlet}
\title{
Morlet Wavelets on a Ridge
}
\description{
Generate Morlet wavelets at specified positions on a ridge.
}
\usage{
vecmorlet(sigsize, nbnodes, bridge, aridge, w0=2 * pi)
}
\arguments{
\item{sigsize}{
Signal size.
}
\item{nbnodes}{
Number of wavelets to be generated.
}
\item{bridge}{
b coordinates of the ridge samples (1D array of length nbnodes).
}
\item{aridge}{
a coordinates of the ridge samples (1D array of length nbnodes).
}
\item{w0}{
Center frequency of the wavelet.
}}
\value{
2D (complex) array containing wavelets located at the specific points.
}
%\details{}
%\references{}
\seealso{
\code{\link{vecgabor}}.
}
\keyword{ts}

\name{snakeview}
\alias{snakeview}
\title{
Restriction to a Snake
}
\description{
Restrict time-frequency transform to a snake.
}
\usage{
snakeview(modulus, snake)
}
\arguments{
\item{modulus}{
Time-Frequency representation (real valued).
}
\item{snake}{
Time and frequency components of a snake.
}}
\value{
2D array containing the restriction of the transform modulus
to the snake.
}
\details{
Recall that a snake is a (two components) \R structure.
}
\references{
See discussions in the text of \dQuote{Time-Frequency Analysis}.
}
%\seealso{}
\keyword{ts}

\name{plotwt}
\alias{plotwt}
\title{
Plot Dyadic Wavelet Transform
}
\description{
Plot dyadic wavelet transform.
}
\usage{
plotwt(original, psi, phi, maxresoln, scale=FALSE, yaxtype="s")
}
\arguments{
\item{original}{
input signal.
}
\item{psi}{
dyadic wavelet transform.
}
\item{phi}{
scaling function transform at last resolution.
}
\item{maxresoln}{
number of decomposition scales.
}
\item{scale}{
when set, the wavelet transform at each scale is plotted with the same
scale.
}
\item{yaxtype}{
 axis type (see \R manual).
}}
%\value{}
%\details{}
\references{
See discussions in the text of \dQuote{Time-Frequency Analysis}.
}
\seealso{
\code{\link{plotResult}}, \code{\link{epl}}, \code{\link{wpl}}.
}
\keyword{ts}

\name{cwtp}
\alias{cwtp}
\title{Continuous Wavelet Transform with Phase Derivative}
\description{
Computes the continuous wavelet transform with (complex-valued)
Morlet wavelet and its phase derivative.
}
\usage{
cwtp(input, noctave, nvoice=1, w0=2 * pi, twoD=TRUE, plot=TRUE)
}
\arguments{
\item{input}{input signal (possibly complex-valued)}
\item{noctave}{number of powers of 2 for the scale variable}
\item{nvoice}{number of scales in each octave (i.e., between two 
  consecutive powers of 2).}
\item{w0}{central frequency of the wavelet.}
\item{twoD}{logical variable set to \code{T} to organize the output as a 
  2D array (signal size \eqn{\times}{x} nb scales), otherwise, the output 
  is a 3D array (signal size \eqn{\times}{x} noctave \eqn{\times}{x} 
  nvoice).}
\item{plot}{if set to \code{TRUE}, display the modulus of the continuous 
  wavelet transform on the graphic device.}
}
%\details{}
\value{
list containing the continuous (complex) wavelet transform
and the phase derivative
\item{wt}{array of complex numbers for the values of the continuous wavelet 
  transform.}
\item{f}{array of the same dimensions containing the values of the derivative
  of the phase of the continuous wavelet transform.}
}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{cgt}}, \code{\link{cwt}}, \code{\link{cwtTh}},
\code{\link{DOG}} for wavelet transform, and \code{\link{gabor}} for
continuous Gabor transform.
}
\examples{
    ## discards imaginary part with error,
    ## c code does not account for Im(input)
    x <- 1:512
    chirp <- sin(2*pi * (x + 0.002 * (x-256)^2 ) / 16)
    chirp <- chirp + 1i * sin(2*pi * (x + 0.004 * (x-256)^2 ) / 16)
    retChirp <- cwtp(chirp, noctave=5, nvoice=12)
}
\keyword{ts}

\name{regrec}
\alias{regrec}
\title{
Reconstruction from a Ridge
}
\description{
Reconstructs signal from a \dQuote{regularly sampled} ridge, in the wavelet 
case.
}
\usage{
regrec(siginput, cwtinput, phi, compr, noct, nvoice, epsilon=0,
w0=2 * pi, fast=FALSE, plot=FALSE, para=0, hflag=FALSE,
check=FALSE, minnbnodes=2, real=FALSE)
}
\arguments{
\item{siginput}{
input signal.
}
\item{cwtinput}{
wavelet transform, output of \code{\link{cwt}}.
}
\item{phi}{
unsampled ridge.
}
\item{compr}{
subsampling rate for the wavelet coefficients (at scale 1)
}
\item{noct}{
number of octaves (powers of 2)
}
\item{nvoice}{
number of different scales per octave
}
\item{epsilon}{
coefficient of the \eqn{Q_2} term in reconstruction kernel
}
\item{w0}{
central frequency of Morlet wavelet
}
\item{fast}{
if set to TRUE, the kernel is computed using trapezoidal rule.
}
\item{plot}{
if set to TRUE, displays original and reconstructed signals
}
\item{para}{
scale parameter for extrapolating the ridges.
}
\item{hflag}{
if set to TRUE, uses \eqn{Q_1} as first term in the kernel.
}
\item{check}{
if set to TRUE, computes \code{\link{cwt}} of reconstructed signal.
}
\item{minnbnodes}{
minimum number of nodes for the reconstruction.
}
\item{real}{
if set to TRUE, uses only real constraints on the transform.
}}
\value{
Returns a list containing:
\item{sol}{
  reconstruction from a ridge.
}
\item{A}{
  <wavelets,dualwavelets> matrix.
}
\item{lam}{
  coefficients of dual wavelets in reconstructed signal.
}
\item{dualwave}{
  array containing the dual wavelets.
}
\item{morvelets}{
  array containing the wavelets on sampled ridge.
}
\item{solskel}{
  wavelet transform of sol, restricted to the ridge.
}
\item{inputskel}{
  wavelet transform of signal, restricted to the ridge.
}
\item{Q2}{
  second part of the reconstruction kernel.
}
\item{nbnodes}{
  number of nodes used for the reconstruction.
}}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{regrec2}}, \code{\link{ridrec}}, \code{\link{gregrec}},
\code{\link{gridrec}}.
}
\keyword{ts}

\name{cwtTh}
\alias{cwtTh}
\title{Cauchy's wavelet transform}
\description{
  Compute the continuous wavelet transform with (complex-valued)
  Cauchy's wavelet.
}
\usage{cwtTh(input, noctave, nvoice=1, moments, twoD=TRUE, plot=TRUE)
}
\arguments{
  \item{input}{
    input signal (possibly complex-valued).
  }
  \item{noctave}{
    number of powers of 2 for the scale variable.
  }
  \item{nvoice}{
    number of scales in each octave
    (i.e. between two consecutive powers of 2).
  }
  \item{moments}{
    number of vanishing moments.
  }
  \item{twoD}{
    logical variable set to \code{T} to organize the output as a 2D array
    (signal size x nb scales), otherwise, the output is a 3D array (signal
    size x noctave x nvoice).
  }
  \item{plot}{
    if set to \code{T}, display the modulus of the continuous wavelet
    transform on the graphic device.
}}
\value{
  \item{tmp}{continuous (complex) wavelet transform.}
}
\details{
  The output contains the (complex) values of the wavelet transform of
  the input signal.  The format of the output can be

  2D array (signal size \eqn{\times}{x} nb scales)

  3D array (signal size \eqn{\times}{x} noctave \eqn{\times}{x} nvoice)
}
\references{
  See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
  \code{\link{cwt}}, \code{\link{cwtp}}, \code{\link{DOG}},
  \code{\link{gabor}}.
}
\examples{
    x <- 1:512
    chirp <- sin(2*pi * (x + 0.002 * (x-256)^2 ) / 16)
    retChirp <- cwtTh(chirp, noctave=5, nvoice=12, moments=20)
}
\keyword{ts}

\name{snakoid}
\alias{snakoid}
\title{
Modified Snake Method
}
\description{
Estimate a ridge from a time-frequency representation, using the
modified snake method (modified cost function).
}
\usage{
snakoid(modulus, guessA, guessB, snakesize=length(guessB),
tfspec=numeric(dim(modulus)[2]), subrate=1, temprate=3, muA=1,
muB=muA, lambdaB=2 * muB, lambdaA=2 * muA, iteration=1000000,
seed=-7, costsub=1, stagnant=20000, plot=TRUE)
}
\arguments{
\item{modulus}{
Time-Frequency representation (real valued).
}
\item{guessA}{
Initial guess for the algorithm (frequency variable).
}
\item{guessB}{
Initial guess for the algorithm (time variable).
}
\item{snakesize}{
The length of the first guess of time variable.
}
\item{tfspec}{
Estimate for the contribution of srthe noise to modulus.
}
\item{subrate}{
Subsampling rate for ridge estimation.
}
\item{temprate}{
Initial value of temperature parameter.
}
\item{muA}{
Coefficient of the ridge's derivative in cost function (frequency
component).
}
\item{muB}{
Coefficient of the ridge's derivative in cost function (time
component).
}
\item{lambdaB}{
Coefficient of the ridge's second derivative in cost function
(time component).
}
\item{lambdaA}{
Coefficient of the ridge's second derivative in cost function
(frequency component).
}
\item{iteration}{
Maximal number of moves.
}
\item{seed}{
Initialization of random number generator.
}
\item{costsub}{
Subsampling of cost function in output.
}
\item{stagnant}{
Maximum number of stationary iterations before stopping.
}
\item{plot}{
when set(default), some results will be displayed
}}
\value{
Returns a structure containing:
\item{ridge}{1D array (of same length as the signal) containing the ridge.}
\item{cost}{1D array containing the cost function.}
\item{plot}{when set(default), some results will be displayed.}
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{corona}}, \code{\link{coronoid}}, \code{\link{icm}},
\code{\link{snake}}.
}
\keyword{ts}

\name{wRidgeSampling}
\alias{wRidgeSampling}
\title{
Sampling wavelet Ridge
}
\description{
Given a ridge \eqn{\phi}{phi} (for the wavelet transform), returns a
(appropriately) subsampled version with a given subsampling rate.
}
\usage{
wRidgeSampling(phi, compr, nvoice)
}
\arguments{
\item{phi}{
ridge (1D array).
}
\item{compr}{
subsampling rate for the ridge.
}
\item{nvoice}{
number of voices per octave.
}}
\value{
Returns a list containing the discrete values of the ridge.
\item{node}{time coordinates of the ridge samples.}
\item{phinode}{scale coordinates of the ridge samples.}
\item{nbnode}{number of nodes of the ridge samples.}
}
\details{
To account for the variable sizes of wavelets, the sampling
rate of a wavelet ridge is not uniform, and is proportional
to the scale.
}
%\references{}
\seealso{
\code{\link{RidgeSampling}}.
}
\keyword{ts}

\name{icm}
\alias{icm}
\title{
Ridge Estimation by ICM Method
}
\description{
Estimate a (single) ridge from a time-frequency representation,
using the ICM minimization method.
}
\usage{
icm(modulus, guess, tfspec=numeric(dim(modulus)[2]), subrate=1,
mu=1, lambda=2 * mu, iteration=100)
}
\arguments{
\item{modulus}{
Time-Frequency representation (real valued).
}
\item{guess}{
Initial guess for the algorithm.
}
\item{tfspec}{
Estimate for the contribution of the noise to modulus.
}
\item{subrate}{
Subsampling rate for ridge estimation.
}
\item{mu}{
Coefficient of the ridge's second derivative in cost function.
}
\item{lambda}{
Coefficient of the ridge's derivative in cost function.
}
\item{iteration}{
Maximal number of moves.
}}
\value{
Returns the estimated ridge and the cost function.
\item{ridge}{
  1D array (of same length as the signal) containing the ridge.
}
\item{cost}{
  1D array containing the cost function.
}}
\details{
To accelerate convergence, it is useful to preprocess modulus before
running annealing method. Such a preprocessing (smoothing and
subsampling of modulus) is implemented in \code{\link{icm}}. The
parameter subrate specifies the subsampling rate.
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{corona}}, \code{\link{coronoid}}, and \code{\link{snake}},
\code{\link{snakoid}}.
}
\keyword{ts}

\name{fastkernel}
\alias{fastkernel}
\title{
Kernel for Reconstruction from Wavelet Ridges
}
\description{
Computes the cost from the sample of points on the estimated ridge
and the matrix used in the reconstruction of the original signal,
using simple trapezoidal rule for integrals.
}
\usage{
fastkernel(node, phinode, nvoice, x.inc=1, x.min=node[1],
x.max=node[length(node)], w0=2 * pi, plot=FALSE)
}
\arguments{
\item{node}{
values of the variable b for the nodes of the ridge.
}
\item{phinode}{
values of the scale variable a for the nodes of the ridge.
}
\item{nvoice}{
number of scales within 1 octave.
}
\item{x.inc}{
step unit for the computation of the kernel
}
\item{x.min}{
minimal value of x for the computation of \eqn{Q_2}.
}
\item{x.max}{
maximal value of x for the computation of \eqn{Q_2}.
}
\item{w0}{
central frequency of the wavelet
}
\item{plot}{
if set to TRUE, displays the modulus of the matrix of \eqn{Q_2}.
}}
\value{
matrix of the \eqn{Q_2} kernel.
}
\details{
Uses trapezoidal rule (instead of Romberg's method) to evaluate
the kernel.
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.  
}
\seealso{
\code{\link{kernel}}, \code{\link{rkernel}}, \code{\link{gkernel}},
\code{\link{zerokernel}}.
}
\keyword{ts}

%\keyword{~keyword}
% Converted by Sd2Rd version 1.21.

\name{mrecons}
\alias{mrecons}
\title{
Reconstruct from Dyadic Wavelet Transform Extrema
}
\description{
Reconstruct from dyadic wavelet transform modulus extrema.
The reconstructed signal preserves locations and values at extrema.
}
\usage{
mrecons(extrema, filtername="Gaussian1", readflag=FALSE)
}
\arguments{
\item{extrema}{
the extrema representation. 
}
\item{filtername}{
filter used for dyadic wavelet transform.
}
\item{readflag}{
if set to T, read reconstruction kernel from precomputed file.
}}
\value{
Structure containing
\item{f}{
  the reconstructed signal.
}
\item{g}{
  reconstructed signal plus mean of original signal.
}
\item{h}{
  reconstructed signal plus coarse scale component of original signal.
}}
\details{
The reconstruction involves only the wavelet coefficients,
without taking care of the coarse scale component. The latter
may be added a posteriori.
}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{mw}}, \code{\link{ext}}.
}
\keyword{ts}

\name{vwt}
\alias{vwt}
\title{
 Voice Wavelet Transform
}
\description{
Compute Morlet's wavelet transform at one scale.
}
\usage{
vwt(input, scale, w0=2 * pi)
}
\arguments{
\item{input}{
Input signal (1D array).
}
\item{scale}{
Scale at which the wavelet transform is to be computed.
}
\item{w0}{
Center frequency of the wavelet.
}}
\value{
1D (complex) array containing wavelet transform at one scale.
}
%\details{}
\references{
See discussions in the text of \dQuote{Practical Time-Frequency Analysis}.
}
\seealso{
\code{\link{vgt}}, \code{\link{vDOG}}.
}
\keyword{ts}

\name{hurst.est}
\alias{hurst.est}
\title{
Estimate Hurst Exponent
}
\description{
Estimates Hurst exponent from a wavelet transform.
}
\usage{
hurst.est(wspec, range, nvoice, plot=TRUE)
}
\arguments{
\item{wspec}{
wavelet spectrum (output of \code{\link{tfmean}})
}
\item{range}{
range of scales from which estimate the exponent.
}
\item{nvoice}{
number of scales per octave of the wavelet transform.
}
\item{plot}{
if set to \code{TRUE}, displays regression line on current plot.
}}
\value{
complex 1D array of size sigsize.
}
%\details{}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{tfmean}}, \code{\link{wspec.pl}}.
}
\keyword{ts}
\examples{
# White Noise Hurst Exponent: The plots on the top row of Figure 6.8
# were produced by the folling S-commands. These make use of the two
# functions Hurst.est (estimation of Hurst exponent from CWT) and
# wspec.pl (display wavelet spectrum).

# Compare the periodogram and the wavelet spectral estimate.
wnoise <- rnorm(8192)
plot.ts(wnoise)
spwnoise <- fft(wnoise)
spwnoise <- Mod(spwnoise)
spwnoise <- spwnoise*spwnoise
plot(spwnoise[1:4096], log="xy", type="l")
lswnoise <- lsfit(log10(1:4096), log10(spwnoise[1:4096]))
abline(lswnoise$coef)
cwtwnoise <- DOG(wnoise, 10, 5, 1, plot=FALSE)
mcwtwnoise <- Mod(cwtwnoise)
mcwtwnoise <- mcwtwnoise*mcwtwnoise
wspwnoise <- tfmean(mcwtwnoise, plot=FALSE)
wspec.pl(wspwnoise, 5)
hurst.est(wspwnoise, 1:50, 5)
}

\name{YN}
\alias{YN}
\title{Logarithms of the Prices of Japanese Yen}
\description{Logarithms of the prices of a contract of Japanese yen.
}
\usage{data(YN)
}
\format{A vector containing 500 observations.
}
\source{
  See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\references{
  Carmona, R. A., W. L. Hwang and B Torresani (1998, eBook ISBN:978008053942)
  \emph{Practical Time-Frequency Analysis: Gabor and Wavelet Transforms
    with an Implementation in S}, Academic Press, San Diego.
}
\examples{

data(YN)
plot.ts(YN)

}


\keyword{datasets}

\name{signal_W_tilda.2}
\alias{signal_W_tilda.2}
\title{Pixel from Amber Camara}
\description{Pixel from amber camara.
}
\usage{data(signal_W_tilda.2)
}
\format{A vector containing observations.
}
\source{
  See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\references{
  Carmona, R. A., W. L. Hwang and B Torresani (1998, eBook ISBN:978008053942)
  \emph{Practical Time-Frequency Analysis: Gabor and Wavelet Transforms
    with an Implementation in S}, Academic Press, San Diego.
}
\examples{

data(signal_W_tilda.2)
plot.ts(signal_W_tilda.2)

}
\keyword{datasets}

\name{plotResult}
\alias{plotResult}
\title{
Plot Dyadic Wavelet Transform Extrema
}
\description{
Plot extrema of dyadic wavelet transform.
}
\usage{
plotResult(result, original, maxresoln, scale=FALSE, yaxtype="s")
}
\arguments{
  \item{result}{
    result.
  }
  \item{original}{
    input signal.
  }
  \item{maxresoln}{
    number of decomposition scales.
  }
  \item{scale}{
    when set, the extrema at each scale is plotted withe the same scale.
  }
  \item{yaxtype}{
    y axis type (see \R manual).
  }
}
%\value{}
%\details{}
\references{
  See discussions in the text of ``Time-Frequency Analysis''.
}
\seealso{
  \code{\link{plotwt}}, \code{\link{epl}}, \code{\link{wpl}}.
}
\keyword{ts}

\name{gregrec}
\alias{gregrec}
\title{
Reconstruction from a Ridge
}
\description{
Reconstructs signal from a ``regularly sampled'' ridge, in the Gabor case.
}
\usage{
gregrec(siginput, gtinput, phi, nbnodes, nvoice, freqstep, scale,
epsilon=0, fast=FALSE, plot=FALSE, para=0, hflag=FALSE, real=FALSE,
check=FALSE)
}
\arguments{
\item{siginput}{
input signal.
}
\item{gtinput}{
Gabor transform, output of \code{\link{cgt}}.
}
\item{phi}{
unsampled ridge.
}
\item{nbnodes}{
number of nodes used for the reconstruction.
}
\item{nvoice}{
number of different scales per octave
}
\item{freqstep}{
sampling rate for the frequency axis
}
\item{scale}{
size parameter for the Gabor function.
}
\item{epsilon}{
coefficient of the \eqn{Q_2} term in reconstruction kernel
}
\item{fast}{
if set to T, the kernel is computed using trapezoidal rule.
}
\item{plot}{
if set to TRUE, displays original and reconstructed signals
}
\item{para}{
scale parameter for extrapolating the ridges.
}
\item{hflag}{
if set to TRUE, uses \eqn{Q_1} as first term in the kernel.
}
\item{real}{
if set to TRUE, uses only real constraints on the transform.
}
\item{check}{
if set to TRUE, computes \code{\link{cwt}} of
reconstructed signal.
}}
\value{
Returns a list containing:
\item{sol}{
  reconstruction from a ridge.
}
\item{A}{
  <gaborlets,dualgaborlets> matrix.
}
\item{lam}{
  coefficients of dual wavelets in reconstructed signal.
}
\item{dualwave}{
  array containing the dual wavelets.
}
\item{gaborets}{
  array containing the wavelets on sampled ridge.
}
\item{solskel}{
  Gabor transform of sol, restricted to the ridge.
}
\item{inputskel}{
  Gabor transform of signal, restricted to the ridge.
}
\item{Q2}{
  second part of the reconstruction kernel.
}}
%\details{}
\references{
See discussions in the text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{regrec}}.
}
\keyword{ts}

\name{coronoid}
\alias{coronoid}
\title{
Ridge Estimation by Modified Corona Method
}
\description{
Estimate a ridge using the
modified corona method (modified cost function).
}
\usage{
coronoid(tfrep, guess, tfspec=numeric(dim(tfrep)[2]), subrate=1,
temprate=3, mu=1, lambda=2 * mu, iteration=1000000, seed=-7,
stagnant=20000, costsub=1, plot=TRUE)
}
\arguments{
\item{tfrep}{
Estimate for the contribution of the noise to modulus.
}
\item{guess}{
Initial guess for the algorithm.
}
\item{tfspec}{
Estimate for the contribution of the noise to modulus.
}
\item{subrate}{
Subsampling rate for ridge estimation.
}
\item{temprate}{
Initial value of temperature parameter.
}
\item{mu}{
Coefficient of the ridge's derivative in cost function.
}
\item{lambda}{
Coefficient of the ridge's second derivative in cost function.
}
\item{iteration}{
Maximal number of moves.
}
\item{seed}{
Initialization of random number generator.
}
\item{stagnant}{
Maximum number of stationary iterations before stopping.
}
\item{costsub}{
Subsampling of cost function in output.
}
\item{plot}{
When set(default), some results will be shown on the display.
}}
\value{
Returns the estimated ridge and the cost function.
\item{ridge}{
  1D array (of same length as the signal) containing the ridge.
}
\item{cost}{
  1D array containing the cost function.
}
}
\details{
To accelerate convergence, it is useful to preprocess modulus before
running annealing method. Such a preprocessing (smoothing and
subsampling of modulus) is implemented in \code{\link{coronoid}}. The
parameter subrate specifies the subsampling rate.
}
\references{
See discussion in text of ``Practical Time-Frequency Analysis''.
}
\seealso{
\code{\link{corona}}, \code{\link{icm}}, \code{\link{snake}}, \code{\link{snakoid}}.
}
\keyword{ts}
\section{Warning}{
The returned cost may be a large array.
The argument costsub allows subsampling the cost function.
}

\name{cfamily}
\alias{cfamily}
\title{
Ridge Chaining Procedure
}
\description{
Chains the ridge estimates produced by the function \code{\link{crc}}.
}
\usage{
cfamily(ccridge, bstep=1, nbchain=100, ptile=0.05)
}
\arguments{
\item{ccridge}{
unchained ridge set as the output of the function \code{\link{crc}}
}
\item{bstep}{
maximal length for a gap in a ridge.
}
\item{nbchain}{
maximal number of chains produced by the function.
}
\item{ptile}{
relative threshold for the ridges.
}}
\value{
  Returns the results of the chaining algorithm
  \item{ordered map}{
    image containing the ridges (displayed with different colors)
  }
  \item{chain}{
    2D array containing the chained ridges, according to the chain data
    structure\cr
    chain[,1]: first point of the ridge\cr
    chain[,2]: length of the chain\cr
    chain[,3:(chain[,2]+2)]: values of the ridge\cr
  }
  \item{nbchain}{
    number of chains produced by the algorithm
}}
\details{
  \code{\link{crc}} returns a measure in time-frequency (or time-scale)
  space. \code{\link{cfamily}} turns it into a series of one-dimensional
  objects (ridges). The measure is first thresholded, with a relative
  threshold value set to the input parameter ptile. During the chaining
  procedure, gaps within a given ridge are allowed and filled in. The
  maximal length of such gaps is the input parameter bstep.
}
\references{
  See discussion in text of ``Practical Time-Frequency Analysis''.
}
\seealso{
  \code{\link{crc}} for the ridge estimation, and \code{\link{crcrec}},
  \code{\link{gcrcrec}} and \code{\link{scrcrec}} for corresponding
  reconstruction functions.
}
\examples{

\dontrun{
   data(HOWAREYOU)
 plot.ts(HOWAREYOU)
 
cgtHOWAREYOU <- cgt(HOWAREYOU,70,0.01,100)

clHOWAREYOU <- crc(Mod(cgtHOWAREYOU),nbclimb=1000)

cfHOWAREYOU <- cfamily(clHOWAREYOU,ptile=0.001)
image(cfHOWAREYOU$ordered > 0)
}
}

\keyword{ts}
